// Edit from veronica
// Resident Evil/Biohazard: Code: Veronica Auto Splitter
// By Kapdap 2020/07/16
// https://github.com/kapdap/re-cvx-autosplitter

state("pcsx2") {}

startup
{
	refreshRate = 30;

    // Split tracker
    vars.splits = new Dictionary<string, bool>();

    // Inventory split tracker
    vars.itemSplits = new Dictionary<byte, bool>();
    vars.itemIndex = new Dictionary<byte, string>();

    // Adds a split
    vars.AddSplit = (Action<string, bool, string, string>)((id, default_value, description, parent) => {
        vars.splits.Add(id, false);
        settings.Add(id, default_value, description, parent);
    });

    // Adds an inventory split
    vars.AddItemSplit = (Action<byte, string, bool, string, string>)((code, id, default_value, description, parent) => {
        vars.itemSplits.Add(code, false);
        vars.itemIndex.Add(code, id);  // Map item code to split name
        settings.Add(id, default_value, description, parent);
    });

    // Resets split tracker
    vars.ResetSplits = (Action) (() => {
        List<string> keys = new List<string>(vars.splits.Keys);
        foreach(string key in keys)
            vars.splits[key] = false;
    });

    // Resets inventory split tracker
    vars.ResetItemSplits = (Action) (() => {
        List<byte> keys = new List<byte>(vars.itemSplits.Keys);
        foreach(byte key in keys)
            vars.itemSplits[key] = false;
    });

    // Swaps 2 byte values
    vars.SwapBytes = (Func<ushort, ushort>)((value) => {
        int b1 = (value >> 0) & 0xff;
        int b2 = (value >> 8) & 0xff;

        return (ushort) (b1 << 8 | b2 << 0);
    });

    // Swaps 4 byte values
    vars.SwapBytesInt = (Func<uint, uint>)((value) => {
        return ((value & 0x000000ff) << 24) +
            ((value & 0x0000ff00) << 8) +
            ((value & 0x00ff0000) >> 8) +
            ((value & 0xff000000) >> 24);
    });

        settings.Add("events", true, "Events");
    vars.AddSplit("endGame", true, "End Game", "events");
    settings.SetToolTip("endGame", "Splits when the game rank screen displays");

    vars.AddSplit("one", true, "Entrance Hall", "events");
    settings.SetToolTip("one", "Splits when the leaving the 1st room");

    vars.AddSplit("two", true, "Student Affairs Office", "events");
    settings.SetToolTip("two", "Splits when the leaving the 2nd room");

    vars.AddSplit("three", true, "General Manager's Room", "events");
    settings.SetToolTip("three", "Splits when the leaving the 3rd room");

    vars.AddSplit("four", true, "Student Affairs Office", "events");
    settings.SetToolTip("four", "Splits when the leaving the 4th room");

    vars.AddSplit("five", true, "Entrance Hall", "events");
    settings.SetToolTip("five", "Splits when the leaving the 5th room");

    vars.AddSplit("six", true, "2F Hallway", "events");
    settings.SetToolTip("six", "Splits when the leaving the 6th room");

    vars.AddSplit("seven", true, "Drawing Room", "events");
    settings.SetToolTip("seven", "Splits when the leaving the 7th room");

    vars.AddSplit("eight", true, "President's Room", "events");
    settings.SetToolTip("eight", "Splits when the leaving the 8th room");

    vars.AddSplit("nine", true, "Drawing Room", "events");
    settings.SetToolTip("nine", "Splits when the leaving the 9th room");

    vars.AddSplit("ten", true, "2F Hallway", "events");
    settings.SetToolTip("ten", "Splits when the leaving the 10th room");

    vars.AddSplit("eleven", true, "Art Safe Room", "events");
    settings.SetToolTip("eleven", "Splits when the leaving the 11th room");

    vars.AddSplit("twelve", true, "2F Hallway", "events");
    settings.SetToolTip("twelve", "Splits when the leaving the 12th room");

    vars.AddSplit("thirteen", true, "Entrance Hall", "events");
    settings.SetToolTip("thirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("fourteen", true, "Secret Room", "events");
    settings.SetToolTip("fourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("fifteen", true, "Entrance Hall", "events");
    settings.SetToolTip("fifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("sixteen", true, "Elevator Passage 1F", "events");
    settings.SetToolTip("sixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("seventeen", true, "Elevator Passage B4F", "events");
    settings.SetToolTip("seventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("eighteen", true, "Access Waterway", "events");
    settings.SetToolTip("eighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("nineteen", true, "Old Subway Rail Siding", "events");
    settings.SetToolTip("nineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("twenty", true, "Old Subway Tunnel", "events");
    settings.SetToolTip("twenty", "Splits when the leaving the 20th room");

    vars.AddSplit("twentyOne", true, "T-Shaped Passage", "events");
    settings.SetToolTip("twentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("twentyTwo", true, "Store Room", "events");
    settings.SetToolTip("twentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("twentyThree", true, "Power Room", "events");
    settings.SetToolTip("twentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("twentyFour", true, "Store Room", "events");
    settings.SetToolTip("twentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("twentyFive", true, "T-Shaped Passage", "events");
    settings.SetToolTip("twentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("twentySix", true, "Tower Access Way", "events");
    settings.SetToolTip("twentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("twentySeven", true, "Tower Lower Part", "events");
    settings.SetToolTip("twentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("twentyEight", true, "Tower Elevator", "events");
    settings.SetToolTip("twentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("twentyNine", true, "Tower Upper Part", "events");
    settings.SetToolTip("twentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("thirty", true, "Tower Station", "events");
    settings.SetToolTip("thirty", "Splits when the leaving the 30th room");

    vars.AddSplit("thirtyOne", true, "Back Square", "events");
    settings.SetToolTip("thirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("thirtyTwo", true, "1F Passage B", "events");
    settings.SetToolTip("thirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("thirtyThree", true, "Entrance Hall", "events");
    settings.SetToolTip("thirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("thirtyFour", true, "T-Blood", "events");
    settings.SetToolTip("thirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("thirtyFive", true, "Entrance Hall", "events");
    settings.SetToolTip("thirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("thirtySix", true, "Elevator Passage 1F", "events");
    settings.SetToolTip("thirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("thirtySeven", true, "Elevator Passage 3F", "events");
    settings.SetToolTip("thirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("thirtyEight", true, "Experiment Prep Room", "events");
    settings.SetToolTip("thirtyEight", "Splits when the leaving the 38th room");

    vars.AddSplit("thirtyNine", true, "Experiment Room", "events");
    settings.SetToolTip("thirtyNine", "Splits when the leaving the 39th room");

    vars.AddSplit("forty", true, "Machine Storage Room", "events");
    settings.SetToolTip("forty", "Splits when the leaving the 40th room");

    vars.AddSplit("fortyOne", true, "Bomb Sequence", "events");
    settings.SetToolTip("fortyOne", "Splits when the leaving the 41st room");

    vars.AddSplit("fortyTwo", true, "Back Square", "events");
    settings.SetToolTip("fortyTwo", "Splits when the leaving the 42nd room");

    vars.AddSplit("fortyThree", true, "Unloading Passage", "events");
    settings.SetToolTip("fortyThree", "Splits when the leaving the 43rd room");

    vars.AddSplit("fortyFour", true, "South Car", "events");
    settings.SetToolTip("fortyFour", "Splits when the leaving the South Car");


    vars.AddSplit("fortySix", true, "Old Subway Tunnel", "events");
    settings.SetToolTip("fortySix", "Splits when the leaving the Tunnel");

    vars.AddSplit("fortySeven", true, "Elevator Passage B2F", "events");
    settings.SetToolTip("fortySeven", "Splits when the leaving the Tunnel");

    vars.AddSplit("fortyEight", true, "Pier", "events");
    settings.SetToolTip("fortyEight", "Splits when the leaving the Pier");

    vars.AddSplit("fortyNine", true, "Elevator Passage B2F", "events");
    settings.SetToolTip("fortyNine", "Splits when the leaving the B2F Passage w/ card key");

}

init
{
    vars.lastRoom = String.Empty;
    vars.lastSplit = String.Empty; // Name of the most recent split
    vars.gameProcess = String.Empty; // Used to detect when the process has changed
    vars.productCode = String.Empty; // Used to detect when the game release has changed
    vars.basePointer = IntPtr.Zero; // Emulator virtual memory base pointer
    vars.isBigEndian = false; // Console uses big endian (e.g. PS3 and GCN)

    vars.LogRoom = (Action<string>)((text) => {
        vars.lastRoom = text;

        string log = timer.CurrentTime[timer.CurrentTimingMethod] + ": " + text;

        if (settings["logSplits"])
            File.AppendAllText(vars.logPath, log + System.Environment.NewLine);

        if (settings["debugSplits"])
            print("recvx split: " + log);
    });


    // Log splits
    vars.LogSplit = (Action<string>)((text) => {
        vars.lastSplit = text;

        string log = timer.CurrentTime[timer.CurrentTimingMethod] + ": " + text;

        if (settings["logSplits"])
            File.AppendAllText(vars.logPath, log + System.Environment.NewLine);

        if (settings["debugSplits"])
            print("recvx split: " + log);
    });

    // Update split status
    vars.UpdateSplit = (Func<string, bool>)((split) => {
        if (!vars.splits[split])
        {
            vars.LogSplit(split);
            vars.splits[split] = true;
            return settings[split];
        }
        else
            return false;
    });

    // Update item split status
    vars.UpdateItemSplit = (Func<byte, bool>)((id) => {
        if (!vars.itemSplits[id])
        {
            vars.LogSplit(vars.itemIndex[id] + " (" + id.ToString() + ")");
            vars.itemSplits[id] = true;
            return settings[vars.itemIndex[id]];
        }
        else
            return false;
    });

    // Sets memory pointers for the detected game release
    vars.UpdatePointers = (Action) (() => {
        switch ((string)vars.productCode)
        {
            default: // SLPM_654.28 [PS2] [JP] Biohazard: outbreak f1
                vars.timePtr = 0x0048BF78;
				vars.scenarioPtr = 0x003065AA;
                vars.roomPtr = 0x00476FB2;
                vars.screenPtr = 0x0048BF60;
				vars.winPtr = 0x0048C006;
                vars.healthPtr = 0x00477314;
                vars.statusPtr = 0x00477970;
                vars.pausePtr = 0x0048C024;
                vars.characterPtr = 0x00477968;
                vars.inventoryPtr = 0x00477A54;
                vars.moveablePtr = 0x004779A0;
                vars.bosshpPtr = 0x0071AA6C;
		vars.storedoorhpPtr = 0x00473A70;
		vars.lockerhpPtr = 0x00473D32;
                break;
        }
    });
	
    // Detects if the process has changed
    vars.UpdateProcess = (Action) (() => {
        // Update process name if application has changed
        if (vars.gameProcess != game.ProcessName)
        {
            vars.gameProcess = game.ProcessName;

            // Set emulator edianess
            switch ((string)vars.gameProcess.ToLower())
            {
                default: //pcsx2
                    vars.isBigEndian = false;
                    break;
            }
        }
    });

    // Set emulator base pointer
    vars.UpdatePointer = (Action) (() => {
        switch ((string)vars.gameProcess.ToLower())
        {
            default: // pcsx2
                vars.basePointer = 0x20000000;
                break;
        }
    });

    // Detects if the game release has changed
    vars.UpdateProduct = (Action) (() => {
        string productCode;

        // Read game product code from memory
        switch ((string)vars.gameProcess.ToLower())
        {
            default: //pcsx2
                productCode = memory.ReadString(new IntPtr(vars.basePointer + 0x00015B90), 11);
                break;
        }

        // Update product code if the game release has changed
        if (vars.productCode != productCode)
        {
            vars.productCode = productCode;
            vars.UpdatePointers();
        }
    });

    // Updates game values
    vars.UpdateValues = (Action) (() => {
        uint time = 0; // In Game Timer
        ushort scenario = 0; // Scenario ID
        byte room = 0; // Room the character is in
        byte screen = 0; // Current game screen (04 playing movie)
        ushort win = 0; // win result (0x0001 win, 0x0101 fail)
        uint health = 0; // Character health
        byte status = 0; // Character status info (0=OK, 1=Poison, 2=Bleed, 4=Cleared)
        byte pause = 0; // pause status info (0=off, 1=pause)
        byte character = 0; // Character ID
        byte moveable = 0; // When character can move (0=able, 1=unable)
        ushort bosshp = 0; // bosshp
	ushort storedoorhp = 0; //storage room door hp
	ushort lockerhp = 0; //locker hp

        // Read values from memory
        memory.ReadValue<uint>(new IntPtr(vars.basePointer + vars.timePtr), out time);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.scenarioPtr), out scenario);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.roomPtr), out room);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.screenPtr), out screen);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.winPtr), out win);
        memory.ReadValue<uint>(new IntPtr(vars.basePointer + vars.healthPtr), out health);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.statusPtr), out status);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.pausePtr), out pause);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.characterPtr), out character);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.moveablePtr), out moveable);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.bosshpPtr), out bosshp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.storedoorhpPtr), out storedoorhp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.lockerhpPtr), out lockerhp);

        current.slot = 0; // Inventory slot number of the equipped item
        current.ammo = 0; // Ammo count for the equipped weapon
        current.time = vars.isBigEndian ? (int)vars.SwapBytesInt(time) : (int)time;
        current.scenario = scenario;
        current.room = room;
        current.screen = screen;
        current.win = win;
        current.health = vars.isBigEndian ? (int)vars.SwapBytesInt(health) : (int)health;
        current.status = status;
        current.character = character;
        current.inventory = new byte[8]; // Current characters inventory
		current.moveable = moveable;
		current.bosshp = bosshp;
		current.storedoorhp = storedoorhp;
		current.lockerhp = lockerhp;

        int index = -1; // Inventory array index


	if (storedoorhp <= 500)
		current.storedoorhp = "Unlocked";
	if (lockerhp <= 500)
		current.lockerhp = "Destroyed";


        // Pointer to the current characters inventory table
        IntPtr pointer = new IntPtr(vars.basePointer + vars.inventoryPtr);

        // Read inventory of the current character
        for (int i = 0; i < 8; ++i)
        {
            byte item = 0; // Inventory entry

            // Read inventory entry from memory
            memory.ReadValue<byte>(pointer, out item);

            // Move pointer to the next entry
            pointer = IntPtr.Add(pointer, 0x1);

            // First entry is the slot number of the equipped item
            if (i == -1)
            {
                //current.slot = item;
                continue;
            }

            // Set inventory index to the item ID
            current.inventory[++index] = item;
        }
    });

    // Initialise values
    vars.UpdateProcess();
    vars.UpdatePointer();
    vars.UpdateProduct();
    vars.UpdateValues();
}

start
{
    // Start when IGT is 0, in the Prison Cell room and the 1st item slot contains the Lighter
    return (current.time > 0);
}

update
{
    vars.UpdateProcess();
    vars.UpdatePointer();
    vars.UpdateProduct();
    vars.UpdateValues();

    if (timer.CurrentPhase == TimerPhase.NotRunning)
    {
        vars.ResetSplits();
        vars.ResetItemSplits();
    }
}

split
{
    // Split when an inventory entry changes
    for (int i = 0; i < current.inventory.Length; i++)
    {
        byte item = current.inventory[i];

        // Continue if the entry has not changed
        if (item == old.inventory[i]) continue;

        switch (item)
        {
            default: // Split the first time an item is added to the inventory
                if (vars.itemSplits.ContainsKey(item))
                    return vars.UpdateItemSplit(item);
                break;
        }
    }

    if (current.room == 81 && vars.lastSplit == "two" && old.room == 82)
        return vars.UpdateSplit("three");

    if (current.room == 81 && old.room == 80)
        return vars.UpdateSplit("one");

    if (current.room == 82 && vars.lastSplit == "one")
        return vars.UpdateSplit("two");


    if (current.room == 80 && vars.lastSplit == "three")
        return vars.UpdateSplit("four");

    if (current.room == 89 && vars.lastSplit == "four")
        return vars.UpdateSplit("five");

    if (current.room == 88 && vars.lastSplit == "five")
        return vars.UpdateSplit("six");

    if (current.room == 87 && vars.lastSplit == "six")
        return vars.UpdateSplit("seven");

    if (current.room == 88 && vars.lastSplit == "seven")
        return vars.UpdateSplit("eight");

    if (current.room == 89 && vars.lastSplit == "eight")
        return vars.UpdateSplit("nine");

    if (current.room == 91 && vars.lastSplit == "nine")
        return vars.UpdateSplit("ten");

    if (current.room == 89 && vars.lastSplit == "ten")
        return vars.UpdateSplit("eleven");

    if (current.room == 80 && old.room == 89 && vars.lastSplit == "eleven")
        return vars.UpdateSplit("twelve");

    if (current.room == 77 && vars.lastSplit == "twelve")
        return vars.UpdateSplit("thirteen");

    if (current.room == 80 && old.room == 77 && vars.lastSplit == "thirteen")
        return vars.UpdateSplit("fourteen");

    if (current.room == 78 && vars.lastSplit == "fourteen")
        return vars.UpdateSplit("fifteen");

    if (current.room == 76 && vars.lastSplit == "fifteen")
        return vars.UpdateSplit("sixteen");

    if (current.room == 37 && vars.lastSplit == "fortyNine")
        return vars.UpdateSplit("seventeen");

    if (current.room == 38 && vars.lastSplit == "seventeen")
        return vars.UpdateSplit("eighteen");

    if (current.room == 50 && vars.lastSplit == "eighteen")
        return vars.UpdateSplit("nineteen");

    if (current.room == 51 && vars.lastSplit == "nineteen")
        return vars.UpdateSplit("twenty");

    if (current.room == 58 && vars.lastSplit == "fortySix")
        return vars.UpdateSplit("twentyOne");

    if (current.room == 57 && vars.lastSplit == "twentyOne")
        return vars.UpdateSplit("twentyTwo");

    if (current.room == 58 && vars.lastSplit == "twentyTwo")
        return vars.UpdateSplit("twentyThree");

    if (current.room == 54 && vars.lastSplit == "twentyThree")
        return vars.UpdateSplit("twentyFour");

    if (current.room == 60 && vars.lastSplit == "twentyFour")
        return vars.UpdateSplit("twentyFive");

    if (current.room == 61 && vars.lastSplit == "twentyFive")
        return vars.UpdateSplit("twentySix");

    if (current.room == 62 && vars.lastSplit == "twentySix")
        return vars.UpdateSplit("twentySeven");

    if (current.room == 63 && vars.lastSplit == "twentySeven")
        return vars.UpdateSplit("twentyEight");

    if (current.room == 65 && vars.lastSplit == "twentyEight")
        return vars.UpdateSplit("twentyNine");

    if (current.room == 70 && vars.lastSplit == "twentyNine")
        return vars.UpdateSplit("thirty");

    if (current.room == 85 && vars.lastSplit == "thirty")
        return vars.UpdateSplit("thirtyOne");

    if (current.room == 80 && old.room == 85 && vars.lastSplit == "thirtyOne")
        return vars.UpdateSplit("thirtyTwo");

    if (current.room == 85 && vars.lastSplit == "thirtyTwo")
        return vars.UpdateSplit("thirtyThree");

    if (current.room == 80 && old.room == 85 && vars.lastSplit == "thirtyThree")
        return vars.UpdateSplit("thirtyFour");

    if (current.room == 78 && vars.lastSplit == "thirtyFour")
        return vars.UpdateSplit("thirtyFive");

    if (current.room == 94 && vars.lastSplit == "thirtyFive")
        return vars.UpdateSplit("thirtySix");

    if (current.room == 95 && vars.lastSplit == "thirtySix")
        return vars.UpdateSplit("thirtySeven");

    if (current.room == 96 && vars.lastSplit == "thirtySeven")
        return vars.UpdateSplit("thirtyEight");

    if (current.room == 97 && vars.lastSplit == "thirtyEight")
        return vars.UpdateSplit("thirtyNine");

    if (current.room == 98 && vars.lastSplit == "thirtyNine")
        return vars.UpdateSplit("forty");

    if (current.room == 70 && current.screen == 0x04 && vars.lastSplit == "forty")
        return vars.UpdateSplit("fortyOne");

    if (current.room == 72 && vars.lastSplit == "fortyOne")
        return vars.UpdateSplit("fortyTwo");

    if (current.room == 74 && vars.lastSplit == "fortyTwo")
        return vars.UpdateSplit("fortyThree");



    if (current.room == 50 && old.room == 51)
        return vars.UpdateSplit("fortyFour");

    if (current.room == 54 && vars.lastSplit == "fortyFour")
        return vars.UpdateSplit("fortySix");

    if (current.room == 71 && old.room == 76)
        return vars.UpdateSplit("fortySeven");

    if (current.room == 76 && old.room == 71 && vars.lastSplit == "fortySeven")
        return vars.UpdateSplit("fortyEight");

    if (current.room == 36 && old.room == 76)
        return vars.UpdateSplit("fortyNine");


	if (current.status == 0x04) // End Game Rank Screen
    return vars.UpdateSplit("endGame");

}

reset
{
    if (current.scenario == 0xffff)
    {
        return true;
    }
}

gameTime
{
    // Seconds = IGT / 60
    return TimeSpan.FromSeconds(current.time / 0.03 / 1000);
}

isLoading
{
    return true;
}