// Edit from veronica
// Resident Evil/Biohazard: Code: Veronica Auto Splitter
// By Kapdap 2020/07/16
// https://github.com/kapdap/re-cvx-autosplitter

state("pcsx2") {}

startup
{
	refreshRate = 30;

    // Split tracker
    vars.splits = new Dictionary<string, bool>();

    // Inventory split tracker
    vars.itemSplits = new Dictionary<byte, bool>();
    vars.itemIndex = new Dictionary<byte, string>();

    // Adds a split
    vars.AddSplit = (Action<string, bool, string, string>)((id, default_value, description, parent) => {
        vars.splits.Add(id, false);
        settings.Add(id, default_value, description, parent);
    });

    // Adds an inventory split
    vars.AddItemSplit = (Action<byte, string, bool, string, string>)((code, id, default_value, description, parent) => {
        vars.itemSplits.Add(code, false);
        vars.itemIndex.Add(code, id);  // Map item code to split name
        settings.Add(id, default_value, description, parent);
    });

    // Resets split tracker
    vars.ResetSplits = (Action) (() => {
        List<string> keys = new List<string>(vars.splits.Keys);
        foreach(string key in keys)
            vars.splits[key] = false;
    });

    // Resets inventory split tracker
    vars.ResetItemSplits = (Action) (() => {
        List<byte> keys = new List<byte>(vars.itemSplits.Keys);
        foreach(byte key in keys)
            vars.itemSplits[key] = false;
    });

    // Swaps 2 byte values
    vars.SwapBytes = (Func<ushort, ushort>)((value) => {
        int b1 = (value >> 0) & 0xff;
        int b2 = (value >> 8) & 0xff;

        return (ushort) (b1 << 8 | b2 << 0);
    });

    // Swaps 4 byte values
    vars.SwapBytesInt = (Func<uint, uint>)((value) => {
        return ((value & 0x000000ff) << 24) +
            ((value & 0x0000ff00) << 8) +
            ((value & 0x00ff0000) >> 8) +
            ((value & 0xff000000) >> 24);
    });

        settings.Add("events", true, "Events");


    vars.AddSplit("obhone", true, "Bar", "events");
    settings.SetToolTip("obhone", "Splits when the leaving the 1st room");

    vars.AddSplit("obhtwo", true, "Stairs 1", "events");
    settings.SetToolTip("obhtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("obhthree", true, "Staff Room", "events");
    settings.SetToolTip("obhthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("obhfour", true, "Liqour Room", "events");
    settings.SetToolTip("obhfour", "Splits when the leaving the 4th room");


    vars.AddSplit("obhseven", true, "Roof Stairs", "events");
    settings.SetToolTip("obhseven", "Splits when the leaving the 7th room");

    vars.AddSplit("eight", true, "Rooftop", "events");
    settings.SetToolTip("eight", "Splits when the leaving the 8th room");

    vars.AddSplit("obhnine", true, "Apartment 3F", "events");
    settings.SetToolTip("obhnine", "Splits when the leaving the 9th room");

    vars.AddSplit("obhten", true, "Apartment 1F", "events");
    settings.SetToolTip("obhten", "Splits when the leaving the 10th room");

    vars.AddSplit("obheleven", true, "Outside CaRNG", "events");
    settings.SetToolTip("obheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("obhtwelve", true, "Back Alley", "events");
    settings.SetToolTip("obhtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("obhthirteen", true, "Big Boom Room", "events");
    settings.SetToolTip("obhthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("obhfourteen", true, "Tunnel", "events");
    settings.SetToolTip("obhfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("obhfifteen", true, "Outside Apple Inn", "events");
    settings.SetToolTip("obhfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("obhsixteen", true, "Van Room", "events");
    settings.SetToolTip("obhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("obhseventeen", true, "Footbridge", "events");
    settings.SetToolTip("obhseventeen", "Splits when the leaving the 17th room");


    vars.AddSplit("obnone", true, "Bar", "events");
    settings.SetToolTip("obnone", "Splits when the leaving the 1st room");

    vars.AddSplit("obntwo", true, "Stairs 1", "events");
    settings.SetToolTip("obntwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("obnthree", true, "Staff Room", "events");
    settings.SetToolTip("obnthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("obnfour", true, "Liqour Room", "events");
    settings.SetToolTip("obnfour", "Splits when the leaving the 4th room");

    vars.AddSplit("obnfive", true, "Wine Room", "events");
    settings.SetToolTip("obnfive", "Splits when the leaving the 5th room");

    vars.AddSplit("obnsix", true, "Liqour Room", "events");
    settings.SetToolTip("obnsix", "Splits when the leaving the 6th room");

    vars.AddSplit("obnseven", true, "Roof Stairs", "events");
    settings.SetToolTip("obnseven", "Splits when the leaving the 7th room");

    vars.AddSplit("obneight", true, "Rooftop", "events");
    settings.SetToolTip("obneight", "Splits when the leaving the 8th room");

    vars.AddSplit("obnnine", true, "Apartment 3F", "events");
    settings.SetToolTip("obnnine", "Splits when the leaving the 9th room");

    vars.AddSplit("obnten", true, "Apartment 1F", "events");
    settings.SetToolTip("obnten", "Splits when the leaving the 10th room");

    vars.AddSplit("obneleven", true, "Outside CaRNG", "events");
    settings.SetToolTip("obneleven", "Splits when the leaving the 11th room");

    vars.AddSplit("obntwelve", true, "Back Alley", "events");
    settings.SetToolTip("obntwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("obnthirteen", true, "Big Boom Room", "events");
    settings.SetToolTip("obnthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("obnfourteen", true, "Tunnel", "events");
    settings.SetToolTip("obnfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("obnfifteen", true, "Outside Apple Inn", "events");
    settings.SetToolTip("obnfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("obnsixteen", true, "Van Room", "events");
    settings.SetToolTip("obnsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("obnseventeen", true, "Footbridge", "events");
    settings.SetToolTip("obnseventeen", "Splits when the leaving the 17th room");





    vars.AddSplit("bfpone", true, "Underground Tunnel", "events");
    settings.SetToolTip("bfpone", "Splits when the leaving the 1st room");

    vars.AddSplit("bfptwo", true, "Platform", "events");
    settings.SetToolTip("bfptwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("bfpthree", true, "Lift", "events");
    settings.SetToolTip("bfpthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("bfpfour", true, "B7F East Passway", "events");
    settings.SetToolTip("bfpfour", "Splits when the leaving the 4th room");

    vars.AddSplit("bfpfive", true, "B7F Chemical Storage", "events");
    settings.SetToolTip("bfpfive", "Splits when the leaving the 5th room");

    vars.AddSplit("bfpsix", true, "B7F East Passway", "events");
    settings.SetToolTip("bfpsix", "Splits when the leaving the 6th room");

    vars.AddSplit("bfpseven", true, "B7F Experiments Room", "events");
    settings.SetToolTip("bfpseven", "Splits when the leaving the 7th room");

    vars.AddSplit("bfpeight", true, "B7F South Passway", "events");
    settings.SetToolTip("bfpeight", "Splits when the leaving the 8th room");

    vars.AddSplit("bfpnine", true, "B7F Chemical Disp. Room", "events");
    settings.SetToolTip("bfpnine", "Splits when the leaving the 9th room");

    vars.AddSplit("bfpten", true, "B7F South Passway", "events");
    settings.SetToolTip("bfpten", "Splits when the leaving the 10th room");

    vars.AddSplit("bfpeleven", true, "Duct", "events");
    settings.SetToolTip("bfpeleven", "Splits when the leaving the 11th room");

    vars.AddSplit("bfptwelve", true, "B6F South Passway", "events");
    settings.SetToolTip("bfptwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("bfpthirteen", true, "B6F Security Office", "events");
    settings.SetToolTip("bfpthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("bfpfourteen", true, "B6F South Passway", "events");
    settings.SetToolTip("bfpfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("bfpfifteen", true, "Duct", "events");
    settings.SetToolTip("bfpfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("bfpsixteen", true, "B4F West Passway", "events");
    settings.SetToolTip("bfpsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("bfpseventeen", true, "Main Shaft", "events");
    settings.SetToolTip("bfpseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("bfpeighteen", true, "B4F East Passway", "events");
    settings.SetToolTip("bfpeighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("bfpnineteen", true, "B4F Culture Room", "events");
    settings.SetToolTip("bfpnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("bfptwenty", true, "B4F East Passway", "events");
    settings.SetToolTip("bfptwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("bfptwentyOne", true, "B4F Low Temp. Room", "events");
    settings.SetToolTip("bfptwentyOne", "Splits when the leaving the 21st room");




    vars.AddSplit("bfptwentyFour", true, "Turn Table Up", "events");
    settings.SetToolTip("bfptwentyFour", "Splits when the Turn Table Cutscene Plays");






    vars.AddSplit("hiveone", true, "Room 301", "events");
    settings.SetToolTip("hiveone", "Splits when the leaving the 1st room");

    vars.AddSplit("hivetwo", true, "3F Passway", "events");
    settings.SetToolTip("hivetwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("hivethree", true, "Room 302", "events");
    settings.SetToolTip("hivethree", "Splits when the leaving the 3rd room");

    vars.AddSplit("hivefour", true, "3F Passway", "events");
    settings.SetToolTip("hivefour", "Splits when the leaving the 4th room");

    vars.AddSplit("hivefive", true, "Nurse's Center", "events");
    settings.SetToolTip("hivefive", "Splits when the leaving the 5th room");

    vars.AddSplit("hivesix", true, "3F Passway", "events");
    settings.SetToolTip("hivesix", "Splits when the leaving the 6th room");

    vars.AddSplit("hiveseven", true, "2F Passway", "events");
    settings.SetToolTip("hiveseven", "Splits when the leaving the 7th room");

    vars.AddSplit("hiveeight", true, "1F Passway", "events");
    settings.SetToolTip("hiveeight", "Splits when the leaving the 8th room");

    vars.AddSplit("hivenine", true, "Locker Room", "events");
    settings.SetToolTip("hivenine", "Splits when the leaving the 9th room");

    vars.AddSplit("hiveten", true, "Examination Room", "events");
    settings.SetToolTip("hiveten", "Splits when the leaving the 10th room");

    vars.AddSplit("hiveeleven", true, "Locker Room", "events");
    settings.SetToolTip("hiveeleven", "Splits when the leaving the 11th room");

    vars.AddSplit("hivetwelve", true, "1F Passway", "events");
    settings.SetToolTip("hivetwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("hivethirteen", true, "2F Passway", "events");
    settings.SetToolTip("hivethirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("hivefourteen", true, "B1F Passway", "events");
    settings.SetToolTip("hivefourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("hivefifteen", true, "B1F South Passway", "events");
    settings.SetToolTip("hivefifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("hivesixteen", true, "Waste Liquid Disp.", "events");
    settings.SetToolTip("hivesixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("hiveseventeen", true, "B1F South Passway", "events");
    settings.SetToolTip("hiveseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("hiveeighteen", true, "B1F Passway", "events");
    settings.SetToolTip("hiveeighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("hivenineteen", true, "Elevator Control Room", "events");
    settings.SetToolTip("hivenineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("hivetwenty", true, "B1F Passway", "events");
    settings.SetToolTip("hivetwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("hivetwentyOne", true, "B2F Passway", "events");
    settings.SetToolTip("hivetwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("hivetwentyTwo", true, "Experiment Room", "events");
    settings.SetToolTip("hivetwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("hivetwentyThree", true, "Fixed Temperature Exp. Room", "events");
    settings.SetToolTip("hivetwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("hivetwentyFour", true, "Experiment Room", "events");
    settings.SetToolTip("hivetwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("hivetwentyFive", true, "B2F Passway", "events");
    settings.SetToolTip("hivetwentyFive", "Splits when the leaving the 25th room");





    vars.AddSplit("hfone", true, "Apple Inn Square", "events");
    settings.SetToolTip("hfone", "Splits when the leaving the 1st room");

    vars.AddSplit("hftwo", true, "Boiler Room", "events");
    settings.SetToolTip("hftwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("hfthree", true, "Apple Inn Square", "events");
    settings.SetToolTip("hfthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("hffour", true, "Corridor", "events");
    settings.SetToolTip("hffour", "Splits when the leaving the 4th room");

    vars.AddSplit("hffive", true, "Room 104", "events");
    settings.SetToolTip("hffive", "Splits when the leaving the 5th room");

    vars.AddSplit("hfsix", true, "Corridor", "events");
    settings.SetToolTip("hfsix", "Splits when the leaving the 6th room");

    vars.AddSplit("hfseven", true, "Room 204", "events");
    settings.SetToolTip("hfseven", "Splits when the leaving the 7th room");

    vars.AddSplit("hfeight", true, "Corridor", "events");
    settings.SetToolTip("hfeight", "Splits when the leaving the 8th room");

    vars.AddSplit("hfnine", true, "Security Room", "events");
    settings.SetToolTip("hfnine", "Splits when the leaving the 9th room");

    vars.AddSplit("hften", true, "Northwest Passage 2", "events");
    settings.SetToolTip("hften", "Splits when the leaving the 10th room");

    vars.AddSplit("hfeleven", true, "Owner's Room", "events");
    settings.SetToolTip("hfeleven", "Splits when the leaving the 11th room");

    vars.AddSplit("hftwelve", true, "Northwest Passage 1", "events");
    settings.SetToolTip("hftwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("hfthirteen", true, "Power Supply Room", "events");
    settings.SetToolTip("hfthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("hffourteen", true, "Northwest Passage 1", "events");
    settings.SetToolTip("hffourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("hffifteen", true, "Corridor", "events");
    settings.SetToolTip("hffifteen", "Splits when the leaving the 15th room");


    vars.AddSplit("hfnineteen", true, "Apple Inn Front Square", "events");
    settings.SetToolTip("hfnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("hftwenty", true, "Apple Inn Front Square", "events");
    settings.SetToolTip("hftwenty", "Splits when the leaving the 20th room");


    vars.AddSplit("hfsixteen", true, "Room 306", "events");
    settings.SetToolTip("hfsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("hfseventeen", true, "Corridor", "events");
    settings.SetToolTip("hfseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("hfeighteen", true, "Security Office", "events");
    settings.SetToolTip("hfeighteen", "Splits when the leaving the 18th room");





    vars.AddSplit("endGame", true, "End Game", "events");
    settings.SetToolTip("endGame", "Splits when the game rank screen displays");

    vars.AddSplit("ddone", true, "Entrance Hall", "events");
    settings.SetToolTip("ddone", "Splits when the leaving the 1st room");

    vars.AddSplit("ddtwo", true, "Student Affairs Office", "events");
    settings.SetToolTip("ddtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("ddthree", true, "General Manager's Room", "events");
    settings.SetToolTip("ddthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("ddfour", true, "Student Affairs Office", "events");
    settings.SetToolTip("ddfour", "Splits when the leaving the 4th room");

    vars.AddSplit("ddfive", true, "Entrance Hall", "events");
    settings.SetToolTip("ddfive", "Splits when the leaving the 5th room");

    vars.AddSplit("ddsix", true, "2F Hallway", "events");
    settings.SetToolTip("ddsix", "Splits when the leaving the 6th room");

    vars.AddSplit("ddseven", true, "Drawing Room", "events");
    settings.SetToolTip("ddseven", "Splits when the leaving the 7th room");

    vars.AddSplit("ddeight", true, "President's Room", "events");
    settings.SetToolTip("ddeight", "Splits when the leaving the 8th room");

    vars.AddSplit("ddnine", true, "Drawing Room", "events");
    settings.SetToolTip("ddnine", "Splits when the leaving the 9th room");

    vars.AddSplit("ddten", true, "2F Hallway", "events");
    settings.SetToolTip("ddten", "Splits when the leaving the 10th room");

    vars.AddSplit("ddeleven", true, "Art Safe Room", "events");
    settings.SetToolTip("ddeleven", "Splits when the leaving the 11th room");

    vars.AddSplit("ddtwelve", true, "2F Hallway", "events");
    settings.SetToolTip("ddtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("ddthirteen", true, "Entrance Hall", "events");
    settings.SetToolTip("ddthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("ddfourteen", true, "Secret Room", "events");
    settings.SetToolTip("ddfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("ddfifteen", true, "Entrance Hall", "events");
    settings.SetToolTip("ddfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("ddnsixteen", true, "Elevator Passage 1F", "events");
    settings.SetToolTip("ddnsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("ddhsixteen", true, "Elevator Passage 1F", "events");
    settings.SetToolTip("ddhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("ddnseventeen", true, "Elevator Passage B4F", "events");
    settings.SetToolTip("ddnseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("ddhseventeen", true, "Elevator Passage B4F", "events");
    settings.SetToolTip("ddhseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("ddeighteen", true, "Access Waterway", "events");
    settings.SetToolTip("ddeighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("ddnineteen", true, "Old Subway Rail Siding", "events");
    settings.SetToolTip("ddnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("ddhtwenty", true, "Old Subway Tunnel", "events");
    settings.SetToolTip("ddhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("ddvhtwenty", true, "Old Subway Tunnel", "events");
    settings.SetToolTip("ddvhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("ddhtwentyOne", true, "T-Shaped Passage", "events");
    settings.SetToolTip("ddhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("ddvhtwentyOne", true, "T-Shaped Passage", "events");
    settings.SetToolTip("ddvhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("ddtwentyTwo", true, "Store Room", "events");
    settings.SetToolTip("ddtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("ddtwentyThree", true, "Power Room", "events");
    settings.SetToolTip("ddtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("ddtwentyFour", true, "Store Room", "events");
    settings.SetToolTip("ddtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("ddtwentyFive", true, "T-Shaped Passage", "events");
    settings.SetToolTip("ddtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("ddtwentySix", true, "Tower Access Way", "events");
    settings.SetToolTip("ddtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("ddtwentySeven", true, "Tower Lower Part", "events");
    settings.SetToolTip("ddtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("ddtwentyEight", true, "Tower Elevator", "events");
    settings.SetToolTip("ddtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("ddtwentyNine", true, "Tower Upper Part", "events");
    settings.SetToolTip("ddtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("ddthirty", true, "Tower Station", "events");
    settings.SetToolTip("ddthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("ddthirtyOne", true, "Back Square", "events");
    settings.SetToolTip("ddthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("ddthirtyTwo", true, "1F Passage B", "events");
    settings.SetToolTip("ddthirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("ddthirtyThree", true, "Entrance Hall", "events");
    settings.SetToolTip("ddthirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("ddthirtyFour", true, "T-Blood", "events");
    settings.SetToolTip("ddthirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("ddthirtyFive", true, "Entrance Hall", "events");
    settings.SetToolTip("ddthirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("ddthirtySix", true, "Elevator Passage 1F", "events");
    settings.SetToolTip("ddthirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("ddthirtySeven", true, "Elevator Passage 3F", "events");
    settings.SetToolTip("ddthirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("ddthirtyEight", true, "Experiment Prep Room", "events");
    settings.SetToolTip("ddthirtyEight", "Splits when the leaving the 38th room");

    vars.AddSplit("ddthirtyNine", true, "Experiment Room", "events");
    settings.SetToolTip("ddthirtyNine", "Splits when the leaving the 39th room");

    vars.AddSplit("ddforty", true, "Machine Storage Room", "events");
    settings.SetToolTip("ddforty", "Splits when the leaving the 40th room");

    vars.AddSplit("ddfortyOne", true, "Bomb Sequence", "events");
    settings.SetToolTip("ddfortyOne", "Splits when the leaving the 41st room");

    vars.AddSplit("ddfortyTwo", true, "Back Square", "events");
    settings.SetToolTip("ddfortyTwo", "Splits when the leaving the 42nd room");

    vars.AddSplit("ddfortyThree", true, "Unloading Passage", "events");
    settings.SetToolTip("ddfortyThree", "Splits when the leaving the 43rd room");

    vars.AddSplit("ddfortyFour", true, "South Car", "events");
    settings.SetToolTip("ddfortyFour", "Splits when the leaving the South Car");

    vars.AddSplit("ddfortySix", true, "Old Subway Tunnel", "events");
    settings.SetToolTip("ddfortySix", "Splits when the leaving the Tunnel");

    vars.AddSplit("ddfortySeven", true, "Elevator Passage B2F", "events");
    settings.SetToolTip("ddfortySeven", "Splits when the leaving the B2F to Pier");

    vars.AddSplit("ddfortyEight", true, "Pier", "events");
    settings.SetToolTip("ddfortyEight", "Splits when the leaving the Pier");

    vars.AddSplit("ddfortyNine", true, "Elevator Passage B2F", "events");
    settings.SetToolTip("ddfortyNine", "Splits when the leaving the B2F Passage w/ card key");

}

init
{
    vars.lastRoom = String.Empty;
    vars.lastSplit = String.Empty; // Name of the most recent split
    vars.gameProcess = String.Empty; // Used to detect when the process has changed
    vars.productCode = String.Empty; // Used to detect when the game release has changed
    vars.basePointer = IntPtr.Zero; // Emulator virtual memory base pointer
    vars.isBigEndian = false; // Console uses big endian (e.g. PS3 and GCN)

    vars.LogRoom = (Action<string>)((text) => {
        vars.lastRoom = text;

        string log = timer.CurrentTime[timer.CurrentTimingMethod] + ": " + text;

        if (settings["logSplits"])
            File.AppendAllText(vars.logPath, log + System.Environment.NewLine);

        if (settings["debugSplits"])
            print("recvx split: " + log);
    });


    // Log splits
    vars.LogSplit = (Action<string>)((text) => {
        vars.lastSplit = text;

        string log = timer.CurrentTime[timer.CurrentTimingMethod] + ": " + text;

        if (settings["logSplits"])
            File.AppendAllText(vars.logPath, log + System.Environment.NewLine);

        if (settings["debugSplits"])
            print("recvx split: " + log);
    });

    // Update split status
    vars.UpdateSplit = (Func<string, bool>)((split) => {
        if (!vars.splits[split])
        {
            vars.LogSplit(split);
            vars.splits[split] = true;
            return settings[split];
        }
        else
            return false;
    });

    // Update item split status
    vars.UpdateItemSplit = (Func<byte, bool>)((id) => {
        if (!vars.itemSplits[id])
        {
            vars.LogSplit(vars.itemIndex[id] + " (" + id.ToString() + ")");
            vars.itemSplits[id] = true;
            return settings[vars.itemIndex[id]];
        }
        else
            return false;
    });

    // Sets memory pointers for the detected game release
    vars.UpdatePointers = (Action) (() => {
        switch ((string)vars.productCode)
        {
            default: // SLPM_654.28 [PS2] [JP] Biohazard: outbreak f1
                vars.timePtr = 0x0048BF78;

                vars.roomPtr = 0x00476FB2;
                vars.screenPtr = 0x0048BF60;
				vars.winPtr = 0x0048C006;
                vars.healthPtr = 0x00477314;
                vars.statusPtr = 0x00477970;
                vars.pausePtr = 0x0048C024;
                vars.characterPtr = 0x00477968;
                vars.inventoryPtr = 0x00477A54;
                vars.moveablePtr = 0x004779A0;
                vars.bosshpPtr = 0x0071AA6C;
		vars.storedoorhpPtr = 0x00473A70;
		vars.lockerhpPtr = 0x00473D32;
		vars.obstorehpPtr = 0x00473232;
		vars.scenarioidPtr = 0x003065AA;
		vars.hvhbfppanelhpPtr = 0x00473162;
		vars.enbfppanelhpPtr = 0x00473160;
		vars.obgratehpPtr = 0x00473250;

		vars.obshutterhpPtr = 0x00473220;
		vars.oballeydoorhpPtr = 0x00473340;
                break;
        }
    });
	
    // Detects if the process has changed
    vars.UpdateProcess = (Action) (() => {
        // Update process name if application has changed
        if (vars.gameProcess != game.ProcessName)
        {
            vars.gameProcess = game.ProcessName;

            // Set emulator edianess
            switch ((string)vars.gameProcess.ToLower())
            {
                default: //pcsx2
                    vars.isBigEndian = false;
                    break;
            }
        }
    });

    // Set emulator base pointer
    vars.UpdatePointer = (Action) (() => {
        switch ((string)vars.gameProcess.ToLower())
        {
            default: // pcsx2
                vars.basePointer = 0x20000000;
                break;
        }
    });

    // Detects if the game release has changed
    vars.UpdateProduct = (Action) (() => {
        string productCode;

        // Read game product code from memory
        switch ((string)vars.gameProcess.ToLower())
        {
            default: //pcsx2
                productCode = memory.ReadString(new IntPtr(vars.basePointer + 0x00015B90), 11);
                break;
        }

        // Update product code if the game release has changed
        if (vars.productCode != productCode)
        {
            vars.productCode = productCode;
            vars.UpdatePointers();
        }
    });

    // Updates game values
    vars.UpdateValues = (Action) (() => {
        uint time = 0; // In Game Timer

        byte room = 0; // Room the character is in
        byte screen = 0; // Current game screen (04 playing movie)
        ushort win = 0; // win result (0x0001 win, 0x0101 fail)
        uint health = 0; // Character health
        byte status = 0; // Character status info (0=OK, 1=Poison, 2=Bleed, 4=Cleared)
        byte pause = 0; // pause status info (0=off, 1=pause)
        byte character = 0; // Character ID
        byte moveable = 0; // When character can move (0=able, 1=unable)
        ushort bosshp = 0; // bosshp
	ushort storedoorhp = 0; //storage room door hp
	ushort lockerhp = 0; //locker hp
	ushort obstorehp = 0; //ob storeroom door hp for difficulty detection
	ushort hvhbfppanelhp = 0;
	ushort enbfppanelhp = 0;
	ushort obgratehp = 0;
	ushort obshutterhp = 0;
	ushort oballeydoorhp = 0;
	byte scenarioid = 0; //Scenario ID (1 = OB, 35 = BFP, 28 = Hive, 2 = Hellfire, 41 = DD)

        // Read values from memory
        memory.ReadValue<uint>(new IntPtr(vars.basePointer + vars.timePtr), out time);

        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.roomPtr), out room);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.screenPtr), out screen);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.winPtr), out win);
        memory.ReadValue<uint>(new IntPtr(vars.basePointer + vars.healthPtr), out health);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.statusPtr), out status);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.pausePtr), out pause);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.characterPtr), out character);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.moveablePtr), out moveable);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.bosshpPtr), out bosshp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.storedoorhpPtr), out storedoorhp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.lockerhpPtr), out lockerhp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.obstorehpPtr), out obstorehp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.hvhbfppanelhpPtr), out hvhbfppanelhp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.enbfppanelhpPtr), out enbfppanelhp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.obgratehpPtr), out obgratehp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.obshutterhpPtr), out obshutterhp);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.oballeydoorhpPtr), out oballeydoorhp);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.scenarioidPtr), out scenarioid);

        current.slot = 0; // Inventory slot number of the equipped item
        current.ammo = 0; // Ammo count for the equipped weapon
        current.time = vars.isBigEndian ? (int)vars.SwapBytesInt(time) : (int)time;

        current.room = room;
        current.screen = screen;
        current.win = win;
        current.health = vars.isBigEndian ? (int)vars.SwapBytesInt(health) : (int)health;
        current.status = status;
        current.character = character;
        current.inventory = new byte[8]; // Current characters inventory
	current.scenarioid = scenarioid;
		current.moveable = moveable;
		current.bosshp = bosshp;
		current.storedoorhp = storedoorhp;
		current.lockerhp = lockerhp;
		current.obstorehp = obstorehp; 
		current.hvhbfppanelhp = hvhbfppanelhp;
		current.enbfppanelhp = enbfppanelhp;
		current.obgratehp = obgratehp;
		current.obshutterhp = obshutterhp;
		current.oballeydoorhp = oballeydoorhp;

        int index = -1; // Inventory array index


	if (storedoorhp <= 500)
		current.storedoorhp = "Unlocked";
	if (lockerhp <= 249)
		current.lockerhp = "Destroyed";
	if (enbfppanelhp <= 99)
		current.enbfppanelhp = "Opened";
	if (hvhbfppanelhp <= 99)
		current.hvhbfppanelhp = "Opened";
	if (obgratehp <= 99)
		current.obgratehp = "Destroyed";
	if (obshutterhp <= 99)
		current.obshutterhp = "Opened";
	if (oballeydoorhp <= 99)
		current.oballeydoorhp = "Opened";


        // Pointer to the current characters inventory table
        IntPtr pointer = new IntPtr(vars.basePointer + vars.inventoryPtr);

        // Read inventory of the current character
        for (int i = 0; i < 8; ++i)
        {
            byte item = 0; // Inventory entry

            // Read inventory entry from memory
            memory.ReadValue<byte>(pointer, out item);

            // Move pointer to the next entry
            pointer = IntPtr.Add(pointer, 0x1);

            // First entry is the slot number of the equipped item
            if (i == -1)
            {
                //current.slot = item;
                continue;
            }

            // Set inventory index to the item ID
            current.inventory[++index] = item;
        }
    });

    // Initialise values
    vars.UpdateProcess();
    vars.UpdatePointer();
    vars.UpdateProduct();
    vars.UpdateValues();
}

start
{
    // Start when IGT is 0, in the Prison Cell room and the 1st item slot contains the Lighter
    return (current.time > 0);
}

update
{
    vars.UpdateProcess();
    vars.UpdatePointer();
    vars.UpdateProduct();
    vars.UpdateValues();

    if (timer.CurrentPhase == TimerPhase.NotRunning)
    {
        vars.ResetSplits();
        vars.ResetItemSplits();
    }
}

split
{
    // Split when an inventory entry changes
    for (int i = 0; i < current.inventory.Length; i++)
    {
        byte item = current.inventory[i];

        // Continue if the entry has not changed
        if (item == old.inventory[i]) continue;

        switch (item)
        {
            default: // Split the first time an item is added to the inventory
                if (vars.itemSplits.ContainsKey(item))
                    return vars.UpdateItemSplit(item);
                break;
        }
    }



    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 2 )
        return vars.UpdateSplit("obhone");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 5 && vars.lastSplit == "obhone")
        return vars.UpdateSplit("obhtwo");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 11 && vars.lastSplit == "obhtwo")
        return vars.UpdateSplit("obhthree");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 13 && vars.lastSplit == "obhthree")
        return vars.UpdateSplit("obhfour");



    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 14 && vars.lastSplit == "obhfour")
        return vars.UpdateSplit("obhseven");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 16 && vars.lastSplit == "obhseven")
        return vars.UpdateSplit("obheight");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 17 && vars.lastSplit == "obheight")
        return vars.UpdateSplit("obhnine");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 18 && vars.lastSplit == "obhnine")
        return vars.UpdateSplit("obhten");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 19 && vars.lastSplit == "obhten")
        return vars.UpdateSplit("obheleven");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 20 && vars.lastSplit == "obheleven")
        return vars.UpdateSplit("obhtwelve");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 21 && vars.lastSplit == "obhtwelve")
        return vars.UpdateSplit("obhthirteen");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 22 && vars.lastSplit == "obhthirteen")
        return vars.UpdateSplit("obhfourteen");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 23 && vars.lastSplit == "obhfourteen")
        return vars.UpdateSplit("obhfifteen");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 24 && vars.lastSplit == "obhfifteen")
        return vars.UpdateSplit("obhsixteen");

    if (current.scenarioid == 1 && current.obstorehp >= 2500 && current.room == 23 && vars.lastSplit == "obhsixteen")
        return vars.UpdateSplit("obhseventeen");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 2 )
        return vars.UpdateSplit("obnone");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 5 && vars.lastSplit == "obnone")
        return vars.UpdateSplit("obntwo");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 11 && vars.lastSplit == "obntwo")
        return vars.UpdateSplit("obnthree");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 12 && vars.lastSplit == "obnthree")
        return vars.UpdateSplit("obnfour");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 11 && vars.lastSplit == "obnfour")
        return vars.UpdateSplit("obnfive");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 13 && vars.lastSplit == "obnfive")
        return vars.UpdateSplit("obnsix");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 14 && vars.lastSplit == "obnsix")
        return vars.UpdateSplit("obnseven");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 16 && vars.lastSplit == "obnseven")
        return vars.UpdateSplit("obneight");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 17 && vars.lastSplit == "obneight")
        return vars.UpdateSplit("obnnine");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 18 && vars.lastSplit == "obnnine")
        return vars.UpdateSplit("obnten");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 19 && vars.lastSplit == "obnten")
        return vars.UpdateSplit("obneleven");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 20 && vars.lastSplit == "obneleven")
        return vars.UpdateSplit("obntwelve");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 21 && vars.lastSplit == "obntwelve")
        return vars.UpdateSplit("obnthirteen");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 22 && vars.lastSplit == "obnthirteen")
        return vars.UpdateSplit("obnfourteen");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 23 && vars.lastSplit == "obnfourteen")
        return vars.UpdateSplit("obnfifteen");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 24 && vars.lastSplit == "obnfifteen")
        return vars.UpdateSplit("obnsixteen");

    if (current.scenarioid == 1 && current.obstorehp <= 2100 && current.room == 23 && vars.lastSplit == "obnsixteen")
        return vars.UpdateSplit("obnseventeen");





    if (current.scenarioid == 35 && current.room == 2)
        return vars.UpdateSplit("bfpone");

    if (current.scenarioid == 35 && current.room == 17 && vars.lastSplit == "bfpone")
        return vars.UpdateSplit("bfptwo");

    if (current.scenarioid == 35 && current.room == 6 && vars.lastSplit == "bfptwo")
        return vars.UpdateSplit("bfpthree");

    if (current.scenarioid == 35 && current.room == 8 && vars.lastSplit == "bfpthree")
        return vars.UpdateSplit("bfpfour");

    if (current.scenarioid == 35 && current.room == 6 && vars.lastSplit == "bfpfour")
        return vars.UpdateSplit("bfpfive");

    if (current.scenarioid == 35 && current.room == 3 && vars.lastSplit == "bfpfive")
        return vars.UpdateSplit("bfpsix");

    if (current.scenarioid == 35 && current.room == 4 && vars.lastSplit == "bfpsix")
        return vars.UpdateSplit("bfpseven");

    if (current.scenarioid == 35 && current.room == 5 && vars.lastSplit == "bfpseven")
        return vars.UpdateSplit("bfpeight");

    if (current.scenarioid == 35 && current.room == 4 && vars.lastSplit == "bfpeight")
        return vars.UpdateSplit("bfpnine");

    if (current.scenarioid == 35 && current.room == 26 && vars.lastSplit == "bfpnine")
        return vars.UpdateSplit("bfpten");

    if (current.scenarioid == 35 && current.room == 10 && vars.lastSplit == "bfpten")
        return vars.UpdateSplit("bfpeleven");

    if (current.scenarioid == 35 && current.room == 9 && vars.lastSplit == "bfpeleven")
        return vars.UpdateSplit("bfptwelve");

    if (current.scenarioid == 35 && current.room == 10 && vars.lastSplit == "bfptwelve")
        return vars.UpdateSplit("bfpthirteen");

    if (current.scenarioid == 35 && current.room == 26 && vars.lastSplit == "bfpthirteen")
        return vars.UpdateSplit("bfpfourteen");

    if (current.scenarioid == 35 && current.room == 25 && vars.lastSplit == "bfpfourteen")
        return vars.UpdateSplit("bfpfifteen");

    if (current.scenarioid == 35 && current.room == 24 && vars.lastSplit == "bfpfifteen")
        return vars.UpdateSplit("bfpsixteen");

    if (current.scenarioid == 35 && current.room == 27 && vars.lastSplit == "bfpsixteen")
        return vars.UpdateSplit("bfpseventeen");

    if (current.scenarioid == 35 && current.room == 30 && vars.lastSplit == "bfpseventeen")
        return vars.UpdateSplit("bfpeighteen");

    if (current.scenarioid == 35 && current.room == 27 && vars.lastSplit == "bfpeighteen")
        return vars.UpdateSplit("bfpnineteen");

    if (current.scenarioid == 35 && current.room == 28 && vars.lastSplit == "bfpnineteen")
        return vars.UpdateSplit("bfptwenty");

    if (current.scenarioid == 35 && current.room == 27 && vars.lastSplit == "bfptwenty")
        return vars.UpdateSplit("bfptwentyOne");


    if (current.scenarioid == 35 && current.room == 32 && vars.lastSplit == "bfptwentyOne")
        return vars.UpdateSplit("bfptwentyFour");





    if (current.scenarioid == 28 && current.room == 9 && old.room == 8)
        return vars.UpdateSplit("hiveone");

    if (current.scenarioid == 28 && current.room == 10 && vars.lastSplit == "hiveone")
        return vars.UpdateSplit("hivetwo");

    if (current.scenarioid == 28 && current.room == 9 && vars.lastSplit == "hivetwo" && old.room == 10)
        return vars.UpdateSplit("hivethree");

    if (current.scenarioid == 28 && current.room == 11 && vars.lastSplit == "hivethree")
        return vars.UpdateSplit("hivefour");

    if (current.scenarioid == 28 && current.room == 9 && vars.lastSplit == "hivefour")
        return vars.UpdateSplit("hivefive");

    if (current.scenarioid == 28 && current.room == 22 && vars.lastSplit == "hivefive")
        return vars.UpdateSplit("hivesix");

    if (current.scenarioid == 28 && current.room == 2 && vars.lastSplit == "hivesix")
        return vars.UpdateSplit("hiveseven");

    if (current.scenarioid == 28 && current.room == 14 && vars.lastSplit == "hiveseven")
        return vars.UpdateSplit("hiveeight");

    if (current.scenarioid == 28 && current.room == 12 && vars.lastSplit == "hiveeight")
        return vars.UpdateSplit("hivenine");

    if (current.scenarioid == 28 && current.room == 14 && vars.lastSplit == "hivenine")
        return vars.UpdateSplit("hiveten");

    if (current.scenarioid == 28 && current.room == 2 && vars.lastSplit == "hiveten")
        return vars.UpdateSplit("hiveeleven");

    if (current.scenarioid == 28 && current.room == 22 && vars.lastSplit == "hiveeleven")
        return vars.UpdateSplit("hivetwelve");

    if (current.scenarioid == 28 && current.room == 25 && vars.lastSplit == "hivetwelve")
        return vars.UpdateSplit("hivethirteen");

    if (current.scenarioid == 28 && current.room == 28 && vars.lastSplit == "hivethirteen")
        return vars.UpdateSplit("hivefourteen");

    if (current.scenarioid == 28 && current.room == 29 && vars.lastSplit == "hivefourteen")
        return vars.UpdateSplit("hivefifteen");

    if (current.scenarioid == 28 && current.room == 28 && vars.lastSplit == "hivefifteen")
        return vars.UpdateSplit("hivesixteen");

    if (current.scenarioid == 28 && current.room == 25 && vars.lastSplit == "hivesixteen")
        return vars.UpdateSplit("hiveseventeen");

    if (current.scenarioid == 28 && current.room == 26 && vars.lastSplit == "hiveseventeen")
        return vars.UpdateSplit("hiveeighteen");

    if (current.scenarioid == 28 && current.room == 25 && vars.lastSplit == "hiveeighteen")
        return vars.UpdateSplit("hivenineteen");

    if (current.scenarioid == 28 && current.room == 30 && vars.lastSplit == "hivenineteen")
        return vars.UpdateSplit("hivetwenty");

    if (current.scenarioid == 28 && current.room == 31 && vars.lastSplit == "hivetwenty")
        return vars.UpdateSplit("hivetwentyOne");

    if (current.scenarioid == 28 && current.room == 32 && vars.lastSplit == "hivetwentyOne")
        return vars.UpdateSplit("hivetwentyTwo");

    if (current.scenarioid == 28 && current.room == 31 && vars.lastSplit == "hivetwentyTwo")
        return vars.UpdateSplit("hivetwentyThree");

    if (current.scenarioid == 28 && current.room == 30 && vars.lastSplit == "hivetwentyThree")
        return vars.UpdateSplit("hivetwentyFour");

    if (current.scenarioid == 28 && current.room == 33 && vars.lastSplit == "hivetwentyFour")
        return vars.UpdateSplit("hivetwentyFive");




    if (current.scenarioid == 2 && current.room == 28)
        return vars.UpdateSplit("hfone");

    if (current.scenarioid == 2 && current.room == 27 && old.room == 28 && vars.lastSplit == "hfone")
        return vars.UpdateSplit("hftwo");

    if (current.scenarioid == 2 && current.room == 29 && vars.lastSplit == "hftwo")
        return vars.UpdateSplit("hfthree");

    if (current.scenarioid == 2 && current.room == 38 && vars.lastSplit == "hfthree")
        return vars.UpdateSplit("hffour");

    if (current.scenarioid == 2 && current.room == 29 && vars.lastSplit == "hffour")
        return vars.UpdateSplit("hffive");

    if (current.scenarioid == 2 && current.room == 45 && vars.lastSplit == "hffive")
        return vars.UpdateSplit("hfsix");

    if (current.scenarioid == 2 && current.room == 29 && vars.lastSplit == "hfsix")
        return vars.UpdateSplit("hfseven");

    if (current.scenarioid == 2 && current.room == 43 && vars.lastSplit == "hfseven")
        return vars.UpdateSplit("hfeight");

    if (current.scenarioid == 2 && current.room == 41 && vars.lastSplit == "hfeight")
        return vars.UpdateSplit("hfnine");

    if (current.scenarioid == 2 && current.room == 32 && vars.lastSplit == "hfnine")
        return vars.UpdateSplit("hften");

    if (current.scenarioid == 2 && current.room == 31 && vars.lastSplit == "hften")
        return vars.UpdateSplit("hfeleven");

    if (current.scenarioid == 2 && current.room == 33 && vars.lastSplit == "hfeleven")
        return vars.UpdateSplit("hftwelve");

    if (current.scenarioid == 2 && current.room == 31 && vars.lastSplit == "hftwelve")
        return vars.UpdateSplit("hfthirteen");

    if (current.scenarioid == 2 && current.room == 29 && vars.lastSplit == "hfthirteen")
        return vars.UpdateSplit("hffourteen");

    if (current.scenarioid == 2 && current.room == 27 && old.room == 29 && vars.lastSplit == "hffourteen")
        return vars.UpdateSplit("hffifteen");

    if (current.scenarioid == 2 && current.room == 51 && vars.lastSplit == "hffifteen")
        return vars.UpdateSplit("hfnineteen");

    if (current.scenarioid == 2 && current.room == 27 && old.room == 51 && vars.lastSplit == "hfnineteen")
        return vars.UpdateSplit("hfsixteen");

    if (current.scenarioid == 2 && current.room == 29 && vars.lastSplit == "hfsixteen")
        return vars.UpdateSplit("hftwenty");

    if (current.scenarioid == 2 && current.room == 43 && vars.lastSplit == "hftwenty")
        return vars.UpdateSplit("hfseventeen");

    if (current.scenarioid == 2 && current.room == 35 && vars.lastSplit == "hfseventeen")
        return vars.UpdateSplit("hfeighteen");







    if (current.scenarioid == 41 && current.room == 81 && vars.lastSplit == "ddtwo" && old.room == 82)
        return vars.UpdateSplit("ddthree");

    if (current.scenarioid == 41 && current.room == 81 && old.room == 80)
        return vars.UpdateSplit("ddone");

    if (current.scenarioid == 41 && current.room == 82 && vars.lastSplit == "ddone")
        return vars.UpdateSplit("ddtwo");


    if (current.scenarioid == 41 && current.room == 80 && vars.lastSplit == "ddthree")
        return vars.UpdateSplit("ddfour");

    if (current.scenarioid == 41 && current.room == 89 && vars.lastSplit == "ddfour")
        return vars.UpdateSplit("ddfive");

    if (current.scenarioid == 41 && current.room == 88 && vars.lastSplit == "ddfive")
        return vars.UpdateSplit("ddsix");

    if (current.scenarioid == 41 && current.room == 87 && vars.lastSplit == "ddsix")
        return vars.UpdateSplit("ddseven");

    if (current.scenarioid == 41 && current.room == 88 && vars.lastSplit == "ddseven")
        return vars.UpdateSplit("ddeight");

    if (current.scenarioid == 41 && current.room == 89 && vars.lastSplit == "ddeight")
        return vars.UpdateSplit("ddnine");

    if (current.scenarioid == 41 && current.room == 91 && vars.lastSplit == "ddnine")
        return vars.UpdateSplit("ddten");

    if (current.scenarioid == 41 && current.room == 89 && vars.lastSplit == "ddten")
        return vars.UpdateSplit("ddeleven");

    if (current.scenarioid == 41 && current.room == 80 && old.room == 89 && vars.lastSplit == "ddeleven")
        return vars.UpdateSplit("ddtwelve");

    if (current.scenarioid == 41 && current.room == 77 && vars.lastSplit == "ddtwelve")
        return vars.UpdateSplit("ddthirteen");

    if (current.scenarioid == 41 && current.room == 80 && old.room == 77 && vars.lastSplit == "ddthirteen")
        return vars.UpdateSplit("ddfourteen");

    if (current.scenarioid == 41 && current.room == 78 && vars.lastSplit == "ddfourteen")
        return vars.UpdateSplit("ddfifteen");


    if (current.lockerhp <= 2500 && current.scenarioid == 41 && current.room == 36 && old.room == 78)
	return vars.UpdateSplit("ddnsixteen");

    if (current.lockerhp >= 3000 && current.scenarioid == 41 && current.room == 76 && vars.lastSplit == "ddfifteen")
        return vars.UpdateSplit("ddhsixteen");


    if (current.lockerhp >= 3000 && current.scenarioid == 41 && current.room == 71 && vars.lastSplit == "ddhsixteen")
        return vars.UpdateSplit("ddfortySeven");

    if (current.scenarioid == 41 && current.room == 76 && old.room == 71 && vars.lastSplit == "ddfortySeven")
        return vars.UpdateSplit("ddfortyEight");

    if (current.scenarioid == 41 && current.room == 36 && old.room == 76)
        return vars.UpdateSplit("ddfortyNine");



    if (current.lockerhp <= 2999 && current.scenarioid == 41 && current.room == 37 && vars.lastSplit == "ddnsixteen")
	return vars.UpdateSplit("ddnseventeen");

    if (current.lockerhp >= 3000 && current.scenarioid == 41 && current.room == 37 && vars.lastSplit == "ddfortyNine")
        return vars.UpdateSplit("ddhseventeen");


    if (current.scenarioid == 41 && current.room == 38 && vars.lastSplit == "ddhseventeen")
        return vars.UpdateSplit("ddeighteen");


    if (current.scenarioid == 41 && current.room == 38 && vars.lastSplit == "ddnseventeen")
        return vars.UpdateSplit("ddeighteen");

    if (current.scenarioid == 41 && current.room == 50 && vars.lastSplit == "ddeighteen")
        return vars.UpdateSplit("ddnineteen");


    if (current.lockerhp <= 3000 && current.scenarioid == 41 && current.room == 54 && vars.lastSplit == "ddnineteen")
	return vars.UpdateSplit("ddhtwenty");

    if (current.lockerhp == 5000 && current.scenarioid == 41 && current.room == 51 && vars.lastSplit == "ddnineteen")
        return vars.UpdateSplit("ddvhtwenty");


    if (current.lockerhp <= 3000 && current.scenarioid == 41 && current.room == 58 && vars.lastSplit == "ddhtwenty")
	return vars.UpdateSplit("ddhtwentyOne");

    if (current.lockerhp == 5000 && current.scenarioid == 41 && current.room == 58 && vars.lastSplit == "ddfortySix")
        return vars.UpdateSplit("ddvhtwentyOne");

    if (current.scenarioid == 41 && current.room == 57 && vars.lastSplit == "ddvhtwentyOne")
        return vars.UpdateSplit("ddtwentyTwo");

    if (current.scenarioid == 41 && current.room == 57 && vars.lastSplit == "ddhtwentyOne")
        return vars.UpdateSplit("ddtwentyTwo");

    if (current.scenarioid == 41 && current.room == 58 && vars.lastSplit == "ddtwentyTwo")
        return vars.UpdateSplit("ddtwentyThree");

    if (current.scenarioid == 41 && current.room == 54 && vars.lastSplit == "ddtwentyThree")
        return vars.UpdateSplit("ddtwentyFour");

    if (current.scenarioid == 41 && current.room == 60 && vars.lastSplit == "ddtwentyFour")
        return vars.UpdateSplit("ddtwentyFive");

    if (current.scenarioid == 41 && current.room == 61 && vars.lastSplit == "ddtwentyFive")
        return vars.UpdateSplit("ddtwentySix");

    if (current.scenarioid == 41 && current.room == 62 && vars.lastSplit == "ddtwentySix")
        return vars.UpdateSplit("ddtwentySeven");

    if (current.scenarioid == 41 && current.room == 63 && vars.lastSplit == "ddtwentySeven")
        return vars.UpdateSplit("ddtwentyEight");

    if (current.scenarioid == 41 && current.room == 65 && vars.lastSplit == "ddtwentyEight")
        return vars.UpdateSplit("ddtwentyNine");

    if (current.scenarioid == 41 && current.room == 70 && vars.lastSplit == "ddtwentyNine")
        return vars.UpdateSplit("ddthirty");

    if (current.scenarioid == 41 && current.room == 85 && vars.lastSplit == "ddthirty")
        return vars.UpdateSplit("ddthirtyOne");

    if (current.scenarioid == 41 && current.room == 80 && old.room == 85 && vars.lastSplit == "ddthirtyOne")
        return vars.UpdateSplit("ddthirtyTwo");

    if (current.scenarioid == 41 && current.room == 85 && vars.lastSplit == "ddthirtyTwo")
        return vars.UpdateSplit("ddthirtyThree");

    if (current.scenarioid == 41 && current.room == 80 && old.room == 85 && vars.lastSplit == "ddthirtyThree")
        return vars.UpdateSplit("ddthirtyFour");

    if (current.scenarioid == 41 && current.room == 78 && vars.lastSplit == "ddthirtyFour")
        return vars.UpdateSplit("ddthirtyFive");

    if (current.scenarioid == 41 && current.room == 94 && vars.lastSplit == "ddthirtyFive")
        return vars.UpdateSplit("ddthirtySix");

    if (current.scenarioid == 41 && current.room == 95 && vars.lastSplit == "ddthirtySix")
        return vars.UpdateSplit("ddthirtySeven");

    if (current.scenarioid == 41 && current.room == 96 && vars.lastSplit == "ddthirtySeven")
        return vars.UpdateSplit("ddthirtyEight");

    if (current.scenarioid == 41 && current.room == 97 && vars.lastSplit == "ddthirtyEight")
        return vars.UpdateSplit("ddthirtyNine");

    if (current.scenarioid == 41 && current.room == 98 && vars.lastSplit == "ddthirtyNine")
        return vars.UpdateSplit("ddforty");

    if (current.scenarioid == 41 && current.room == 70 && current.screen == 0x04 && vars.lastSplit == "ddforty")
        return vars.UpdateSplit("ddfortyOne");

    if (current.scenarioid == 41 && current.room == 72 && vars.lastSplit == "ddfortyOne")
        return vars.UpdateSplit("ddfortyTwo");



    if (current.scenarioid == 41 && current.room == 74 && vars.lastSplit == "ddfortyTwo")
        return vars.UpdateSplit("ddfortyThree");





    if (current.lockerhp == 5000 && current.scenarioid == 41 && current.room == 50 && old.room == 51)
        return vars.UpdateSplit("ddfortyFour");

    if (current.scenarioid == 41 && current.room == 54 && vars.lastSplit == "ddfortyFour")
        return vars.UpdateSplit("ddfortySix");




	if (current.status == 0x04) // End Game Rank Screen
    return vars.UpdateSplit("endGame");

}

reset
{
    if (current.scenarioid == 255)
    {
        return true;
    }
}

gameTime
{
    // Seconds = IGT / 60
    return TimeSpan.FromSeconds(current.time / 0.03 / 1000);
}

isLoading
{
    return true;
}