// Edit from veronica
// Resident Evil/Biohazard: Code: Veronica Auto Splitter
// By Kapdap 2020/07/16
// https://github.com/kapdap/re-cvx-autosplitter

state("pcsx2") {}

startup
{
    // Split tracker
    vars.splits = new Dictionary<string, bool>();

    // Inventory split tracker
    vars.itemSplits = new Dictionary<byte, bool>();
    vars.itemIndex = new Dictionary<byte, string>();

    // Adds a split
    vars.AddSplit = (Action<string, bool, string, string>)((id, default_value, description, parent) => {
        vars.splits.Add(id, false);
        settings.Add(id, default_value, description, parent);
    });

    // Adds an inventory split
    vars.AddItemSplit = (Action<byte, string, bool, string, string>)((code, id, default_value, description, parent) => {
        vars.itemSplits.Add(code, false);
        vars.itemIndex.Add(code, id);  // Map item code to split name
        settings.Add(id, default_value, description, parent);
    });

    // Resets split tracker
    vars.ResetSplits = (Action) (() => {
        List<string> keys = new List<string>(vars.splits.Keys);
        foreach(string key in keys)
            vars.splits[key] = false;
    });

    // Resets inventory split tracker
    vars.ResetItemSplits = (Action) (() => {
        List<byte> keys = new List<byte>(vars.itemSplits.Keys);
        foreach(byte key in keys)
            vars.itemSplits[key] = false;
    });

    // Swaps 2 byte values
    vars.SwapBytes = (Func<ushort, ushort>)((value) => {
        int b1 = (value >> 0) & 0xff;
        int b2 = (value >> 8) & 0xff;

        return (ushort) (b1 << 8 | b2 << 0);
    });

    // Swaps 4 byte values
    vars.SwapBytesInt = (Func<uint, uint>)((value) => {
        return ((value & 0x000000ff) << 24) +
            ((value & 0x0000ff00) << 8) +
            ((value & 0x00ff0000) >> 8) +
            ((value & 0xff000000) >> 24);
    });

    settings.Add("events", true, "Events");







    vars.AddSplit("sdogmutant", true, "G-Mutant", "events");
    settings.SetToolTip("sdogmutant", "Splits when killed G-Mutant");

    vars.AddSplit("sdogleech", true, "G.Leech", "events");
    settings.SetToolTip("sdogleech", "Splits when killed G.Leech");

    vars.AddSplit("sdosuspended", true, "Suspended", "events");
    settings.SetToolTip("sdosuspended", "Splits when killed Suspended");

    vars.AddSplit("sdothanatos", true, "Thanatos", "events");
    settings.SetToolTip("sdothanatos", "Splits when killed Thanatos");









    vars.AddSplit("sdttitan", true, "Titan", "events");
    settings.SetToolTip("sdttitan", "Splits when killed Titan");

    vars.AddSplit("sdtstalker", true, "Stalker", "events");
    settings.SetToolTip("sdtstalker", "Splits when killed Stalker");

    vars.AddSplit("sdtgigabyte", true, "Gigabyte", "events");
    settings.SetToolTip("sdtgigabyte", "Splits when killed Gigabyte");

    vars.AddSplit("sdttyrantr", true, "Tyrant R", "events");
    settings.SetToolTip("sdttyrantr", "Splits when killed Tyrant R");






    vars.AddSplit("sdthgmutant", true, "G-Mutant", "events");
    settings.SetToolTip("sdthgmutant", "Splits when killed G-Mutant");

    vars.AddSplit("sdthgleech", true, "G.Leech", "events");
    settings.SetToolTip("sdthgleech", "Splits when killed G.Leech");

    vars.AddSplit("sdthsuspended", true, "Suspended", "events");
    settings.SetToolTip("sdthsuspended", "Splits when killed Suspended");

    vars.AddSplit("sdththanatos", true, "Thanatos", "events");
    settings.SetToolTip("sdththanatos", "Splits when killed Thanatos");

    vars.AddSplit("sdththanatosr", true, "Thanatos.R", "events");
    settings.SetToolTip("sdththanatosr", "Splits when killed Thanatos.R");

    vars.AddSplit("sdthtitan", true, "Titan", "events");
    settings.SetToolTip("sdthtitan", "Splits when killed Titan");

    vars.AddSplit("sdthstalker", true, "Stalker", "events");
    settings.SetToolTip("sdthstalker", "Splits when killed Stalker");

    vars.AddSplit("sdthgigabyte", true, "Gigabyte", "events");
    settings.SetToolTip("sdthgigabyte", "Splits when killed Gigabyte");

    vars.AddSplit("sdthtyrantr", true, "Tyrant R", "events");
    settings.SetToolTip("sdthtyrantr", "Splits when killed Tyrant R");

    vars.AddSplit("sdthnyx", true, "Nyx", "events");
    settings.SetToolTip("sdthnyx", "Splits when killed Nyx");



    vars.AddSplit("enemy1", true, "Enemy 1", "events");
    settings.SetToolTip("enemy1", "Splits when the first enemy is killed");
    vars.AddSplit("enemy2", true, "Enemy 2", "events");
    settings.SetToolTip("enemy2", "Splits when Enemy is killed");
    vars.AddSplit("enemy3", true, "Enemy 3", "events");
    settings.SetToolTip("enemy3", "Splits when Enemy is killed");
    vars.AddSplit("enemy4", true, "Enemy 4", "events");
    settings.SetToolTip("enemy4", "Splits when Enemy is killed");
    vars.AddSplit("enemy5", true, "Enemy 5", "events");
    settings.SetToolTip("enemy5", "Splits when Enemy is killed");
    vars.AddSplit("enemy6", true, "Enemy 6", "events");
    settings.SetToolTip("enemy6", "Splits when Enemy is killed");
    vars.AddSplit("enemy7", true, "Enemy 7", "events");
    settings.SetToolTip("enemy7", "Splits when Enemy is killed");
    vars.AddSplit("enemy8", true, "Enemy 8", "events");
    settings.SetToolTip("enemy8", "Splits when Enemy is killed");
    vars.AddSplit("enemy9", true, "Enemy 9", "events");
    settings.SetToolTip("enemy9", "Splits when Enemy is killed");
    vars.AddSplit("enemy10", true, "Enemy 10", "events");
    settings.SetToolTip("enemy10", "Splits when Enemy is killed");
    vars.AddSplit("enemy11", true, "Enemy 11", "events");
    settings.SetToolTip("enemy11", "Splits when Enemy is killed");
    vars.AddSplit("enemy12", true, "Enemy 12", "events");
    settings.SetToolTip("enemy12", "Splits when Enemy is killed");
    vars.AddSplit("enemy13", true, "Enemy 13", "events");
    settings.SetToolTip("enemy13", "Splits when Enemy is killed");
    vars.AddSplit("enemy14", true, "Enemy 14", "events");
    settings.SetToolTip("enemy14", "Splits when Enemy is killed");
    vars.AddSplit("enemy15", true, "Enemy 15", "events");
    settings.SetToolTip("enemy15", "Splits when Enemy is killed");
    vars.AddSplit("enemy16", true, "Enemy 16", "events");
    settings.SetToolTip("enemy16", "Splits when Enemy is killed");
    vars.AddSplit("enemy17", true, "Enemy 17", "events");
    settings.SetToolTip("enemy17", "Splits when Enemy is killed");
    vars.AddSplit("enemy18", true, "Enemy 18", "events");
    settings.SetToolTip("enemy18", "Splits when Enemy is killed");
    vars.AddSplit("enemy19", true, "Enemy 19", "events");
    settings.SetToolTip("enemy19", "Splits when Enemy is killed");
    vars.AddSplit("enemy20", true, "Enemy 20", "events");
    settings.SetToolTip("enemy20", "Splits when Enemy is killed");
    vars.AddSplit("enemy21", true, "Enemy 21", "events");
    settings.SetToolTip("enemy21", "Splits when Enemy is killed");
    vars.AddSplit("enemy22", true, "Enemy 22", "events");
    settings.SetToolTip("enemy22", "Splits when Enemy is killed");
    vars.AddSplit("enemy23", true, "Enemy 23", "events");
    settings.SetToolTip("enemy23", "Splits when Enemy is killed");
    vars.AddSplit("enemy24", true, "Enemy 24", "events");
    settings.SetToolTip("enemy24", "Splits when Enemy is killed");
    vars.AddSplit("enemy25", true, "Enemy 25", "events");
    settings.SetToolTip("enemy25", "Splits when Enemy is killed");
    vars.AddSplit("enemy26", true, "Enemy 26", "events");
    settings.SetToolTip("enemy26", "Splits when Enemy is killed");
    vars.AddSplit("enemy27", true, "Enemy 27", "events");
    settings.SetToolTip("enemy27", "Splits when Enemy is killed");
    vars.AddSplit("enemy28", true, "Enemy 28", "events");
    settings.SetToolTip("enemy28", "Splits when Enemy is killed");
    vars.AddSplit("enemy29", true, "Enemy 29", "events");
    settings.SetToolTip("enemy29", "Splits when Enemy is killed");
    vars.AddSplit("enemy30", true, "Enemy 30", "events");
    settings.SetToolTip("enemy30", "Splits when Enemy is killed");
    vars.AddSplit("enemy31", true, "Enemy 31", "events");
    settings.SetToolTip("enemy31", "Splits when Enemy is killed");
    vars.AddSplit("enemy32", true, "Enemy 32", "events");
    settings.SetToolTip("enemy32", "Splits when Enemy is killed");
    vars.AddSplit("enemy33", true, "Enemy 33", "events");
    settings.SetToolTip("enemy33", "Splits when Enemy is killed");
    vars.AddSplit("enemy34", true, "Enemy 34", "events");
    settings.SetToolTip("enemy34", "Splits when Enemy is killed");
    vars.AddSplit("enemy35", true, "Enemy 35", "events");
    settings.SetToolTip("enemy35", "Splits when Enemy is killed");
    vars.AddSplit("enemy36", true, "Enemy 36", "events");
    settings.SetToolTip("enemy36", "Splits when Enemy is killed");



    vars.AddSplit("endGame", true, "End Game", "events");
    settings.SetToolTip("endGame", "Splits when the game rank screen displays");



}

init
{
    vars.lastSplit = String.Empty; // Name of the most recent split
    vars.gameProcess = String.Empty; // Used to detect when the process has changed
    vars.productCode = String.Empty; // Used to detect when the game release has changed
    vars.basePointer = IntPtr.Zero; // Emulator virtual memory base pointer
    vars.isBigEndian = false; // Console uses big endian (e.g. PS3 and GCN)

    // Log splits
    vars.LogSplit = (Action<string>)((text) => {
        vars.lastSplit = text;

        string log = timer.CurrentTime[timer.CurrentTimingMethod] + ": " + text;

        if (settings["logSplits"])
            File.AppendAllText(vars.logPath, log + System.Environment.NewLine);

        if (settings["debugSplits"])
            print("recvx split: " + log);
    });

    // Update split status
    vars.UpdateSplit = (Func<string, bool>)((split) => {
        if (!vars.splits[split])
        {
            vars.LogSplit(split);
            vars.splits[split] = true;
            return settings[split];
        }
        else
            return false;
    });

    // Update item split status
    vars.UpdateItemSplit = (Func<byte, bool>)((id) => {
        if (!vars.itemSplits[id])
        {
            vars.LogSplit(vars.itemIndex[id] + " (" + id.ToString() + ")");
            vars.itemSplits[id] = true;
            return settings[vars.itemIndex[id]];
        }
        else
            return false;
    });

    // Sets memory pointers for the detected game release
    vars.UpdatePointers = (Action) (() => {
        switch ((string)vars.productCode)
        {
            default: // SLPM_656.92 [PS2] [JP] Biohazard: outbreak f2
                vars.timePtr = 0x004912B8;
                vars.roomPtr = 0x0047BF12;
                vars.screenPtr = 0x004912A0;
                vars.healthPtr = 0x0047C270;
                vars.statusPtr = 0x0047C8E8;
                vars.pausePtr = 0x004912BE;
                vars.characterPtr = 0x0047C8E0;
                vars.inventoryPtr = 0x0047C9C4;
                vars.bosshpPtr = 0x007612AC;
		vars.scenarioidPtr = 0x003137BA;
		vars.wtbardoorhpPtr = 0x00477726;
		vars.diffPtr = 0x0049135A;
		vars.ekillcountPtr = 0x0049010C;
                break;
        }
    });
	
    // Detects if the process has changed
    vars.UpdateProcess = (Action) (() => {
        // Update process name if application has changed
        if (vars.gameProcess != game.ProcessName)
        {
            vars.gameProcess = game.ProcessName;

            // Set emulator edianess
            switch ((string)vars.gameProcess.ToLower())
            {
                default: //pcsx2
                    vars.isBigEndian = false;
                    break;
            }
        }
    });

    // Set emulator base pointer
    vars.UpdatePointer = (Action) (() => {
        switch ((string)vars.gameProcess.ToLower())
        {
            default: // pcsx2
                vars.basePointer = 0x20000000;
                break;
        }
    });

    // Detects if the game release has changed
    vars.UpdateProduct = (Action) (() => {
        string productCode;

        // Read game product code from memory
        switch ((string)vars.gameProcess.ToLower())
        {
            default: //pcsx2
                productCode = memory.ReadString(new IntPtr(vars.basePointer + 0x00015B90), 11);
                break;
        }

        // Update product code if the game release has changed
        if (vars.productCode != productCode)
        {
            vars.productCode = productCode;
            vars.UpdatePointers();
        }
    });

    // Updates game values
    vars.UpdateValues = (Action) (() => {
        uint time = 0; // In Game Timer
        byte room = 0; // Room the character is in
        byte screen = 0; // Current game screen
        uint health = 0; // Character health
        byte status = 0; // Character status info
        byte pause = 0; // pause status info
        byte character = 0; // Character ID
        ushort bosshp = 0; // bosshp
	byte scenarioid = 0; //40 = WT, 10 = UB, 26 = FB, 15 = DT, 6 = EOTR
	ushort wtbardoorhp = 0;
	byte diff = 0;
	byte ekillcount = 0; //number of enemies killed in elimination

        // Read values from memory
        memory.ReadValue<uint>(new IntPtr(vars.basePointer + vars.timePtr), out time);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.roomPtr), out room);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.screenPtr), out screen);
        memory.ReadValue<uint>(new IntPtr(vars.basePointer + vars.healthPtr), out health);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.statusPtr), out status);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.pausePtr), out pause);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.characterPtr), out character);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.bosshpPtr), out bosshp);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.scenarioidPtr), out scenarioid);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.diffPtr), out diff);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.wtbardoorhpPtr), out wtbardoorhp);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.ekillcountPtr), out ekillcount);

        current.slot = 0; // Inventory slot number of the equipped item
        current.ammo = 0; // Ammo count for the equipped weapon
        current.time = vars.isBigEndian ? (int)vars.SwapBytesInt(time) : (int)time;
        current.room = room;
        current.screen = screen;
        current.health = vars.isBigEndian ? (int)vars.SwapBytesInt(health) : (int)health;
        current.status = "Normal";
        current.character = character;
        current.inventory = new byte[8]; // Current characters inventory
		current.bosshp = bosshp;
	current.scenarioid = scenarioid;
	current.wtbardoorhp = wtbardoorhp;
	current.diff = diff;
	current.ekillcount = ekillcount;

        // Check status for gassed or poison flags
        if ((status & 0x20) != 0)
            current.status = "Gassed";
        else if ((status & 0x08) != 0)
            current.status = "Poison";

        int index = -1; // Inventory array index

        // Pointer to the current characters inventory table
        IntPtr pointer = new IntPtr(vars.basePointer + vars.inventoryPtr-2);

        // Read inventory of the current character
        for (int i = 0; i < 9; ++i)
        {
            int item = 0; // Inventory entry

            // Read inventory entry from memory
            memory.ReadValue<int>(pointer, out item);

            // Move pointer to the next entry
            pointer = IntPtr.Add(pointer, 0x1);

            // First entry is the slot number of the equipped item
            if (i == 0)
            {
                current.slot = item;
                continue;
            }

            // Remaing entries are inventory items
            byte[] bytes = BitConverter.GetBytes(item);

            // Set inventory index to the item ID
            current.inventory[++index] = bytes[1];

            // Read quantity if this item is equipped
            if (current.slot == (index + 1))
                current.ammo = BitConverter.ToInt16(bytes, 0);
        }
    });

    // Initialise values
    vars.UpdateProcess();
    vars.UpdatePointer();
    vars.UpdateProduct();
    vars.UpdateValues();
}

start
{
    // Start when IGT is 0, in the Prison Cell room and the 1st item slot contains the Lighter
    return (current.time > 0);
}

update
{
    vars.UpdateProcess();
    vars.UpdatePointer();
    vars.UpdateProduct();
    vars.UpdateValues();

    if (timer.CurrentPhase == TimerPhase.NotRunning)
    {
        vars.ResetSplits();
        vars.ResetItemSplits();
    }
}

split
{
    // Split when an inventory entry changes
    for (int i = 0; i < current.inventory.Length; i++)
    {
        byte item = current.inventory[i];

        // Continue if the entry has not changed
        if (item == old.inventory[i]) continue;

        switch (item)
        {
            default: // Split the first time an item is added to the inventory
                if (vars.itemSplits.ContainsKey(item))
                    return vars.UpdateItemSplit(item);
                break;
        }
    }







    if (current.scenarioid == 21 && current.room == 2 && old.room == 1) // when boss ded
        return vars.UpdateSplit("sdogmutant");

    if (current.scenarioid == 21 && current.room == 3 && old.room == 2) // when boss ded
        return vars.UpdateSplit("sdogleech");

    if (current.scenarioid == 21 && current.room == 4 && old.room == 3) // when boss ded
        return vars.UpdateSplit("sdosuspended");

    if (current.scenarioid == 21 && current.room == 5 && old.room == 4) // when boss ded
        return vars.UpdateSplit("sdothanatos");




    if (current.scenarioid == 22 && current.room == 7) // when boss ded
        return vars.UpdateSplit("sdttitan");

    if (current.scenarioid == 22 && current.room == 8) // when boss ded
        return vars.UpdateSplit("sdtstalker");

    if (current.scenarioid == 22 && current.room == 9) // when boss ded
        return vars.UpdateSplit("sdtgigabyte");

    if (current.scenarioid == 22 && current.room == 10) // when boss ded
        return vars.UpdateSplit("sdttyrantr");





    if (current.scenarioid == 23 && current.room == 2) // when boss ded
	return vars.UpdateSplit("sdthgmutant");

    if (current.scenarioid == 23 && current.room == 3) // when boss ded
	return vars.UpdateSplit("sdthgleech");

    if (current.scenarioid == 23 && current.room == 4) // when boss ded
	return vars.UpdateSplit("sdthsuspended");

    if (current.scenarioid == 23 && current.room == 5) // when boss ded
	return vars.UpdateSplit("sdththanatos");

    if (current.scenarioid == 23 && current.room == 6) // when boss ded
	return vars.UpdateSplit("sdththanatosr");

    if (current.scenarioid == 23 && current.room == 7) // when boss ded
        return vars.UpdateSplit("sdthtitan");

    if (current.scenarioid == 23 && current.room == 8) // when boss ded
        return vars.UpdateSplit("sdthstalker");

    if (current.scenarioid == 23 && current.room == 9) // when boss ded
        return vars.UpdateSplit("sdthgigabyte");

    if (current.scenarioid == 23 && current.room == 10) // when boss ded
        return vars.UpdateSplit("sdthtyrantr");

    if (current.scenarioid == 23 && current.room == 11) // when boss ded
	return vars.UpdateSplit("sdthnyx");






    if (current.ekillcount == 1 && old.ekillcount == 0)
	return vars.UpdateSplit("enemy1");

    if (current.ekillcount == 2 && old.ekillcount == 1)
        return vars.UpdateSplit("enemy2");

    if (current.ekillcount == 3 && old.ekillcount == 2)
        return vars.UpdateSplit("enemy3");

    if (current.ekillcount == 4 && old.ekillcount == 3)
        return vars.UpdateSplit("enemy4");

    if (current.ekillcount == 5 && old.ekillcount == 4)
        return vars.UpdateSplit("enemy5");

    if (current.ekillcount == 6 && old.ekillcount == 5)
        return vars.UpdateSplit("enemy6");

    if (current.ekillcount == 7 && old.ekillcount == 6)
        return vars.UpdateSplit("enemy7");

    if (current.ekillcount == 8 && old.ekillcount == 7)
        return vars.UpdateSplit("enemy8");

    if (current.ekillcount == 9 && old.ekillcount == 8)
        return vars.UpdateSplit("enemy9");

    if (current.ekillcount == 10 && old.ekillcount == 9)
        return vars.UpdateSplit("enemy10");

    if (current.ekillcount == 11 && old.ekillcount == 10)
        return vars.UpdateSplit("enemy11");

    if (current.ekillcount == 12 && old.ekillcount == 11)
        return vars.UpdateSplit("enemy12");

    if (current.ekillcount == 13 && old.ekillcount == 12)
        return vars.UpdateSplit("enemy13");

    if (current.ekillcount == 14 && old.ekillcount == 13)
        return vars.UpdateSplit("enemy14");

    if (current.ekillcount == 15 && old.ekillcount == 14)
        return vars.UpdateSplit("enemy15");

    if (current.ekillcount == 16 && old.ekillcount == 15)
        return vars.UpdateSplit("enemy16");

    if (current.ekillcount == 17 && old.ekillcount == 16)
        return vars.UpdateSplit("enemy17");

    if (current.ekillcount == 18 && old.ekillcount == 17)
        return vars.UpdateSplit("enemy18");

    if (current.ekillcount == 19 && old.ekillcount == 18)
        return vars.UpdateSplit("enemy19");

    if (current.ekillcount == 20 && old.ekillcount == 19)
        return vars.UpdateSplit("enemy20");

    if (current.ekillcount == 21 && old.ekillcount == 20)
        return vars.UpdateSplit("enemy21");

    if (current.ekillcount == 22 && old.ekillcount == 21)
        return vars.UpdateSplit("enemy22");

    if (current.ekillcount == 23 && old.ekillcount == 22)
        return vars.UpdateSplit("enemy23");

    if (current.ekillcount == 24 && old.ekillcount == 23)
        return vars.UpdateSplit("enemy24");

    if (current.ekillcount == 25 && old.ekillcount == 24)
        return vars.UpdateSplit("enemy25");

    if (current.ekillcount == 26 && old.ekillcount == 25)
        return vars.UpdateSplit("enemy26");

    if (current.ekillcount == 27 && old.ekillcount == 26)
        return vars.UpdateSplit("enemy27");

    if (current.ekillcount == 28 && old.ekillcount == 27)
        return vars.UpdateSplit("enemy28");

    if (current.ekillcount == 29 && old.ekillcount == 28)
        return vars.UpdateSplit("enemy29");

    if (current.ekillcount == 30 && old.ekillcount == 29)
        return vars.UpdateSplit("enemy30");

    if (current.ekillcount == 31 && old.ekillcount == 30)
        return vars.UpdateSplit("enemy31");

    if (current.ekillcount == 32 && old.ekillcount == 31)
        return vars.UpdateSplit("enemy32");

    if (current.ekillcount == 33 && old.ekillcount == 32)
        return vars.UpdateSplit("enemy33");

    if (current.ekillcount == 34 && old.ekillcount == 33)
        return vars.UpdateSplit("enemy34");

    if (current.ekillcount == 35 && old.ekillcount == 34)
        return vars.UpdateSplit("enemy35");

    if (current.ekillcount == 36 && old.ekillcount == 35)
        return vars.UpdateSplit("enemy36");
















    if (current.screen >= 0x0C) // End Game Rank Screen
        return vars.UpdateSplit("endGame");
}

reset
{
    if (current.room == 0 && current.time == 0)
    {
        return true;
    }
}

gameTime
{
    // Seconds = IGT / 60
    return TimeSpan.FromSeconds(current.time / 0.03 / 1000);
}

isLoading
{
    return true;
}