// Edit from veronica
// Resident Evil/Biohazard: Code: Veronica Auto Splitter
// By Kapdap 2020/07/16
// https://github.com/kapdap/re-cvx-autosplitter

state("pcsx2") {}

startup
{
    // Split tracker
    vars.splits = new Dictionary<string, bool>();

    // Inventory split tracker
    vars.itemSplits = new Dictionary<byte, bool>();
    vars.itemIndex = new Dictionary<byte, string>();

    // Adds a split
    vars.AddSplit = (Action<string, bool, string, string>)((id, default_value, description, parent) => {
        vars.splits.Add(id, false);
        settings.Add(id, default_value, description, parent);
    });

    // Adds an inventory split
    vars.AddItemSplit = (Action<byte, string, bool, string, string>)((code, id, default_value, description, parent) => {
        vars.itemSplits.Add(code, false);
        vars.itemIndex.Add(code, id);  // Map item code to split name
        settings.Add(id, default_value, description, parent);
    });

    // Resets split tracker
    vars.ResetSplits = (Action) (() => {
        List<string> keys = new List<string>(vars.splits.Keys);
        foreach(string key in keys)
            vars.splits[key] = false;
    });

    // Resets inventory split tracker
    vars.ResetItemSplits = (Action) (() => {
        List<byte> keys = new List<byte>(vars.itemSplits.Keys);
        foreach(byte key in keys)
            vars.itemSplits[key] = false;
    });

    // Swaps 2 byte values
    vars.SwapBytes = (Func<ushort, ushort>)((value) => {
        int b1 = (value >> 0) & 0xff;
        int b2 = (value >> 8) & 0xff;

        return (ushort) (b1 << 8 | b2 << 0);
    });

    // Swaps 4 byte values
    vars.SwapBytesInt = (Func<uint, uint>)((value) => {
        return ((value & 0x000000ff) << 24) +
            ((value & 0x0000ff00) << 8) +
            ((value & 0x00ff0000) >> 8) +
            ((value & 0xff000000) >> 24);
    });

    settings.Add("events", true, "Events");
    vars.AddSplit("wteone", true, "Outside Elephant Restaurant", "events");
    settings.SetToolTip("wteone", "Splits when the leaving the 1st room");

    vars.AddSplit("wtetwo", true, "Elephant Restaurant", "events");
    settings.SetToolTip("wtetwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("wtethree", true, "Outside Elephant Restaurant", "events");
    settings.SetToolTip("wtethree", "Splits when the leaving the 3rd room");

    vars.AddSplit("wtefour", true, "South Concourse", "events");
    settings.SetToolTip("wtefour", "Splits when the leaving the 4th room");

    vars.AddSplit("wtefive", true, "East Concourse", "events");
    settings.SetToolTip("wtefive", "Splits when the leaving the 5th room");

    vars.AddSplit("wtesix", true, "North Concourse", "events");
    settings.SetToolTip("wtesix", "Splits when the leaving the 6th room");

    vars.AddSplit("wteseven", true, "Office", "events");
    settings.SetToolTip("wteseven", "Splits when the leaving the 7th room");

    vars.AddSplit("wteeight", true, "Inner Office", "events");
    settings.SetToolTip("wteeight", "Splits when the leaving the 8th room");

    vars.AddSplit("wtenine", true, "Office", "events");
    settings.SetToolTip("wtenine", "Splits when the leaving the 9th room");

    vars.AddSplit("wteten", true, "North Concourse", "events");
    settings.SetToolTip("wteten", "Splits when the leaving the 10th room");

    vars.AddSplit("wteeleven", true, "East Concourse", "events");
    settings.SetToolTip("wteeleven", "Splits when the leaving the 11th room");

    vars.AddSplit("wtetwelve", true, "Elephant Stage", "events");
    settings.SetToolTip("wtetwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("wtethirteen", true, "Connecting Passage", "events");
    settings.SetToolTip("wtethirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("wtefourteen", true, "Elephant Stage", "events");
    settings.SetToolTip("wtefourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("wtefifteen", true, "Connecting Passage", "events");
    settings.SetToolTip("wtefifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("wtesixteen", true, "Terrarium Dome", "events");
    settings.SetToolTip("wtesixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("wteseventeen", true, "Lakeside Area", "events");
    settings.SetToolTip("wteseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("wteeighteen", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wteeighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("wtenineteen", true, "Front Gate Plaza", "events");
    settings.SetToolTip("wtenineteen", "Splits when the leaving the 19th room");





    vars.AddSplit("wtnone", true, "Outside Elephant Restaurant", "events");
    settings.SetToolTip("wtnone", "Splits when the leaving the 1st room");

    vars.AddSplit("wtntwo", true, "Elephant Restaurant", "events");
    settings.SetToolTip("wtntwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("wtnthree", true, "Outside Elephant Restaurant", "events");
    settings.SetToolTip("wtnthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("wtnfour", true, "South Concourse", "events");
    settings.SetToolTip("wtnfour", "Splits when the leaving the 4th room");

    vars.AddSplit("wtnfive", true, "East Concourse", "events");
    settings.SetToolTip("wtnfive", "Splits when the leaving the 5th room");

    vars.AddSplit("wtnsix", true, "North Concourse", "events");
    settings.SetToolTip("wtnsix", "Splits when the leaving the 6th room");

    vars.AddSplit("wtnseven", true, "Office", "events");
    settings.SetToolTip("wtnseven", "Splits when the leaving the 7th room");

    vars.AddSplit("wtneight", true, "Inner Office", "events");
    settings.SetToolTip("wtneight", "Splits when the leaving the 8th room");

    vars.AddSplit("wtnnine", true, "Office", "events");
    settings.SetToolTip("wtnnine", "Splits when the leaving the 9th room");

    vars.AddSplit("wtnten", true, "North Concourse", "events");
    settings.SetToolTip("wtnten", "Splits when the leaving the 10th room");

    vars.AddSplit("wtneleven", true, "East Concourse", "events");
    settings.SetToolTip("wtneleven", "Splits when the leaving the 11th room");

    vars.AddSplit("wtntwelve", true, "Elephant Stage", "events");
    settings.SetToolTip("wtntwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("wtnthirteen", true, "Connecting Passage", "events");
    settings.SetToolTip("wtnthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("wtnfourteen", true, "Terrarium Dome", "events");
    settings.SetToolTip("wtnfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("wtnfifteen", true, "Lakeside Area", "events");
    settings.SetToolTip("wtnfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("wtnsixteen", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wtnsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("wtnseventeen", true, "Observation Deck", "events");
    settings.SetToolTip("wtnseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("wtneighteen", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wtneighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("wtnnineteen", true, "North Concourse", "events");
    settings.SetToolTip("wtnnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("wtntwenty", true, "Office", "events");
    settings.SetToolTip("wtntwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("wtntwentyOne", true, "Inner Office", "events");
    settings.SetToolTip("wtntwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("wtntwentyTwo", true, "Office", "events");
    settings.SetToolTip("wtntwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("wtntwentyThree", true, "North Concourse", "events");
    settings.SetToolTip("wtntwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("wtntwentyFour", true, "East Concourse", "events");
    settings.SetToolTip("wtntwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("wtntwentyFive", true, "Elephant Stage", "events");
    settings.SetToolTip("wtntwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("wtntwentySix", true, "Connecting Passage", "events");
    settings.SetToolTip("wtntwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("wtntwentySeven", true, "Terrarium Dome", "events");
    settings.SetToolTip("wtntwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("wtntwentyEight", true, "Connecting Passage", "events");
    settings.SetToolTip("wtntwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("wtntwentyNine", true, "Connecting Passage", "events");
    settings.SetToolTip("wtntwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("wtnthirty", true, "East Concourse", "events");
    settings.SetToolTip("wtnthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("wtnthirtyOne", true, "South Concourse", "events");
    settings.SetToolTip("wtnthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("wtnthirtyTwo", true, "Service Road", "events");
    settings.SetToolTip("wtnthirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("wtnthirtyThree", true, "Show Animals' Boarding House", "events");
    settings.SetToolTip("wtnthirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("wtnthirtyFour", true, "Lion Stage", "events");
    settings.SetToolTip("wtnthirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("wtnthirtyFive", true, "Front Gate Plaza", "events");
    settings.SetToolTip("wtnthirtyFive", "Splits when the leaving the 35th room");








    vars.AddSplit("wthone", true, "Outside of Elephant Restaurant", "events");
    settings.SetToolTip("wthone", "Splits when the leaving the 1st room");

    vars.AddSplit("wthtwo", true, "Back Alley", "events");
    settings.SetToolTip("wthtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("wththree", true, "Outside of Elephant Restaurant", "events");
    settings.SetToolTip("wththree", "Splits when the leaving the 3rd room");

    vars.AddSplit("wthfour", true, "Elephant Restaurant", "events");
    settings.SetToolTip("wthfour", "Splits when the leaving the 4th room");

    vars.AddSplit("wthfive", true, "Outside of Elephant Restaurant", "events");
    settings.SetToolTip("wthfive", "Splits when the leaving the 5th room");

    vars.AddSplit("wthsix", true, "South Concourse", "events");
    settings.SetToolTip("wthsix", "Splits when the leaving the 6th room");

    vars.AddSplit("wthseven", true, "East Concourse", "events");
    settings.SetToolTip("wthseven", "Splits when the leaving the 7th room");

    vars.AddSplit("wtheight", true, "Elephant Stage", "events");
    settings.SetToolTip("wtheight", "Splits when the leaving the 8th room");

    vars.AddSplit("wthnine", true, "East Concourse", "events");
    settings.SetToolTip("wthnine", "Splits when the leaving the 9th room");

    vars.AddSplit("wthten", true, "North Concourse", "events");
    settings.SetToolTip("wthten", "Splits when the leaving the 10th room");

    vars.AddSplit("wtheleven", true, "Office", "events");
    settings.SetToolTip("wtheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("wthtwelve", true, "Inner Office", "events");
    settings.SetToolTip("wthtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("wththirteen", true, "Office", "events");
    settings.SetToolTip("wththirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("wthfourteen", true, "North Concourse", "events");
    settings.SetToolTip("wthfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("wthfifteen", true, "South Concourse", "events");
    settings.SetToolTip("wthfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("wthsixteen", true, "Service Road", "events");
    settings.SetToolTip("wthsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("wthseventeen", true, "Show Animals' Boarding House", "events");
    settings.SetToolTip("wthseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("wtheighteen", true, "Lion Stage", "events");
    settings.SetToolTip("wtheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("wthnineteen", true, "Front Gate Plaza", "events");
    settings.SetToolTip("wthnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("wthtwenty", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wthtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("wthtwentyOne", true, "Observation Deck", "events");
    settings.SetToolTip("wthtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("wthtwentyTwo", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wthtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("wthtwentyThree", true, "North Concourse", "events");
    settings.SetToolTip("wthtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("wthtwentyFour", true, "Office", "events");
    settings.SetToolTip("wthtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("wthtwentyFive", true, "Inner Office", "events");
    settings.SetToolTip("wthtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("wthtwentySix", true, "Office", "events");
    settings.SetToolTip("wthtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("wthtwentySeven", true, "North Concourse", "events");
    settings.SetToolTip("wthtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("wthtwentyEight", true, "East Concourse", "events");
    settings.SetToolTip("wthtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("wthtwentyNine", true, "Elephant Stage", "events");
    settings.SetToolTip("wthtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("wththirty", true, "Connecting Passage", "events");
    settings.SetToolTip("wththirty", "Splits when the leaving the 30th room");

    vars.AddSplit("wththirtyOne", true, "Elephant Stage", "events");
    settings.SetToolTip("wththirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("wththirtyTwo", true, "Connecting Passage", "events");
    settings.SetToolTip("wththirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("wththirtyThree", true, "Terrarium Dome", "events");
    settings.SetToolTip("wththirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("wththirtyFour", true, "Lakeside Area", "events");
    settings.SetToolTip("wththirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("wththirtyFive", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wththirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("wththirtySix", true, "Front Gate Plaza", "events");
    settings.SetToolTip("wththirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("wththirtySeven", true, "Lion Stage", "events");
    settings.SetToolTip("wththirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("wththirtyEight", true, "Front Gate Plaza", "events");
    settings.SetToolTip("wththirtyEight", "Splits when the leaving the 38th room");







    vars.AddSplit("wtvhone", true, "Outside of Elephant Restaurant", "events");
    settings.SetToolTip("wtvhone", "Splits when the leaving the 1st room");

    vars.AddSplit("wtvhtwo", true, "Back Alley", "events");
    settings.SetToolTip("wtvhtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("wtvhthree", true, "Outside of Elephant Restaurant", "events");
    settings.SetToolTip("wtvhthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("wtvhfour", true, "South Concourse", "events");
    settings.SetToolTip("wtvhfour", "Splits when the leaving the 4th room");

    vars.AddSplit("wtvhfive", true, "Service Road", "events");
    settings.SetToolTip("wtvhfive", "Splits when the leaving the 5th room");

    vars.AddSplit("wtvhsix", true, "Show Animals' Boarding House", "events");
    settings.SetToolTip("wtvhsix", "Splits when the leaving the 6th room");

    vars.AddSplit("wtvhseven", true, "Lion Stage", "events");
    settings.SetToolTip("wtvhseven", "Splits when the leaving the 7th room");

    vars.AddSplit("wtvheight", true, "Front Gate Plaza", "events");
    settings.SetToolTip("wtvheight", "Splits when the leaving the 8th room");

    vars.AddSplit("wtvhnine", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wtvhnine", "Splits when the leaving the 9th room");

    vars.AddSplit("wtvhten", true, "Observation Deck", "events");
    settings.SetToolTip("wtvhten", "Splits when the leaving the 10th room");

    vars.AddSplit("wtvheleven", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wtvheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("wtvhtwelve", true, "Lakeside Area", "events");
    settings.SetToolTip("wtvhtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("wtvhthirteen", true, "Terrarium Dome", "events");
    settings.SetToolTip("wtvhthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("wtvhfourteen", true, "Connecting Passage", "events");
    settings.SetToolTip("wtvhfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("wtvhfifteen", true, "Elephant Stage", "events");
    settings.SetToolTip("wtvhfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("wtvhsixteen", true, "East Concourse", "events");
    settings.SetToolTip("wtvhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("wtvhseventeen", true, "North Concourse", "events");
    settings.SetToolTip("wtvhseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("wtvheighteen", true, "Office", "events");
    settings.SetToolTip("wtvheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("wtvhnineteen", true, "Inner Office", "events");
    settings.SetToolTip("wtvhnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("wtvhtwenty", true, "Office", "events");
    settings.SetToolTip("wtvhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("wtvhtwentyOne", true, "North Concourse", "events");
    settings.SetToolTip("wtvhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("wtvhtwentyTwo", true, "East Concourse", "events");
    settings.SetToolTip("wtvhtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("wtvhtwentyThree", true, "Elephant Stage", "events");
    settings.SetToolTip("wtvhtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("wtvhtwentyFour", true, "Connecting Passage", "events");
    settings.SetToolTip("wtvhtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("wtvhtwentyFive", true, "Terrarium Dome", "events");
    settings.SetToolTip("wtvhtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("wtvhtwentySix", true, "Connecting Passage", "events");
    settings.SetToolTip("wtvhtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("wtvhtwentySeven", true, "Elephant Stage", "events");
    settings.SetToolTip("wtvhtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("wtvhtwentyEight", true, "East Concourse", "events");
    settings.SetToolTip("wtvhtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("wtvhtwentyNine", true, "North Concourse", "events");
    settings.SetToolTip("wtvhtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("wtvhthirty", true, "Office", "events");
    settings.SetToolTip("wtvhthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("wtvhthirtyOne", true, "Inner Office", "events");
    settings.SetToolTip("wtvhthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("wtvhthirtyTwo", true, "Office", "events");
    settings.SetToolTip("wtvhthirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("wtvhthirtyThree", true, "North Concourse", "events");
    settings.SetToolTip("wtvhthirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("wtvhthirtyFour", true, "Path in Front of Observation Deck", "events");
    settings.SetToolTip("wtvhthirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("wtvhthirtyFive", true, "Front Gate Plaza", "events");
    settings.SetToolTip("wtvhthirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("wtvhthirtySix", true, "Lion Stage", "events");
    settings.SetToolTip("wtvhthirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("wtvhthirtySeven", true, "Show Animals' Boarding House", "events");
    settings.SetToolTip("wtvhthirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("wtvhthirtyEight", true, "Lion Stage", "events");
    settings.SetToolTip("wtvhthirtyEight", "Splits when the leaving the 38th room");

    vars.AddSplit("wtvhthirtyNine", true, "Front Gate Plaza", "events");
    settings.SetToolTip("wtvhthirtyNine", "Splits when the leaving the 39th room");






    vars.AddSplit("ubeone", true, "West Entrance", "events");
    settings.SetToolTip("ubeone", "Splits when the leaving the 1st room");

    vars.AddSplit("ubetwo", true, "West Ticket Gate", "events");
    settings.SetToolTip("ubetwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("ubethree", true, "West Concourse", "events");
    settings.SetToolTip("ubethree", "Splits when the leaving the 3rd room");

    vars.AddSplit("ubefour", true, "Employee Passage", "events");
    settings.SetToolTip("ubefour", "Splits when the leaving the 4th room");

    vars.AddSplit("ubefive", true, "Men's Staff Restroom", "events");
    settings.SetToolTip("ubefive", "Splits when the leaving the 5th room");

    vars.AddSplit("ubesix", true, "Employee Passage", "events");
    settings.SetToolTip("ubesix", "Splits when the leaving the 6th room");

    vars.AddSplit("ubeseven", true, "Break Room", "events");
    settings.SetToolTip("ubeseven", "Splits when the leaving the 7th room");

    vars.AddSplit("ubeeight", true, "Employee Passage", "events");
    settings.SetToolTip("ubeeight", "Splits when the leaving the 8th room");

    vars.AddSplit("ubenine", true, "Stairwell", "events");
    settings.SetToolTip("ubenine", "Splits when the leaving the 9th room");

    vars.AddSplit("ubeten", true, "B2F Passway", "events");
    settings.SetToolTip("ubeten", "Splits when the leaving the 10th room");

    vars.AddSplit("ubeeleven", true, "Emergency Power Room", "events");
    settings.SetToolTip("ubeeleven", "Splits when the leaving the 11th room");

    vars.AddSplit("ubetwelve", true, "B2F Passway", "events");
    settings.SetToolTip("ubetwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("ubethirteen", true, "Pump Room", "events");
    settings.SetToolTip("ubethirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("ubefourteen", true, "B2F Passway", "events");
    settings.SetToolTip("ubefourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("ubefifteen", true, "Stairwell", "events");
    settings.SetToolTip("ubefifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("ubesixteen", true, "Employee Passage", "events");
    settings.SetToolTip("ubesixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("ubeseventeen", true, "Breaker Room", "events");
    settings.SetToolTip("ubeseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("ubeeighteen", true, "Employee Passage", "events");
    settings.SetToolTip("ubeeighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("ubenineteen", true, "West Concourse", "events");
    settings.SetToolTip("ubenineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("ubetwenty", true, "Platform", "events");
    settings.SetToolTip("ubetwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("ubetwentyOne", true, "West Concourse", "events");
    settings.SetToolTip("ubetwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("ubetwentyTwo", true, "Employee Passage", "events");
    settings.SetToolTip("ubetwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("ubetwentyThree", true, "Control Room", "events");
    settings.SetToolTip("ubetwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("ubetwentyFour", true, "Employee Passage", "events");
    settings.SetToolTip("ubetwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("ubetwentyFive", true, "West Concourse", "events");
    settings.SetToolTip("ubetwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("ubetwentySix", true, "Platform", "events");
    settings.SetToolTip("ubetwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("ubetwentySeven", true, "East Tunnel", "events");
    settings.SetToolTip("ubetwentySeven", "Splits when the leaving the 27th room");







    vars.AddSplit("ubnone", true, "East Entrance", "events");
    settings.SetToolTip("ubnone", "Splits when the leaving the 1st room");

    vars.AddSplit("ubntwo", true, "East Ticket Gate", "events");
    settings.SetToolTip("ubntwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("ubnthree", true, "East Concourse", "events");
    settings.SetToolTip("ubnthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("ubnfour", true, "Employee Passage", "events");
    settings.SetToolTip("ubnfour", "Splits when the leaving the 4th room");

    vars.AddSplit("ubnfive", true, "Men's Staff Restroom", "events");
    settings.SetToolTip("ubnfive", "Splits when the leaving the 5th room");

    vars.AddSplit("ubnsix", true, "Employee Passage", "events");
    settings.SetToolTip("ubnsix", "Splits when the leaving the 6th room");

    vars.AddSplit("ubnseven", true, "Break Room", "events");
    settings.SetToolTip("ubnseven", "Splits when the leaving the 7th room");

    vars.AddSplit("ubneight", true, "Employee Passage", "events");
    settings.SetToolTip("ubneight", "Splits when the leaving the 8th room");

    vars.AddSplit("ubnnine", true, "Stairwell", "events");
    settings.SetToolTip("ubnnine", "Splits when the leaving the 9th room");

    vars.AddSplit("ubnten", true, "B2F Passway", "events");
    settings.SetToolTip("ubnten", "Splits when the leaving the 10th room");

    vars.AddSplit("ubneleven", true, "Emergency Power Room", "events");
    settings.SetToolTip("ubneleven", "Splits when the leaving the 11th room");

    vars.AddSplit("ubntwelve", true, "B2F Passway", "events");
    settings.SetToolTip("ubntwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("ubnthirteen", true, "Pump Room", "events");
    settings.SetToolTip("ubnthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("ubnfourteen", true, "B2F Passway", "events");
    settings.SetToolTip("ubnfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("ubnfifteen", true, "Stairwell", "events");
    settings.SetToolTip("ubnfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("ubnsixteen", true, "Employee Passage", "events");
    settings.SetToolTip("ubnsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("ubnseventeen", true, "Breaker Room", "events");
    settings.SetToolTip("ubnseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("ubneighteen", true, "Employee Passage", "events");
    settings.SetToolTip("ubneighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("ubnnineteen", true, "West Concourse", "events");
    settings.SetToolTip("ubnnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("ubntwenty", true, "Platform", "events");
    settings.SetToolTip("ubntwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("ubntwentyOne", true, "West Concourse", "events");
    settings.SetToolTip("ubntwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("ubntwentyTwo", true, "Employee Passage", "events");
    settings.SetToolTip("ubntwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("ubntwentyThree", true, "Control Room", "events");
    settings.SetToolTip("ubntwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("ubntwentyFour", true, "Employee Passage", "events");
    settings.SetToolTip("ubntwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("ubntwentyFive", true, "West Concourse", "events");
    settings.SetToolTip("ubntwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("ubntwentySix", true, "Platform", "events");
    settings.SetToolTip("ubntwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("ubntwentySeven", true, "East Tunnel", "events");
    settings.SetToolTip("ubntwentySeven", "Splits when the leaving the 27th room");



    vars.AddSplit("ubhone", true, "West Entrance", "events");
    settings.SetToolTip("ubhone", "Splits when the leaving the 1st room");

    vars.AddSplit("ubhtwo", true, "West Ticket Gate", "events");
    settings.SetToolTip("ubhtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("ubhWest", true, "West Concourse", "events");
    settings.SetToolTip("ubhWest", "Splits when the leaving the room");

    vars.AddSplit("ubhPlat", true, "Platform", "events");
    settings.SetToolTip("ubhPlat", "Splits when the leaving the room");

    vars.AddSplit("ubheTunn", true, "East Tunnel", "events");
    settings.SetToolTip("ubheTunn", "Splits when the leaving the room");

    vars.AddSplit("ubhPBoom", true, "Platform", "events");
    settings.SetToolTip("ubhPBoom", "Splits when the leaving the room");

    vars.AddSplit("ubhthree", true, "East Concourse", "events");
    settings.SetToolTip("ubhthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("ubhfour", true, "Employee Passage", "events");
    settings.SetToolTip("ubhfour", "Splits when the leaving the 4th room");

    vars.AddSplit("ubhfive", true, "Men's Staff Restroom", "events");
    settings.SetToolTip("ubhfive", "Splits when the leaving the 5th room");

    vars.AddSplit("ubhsix", true, "Employee Passage", "events");
    settings.SetToolTip("ubhsix", "Splits when the leaving the 6th room");

    vars.AddSplit("ubhseven", true, "Break Room", "events");
    settings.SetToolTip("ubhseven", "Splits when the leaving the 7th room");

    vars.AddSplit("ubheight", true, "Employee Passage", "events");
    settings.SetToolTip("ubheight", "Splits when the leaving the 8th room");

    vars.AddSplit("ubhnine", true, "Stairwell", "events");
    settings.SetToolTip("ubhnine", "Splits when the leaving the 9th room");

    vars.AddSplit("ubhten", true, "B2F Passway", "events");
    settings.SetToolTip("ubhten", "Splits when the leaving the 10th room");

    vars.AddSplit("ubheleven", true, "Emergency Power Room", "events");
    settings.SetToolTip("ubheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("ubhtwelve", true, "B2F Passway", "events");
    settings.SetToolTip("ubhtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("ubhthirteen", true, "Pump Room", "events");
    settings.SetToolTip("ubhthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("ubhfourteen", true, "B2F Passway", "events");
    settings.SetToolTip("ubhfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("ubhfifteen", true, "Stairwell", "events");
    settings.SetToolTip("ubhfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("ubhsixteen", true, "Employee Passage", "events");
    settings.SetToolTip("ubhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("ubhseventeen", true, "Breaker Room", "events");
    settings.SetToolTip("ubhseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("ubheighteen", true, "Employee Passage", "events");
    settings.SetToolTip("ubheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("ubhnineteen", true, "West Concourse", "events");
    settings.SetToolTip("ubhnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("ubhtwenty", true, "Platform", "events");
    settings.SetToolTip("ubhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("ubhtwentyOne", true, "West Concourse", "events");
    settings.SetToolTip("ubhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("ubhtwentyTwo", true, "Employee Passage", "events");
    settings.SetToolTip("ubhtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("ubhtwentyThree", true, "Control Room", "events");
    settings.SetToolTip("ubhtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("ubhtwentyFour", true, "Employee Passage", "events");
    settings.SetToolTip("ubhtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("ubhtwentyFive", true, "West Concourse", "events");
    settings.SetToolTip("ubhtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("ubhtwentySix", true, "Platform", "events");
    settings.SetToolTip("ubhtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("ubhtwentySeven", true, "East Tunnel", "events");
    settings.SetToolTip("ubhtwentySeven", "Splits when the leaving the 27th room");








    vars.AddSplit("ubvhone", true, "East Entrance", "events");
    settings.SetToolTip("ubvhone", "Splits when the leaving the 1st room");

    vars.AddSplit("ubvhtwo", true, "East Ticket Gate", "events");
    settings.SetToolTip("ubvhtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("ubvhWest", true, "East Concourse", "events");
    settings.SetToolTip("ubvhWest", "Splits when the leaving the room");

    vars.AddSplit("ubvhPlat", true, "Platform", "events");
    settings.SetToolTip("ubvhPlat", "Splits when the leaving the room");

    vars.AddSplit("ubvheTunn", true, "East Tunnel", "events");
    settings.SetToolTip("ubvheTunn", "Splits when the leaving the room");

    vars.AddSplit("ubvhPBoom", true, "Platform", "events");
    settings.SetToolTip("ubvhPBoom", "Splits when the leaving the room");

    vars.AddSplit("ubvhthree", true, "East Concourse", "events");
    settings.SetToolTip("ubvhthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("ubvhfour", true, "Employee Passage", "events");
    settings.SetToolTip("ubvhfour", "Splits when the leaving the 4th room");

    vars.AddSplit("ubvhfive", true, "Men's Staff Restroom", "events");
    settings.SetToolTip("ubvhfive", "Splits when the leaving the 5th room");

    vars.AddSplit("ubvhsix", true, "Employee Passage", "events");
    settings.SetToolTip("ubvhsix", "Splits when the leaving the 6th room");

    vars.AddSplit("ubvhseven", true, "Break Room", "events");
    settings.SetToolTip("ubvhseven", "Splits when the leaving the 7th room");

    vars.AddSplit("ubvheight", true, "Employee Passage", "events");
    settings.SetToolTip("ubvheight", "Splits when the leaving the 8th room");

    vars.AddSplit("ubvhnine", true, "Stairwell", "events");
    settings.SetToolTip("ubvhnine", "Splits when the leaving the 9th room");

    vars.AddSplit("ubvhten", true, "B2F Passway", "events");
    settings.SetToolTip("ubvhten", "Splits when the leaving the 10th room");

    vars.AddSplit("ubvheleven", true, "Emergency Power Room", "events");
    settings.SetToolTip("ubvheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("ubvhtwelve", true, "B2F Passway", "events");
    settings.SetToolTip("ubvhtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("ubvhthirteen", true, "Pump Room", "events");
    settings.SetToolTip("ubvhthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("ubvhfourteen", true, "B2F Passway", "events");
    settings.SetToolTip("ubvhfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("ubvhfifteen", true, "Stairwell", "events");
    settings.SetToolTip("ubvhfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("ubvhsixteen", true, "Employee Passage", "events");
    settings.SetToolTip("ubvhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("ubvhseventeen", true, "Breaker Room", "events");
    settings.SetToolTip("ubvhseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("ubvheighteen", true, "Employee Passage", "events");
    settings.SetToolTip("ubvheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("ubvhnineteen", true, "West Concourse", "events");
    settings.SetToolTip("ubvhnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("ubvhtwenty", true, "Platform", "events");
    settings.SetToolTip("ubvhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("ubvhtwentyOne", true, "West Concourse", "events");
    settings.SetToolTip("ubvhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("ubvhtwentyTwo", true, "Employee Passage", "events");
    settings.SetToolTip("ubvhtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("ubvhtwentyThree", true, "Control Room", "events");
    settings.SetToolTip("ubvhtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("ubvhtwentyFour", true, "Employee Passage", "events");
    settings.SetToolTip("ubvhtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("ubvhtwentyFive", true, "West Concourse", "events");
    settings.SetToolTip("ubvhtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("ubvhtwentySix", true, "Platform", "events");
    settings.SetToolTip("ubvhtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("ubvhtwentySeven", true, "East Tunnel", "events");
    settings.SetToolTip("ubvhtwentySeven", "Splits when the leaving the 27th room");





    vars.AddSplit("fbeone", true, "Cabin", "events");
    settings.SetToolTip("fbeone", "Splits when the leaving the 1st room");

    vars.AddSplit("fbetwo", true, "In Front Of Cabin", "events");
    settings.SetToolTip("fbetwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("fbethree", true, "Mountain Path", "events");
    settings.SetToolTip("fbethree", "Splits when the leaving the 3rd room");

    vars.AddSplit("fbefour", true, "Susp. Bridge", "events");
    settings.SetToolTip("fbefour", "Splits when the leaving the 4th room");

    vars.AddSplit("fbefive", true, "Hospital Back Gate", "events");
    settings.SetToolTip("fbefive", "Splits when the leaving the 5th room");

    vars.AddSplit("fbesix", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbesix", "Splits when the leaving the 6th room");

    vars.AddSplit("fbeseven", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbeseven", "Splits when the leaving the 7th room");

    vars.AddSplit("fbeeight", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbeeight", "Splits when the leaving the 8th room");

    vars.AddSplit("fbenine", true, "Pharmacy", "events");
    settings.SetToolTip("fbenine", "Splits when the leaving the 9th room");

    vars.AddSplit("fbeten", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbeten", "Splits when the leaving the 10th room");

    vars.AddSplit("fbeeleven", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbeeleven", "Splits when the leaving the 11th room");

    vars.AddSplit("fbetwelve", true, "Auxiliary Building North Hall", "events");
    settings.SetToolTip("fbetwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("fbethirteen", true, "Auxiliary Building 2F", "events");
    settings.SetToolTip("fbethirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("fbefourteen", true, "Maintenance Access Route", "events");
    settings.SetToolTip("fbefourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("fbefifteen", true, "Auxiliary Building 5F", "events");
    settings.SetToolTip("fbefifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("fbesixteen", true, "Auxiliary Rooftop", "events");
    settings.SetToolTip("fbesixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("fbeseventeen", true, "Auxiliary Building 5F", "events");
    settings.SetToolTip("fbeseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("fbeeighteen", true, "Maintenance Access Route", "events");
    settings.SetToolTip("fbeeighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("fbenineteen", true, "Auxiliary Building 2F", "events");
    settings.SetToolTip("fbenineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("fbetwenty", true, "Storage Room", "events");
    settings.SetToolTip("fbetwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("fbetwentyOne", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbetwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("fbetwentyTwo", true, "Auxiliary Building North Hall", "events");
    settings.SetToolTip("fbetwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("fbetwentyThree", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbetwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("fbetwentyFour", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbetwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("fbetwentyFive", true, "Main Building 2F Hall", "events");
    settings.SetToolTip("fbetwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("fbetwentySix", true, "Administrator's Office", "events");
    settings.SetToolTip("fbetwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("fbetwentySeven", true, "Auxiliary Building 3F", "events");
    settings.SetToolTip("fbetwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("fbetwentyEight", true, "Main Building Rooftop", "events");
    settings.SetToolTip("fbetwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("fbetwentyNine", true, "Room 203", "events");
    settings.SetToolTip("fbetwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("fbethirty", true, "Main Building 2F Hall", "events");
    settings.SetToolTip("fbethirty", "Splits when the leaving the 30th room");

    vars.AddSplit("fbethirtyOne", true, "Room 201", "events");
    settings.SetToolTip("fbethirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("fbethirtyTwo", true, "Main Building 2F Hall", "events");
    settings.SetToolTip("fbethirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("fbethirtyThree", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbethirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("fbethirtyFour", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbethirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("fbethirtyFive", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbethirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("fbethirtySix", true, "Intensive care Unit", "events");
    settings.SetToolTip("fbethirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("fbethirtySeven", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbethirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("fbethirtyEight", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbethirtyEight", "Splits when the leaving the 38th room");






    vars.AddSplit("fbnone", true, "Cabin", "events");
    settings.SetToolTip("fbnone", "Splits when the leaving the 1st room");

    vars.AddSplit("fbntwo", true, "In Front Of Cabin", "events");
    settings.SetToolTip("fbntwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("fbnthree", true, "Mountain Path", "events");
    settings.SetToolTip("fbnthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("fbnfour", true, "Susp. Bridge", "events");
    settings.SetToolTip("fbnfour", "Splits when the leaving the 4th room");

    vars.AddSplit("fbnfive", true, "Hospital Back Gate", "events");
    settings.SetToolTip("fbnfive", "Splits when the leaving the 5th room");


    vars.AddSplit("fbnhallOne", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbnhallOne", "Splits when the leaving room");

    vars.AddSplit("fbnrecep", true, "Reception Office", "events");
    settings.SetToolTip("fbnrecep", "Splits when the leavin room");

    vars.AddSplit("fbnexam", true, "Examination Room", "events");
    settings.SetToolTip("fbnexam", "Splits when the leaving room");

    vars.AddSplit("fbnoffice", true, "Reception Office", "events");
    settings.SetToolTip("fbnoffice", "Splits when the leaving room");


    vars.AddSplit("fbnsix", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbnsix", "Splits when the leaving the 6th room");

    vars.AddSplit("fbnseven", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbnseven", "Splits when the leaving the 7th room");

    vars.AddSplit("fbneight", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbneight", "Splits when the leaving the 8th room");

    vars.AddSplit("fbnnine", true, "Pharmacy", "events");
    settings.SetToolTip("fbnnine", "Splits when the leaving the 9th room");

    vars.AddSplit("fbnten", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbnten", "Splits when the leaving the 10th room");

    vars.AddSplit("fbneleven", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbneleven", "Splits when the leaving the 11th room");

    vars.AddSplit("fbntwelve", true, "Auxiliary Building North Hall", "events");
    settings.SetToolTip("fbntwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("fbnthirteen", true, "Auxiliary Building 2F", "events");
    settings.SetToolTip("fbnthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("fbnfourteen", true, "Maintenance Access Route", "events");
    settings.SetToolTip("fbnfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("fbnfifteen", true, "Auxiliary Building 5F", "events");
    settings.SetToolTip("fbnfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("fbnsixteen", true, "Auxiliary Rooftop", "events");
    settings.SetToolTip("fbnsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("fbnseventeen", true, "Auxiliary Building 5F", "events");
    settings.SetToolTip("fbnseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("fbneighteen", true, "Maintenance Access Route", "events");
    settings.SetToolTip("fbneighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("fbnnineteen", true, "Auxiliary Building 2F", "events");
    settings.SetToolTip("fbnnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("fbntwenty", true, "Storage Room", "events");
    settings.SetToolTip("fbntwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("fbntwentyOne", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbntwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("fbntwentyTwo", true, "Auxiliary Building North Hall", "events");
    settings.SetToolTip("fbntwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("fbntwentyThree", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbntwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("fbntwentyFour", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbntwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("fbntwentyFive", true, "Main Building 2F Hall", "events");
    settings.SetToolTip("fbntwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("fbntwentySix", true, "Administrator's Office", "events");
    settings.SetToolTip("fbntwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("fbntwentySeven", true, "Auxiliary Building 3F", "events");
    settings.SetToolTip("fbntwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("fbntwentyEight", true, "Main Building Rooftop", "events");
    settings.SetToolTip("fbntwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("fbntwentyNine", true, "Room 203", "events");
    settings.SetToolTip("fbntwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("fbnthirty", true, "Main Building 2F Hall", "events");
    settings.SetToolTip("fbnthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("fbnthirtyOne", true, "Room 201", "events");
    settings.SetToolTip("fbnthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("fbnthirtyTwo", true, "Main Building 2F Hall", "events");
    settings.SetToolTip("fbnthirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("fbnthirtyThree", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbnthirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("fbnthirtyFour", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbnthirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("fbnthirtyFive", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbnthirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("fbnthirtySix", true, "Intensive care Unit", "events");
    settings.SetToolTip("fbnthirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("fbnthirtySeven", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbnthirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("fbnthirtyEight", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbnthirtyEight", "Splits when the leaving the 38th room");






    vars.AddSplit("fbhone", true, "Cabin", "events");
    settings.SetToolTip("fbhone", "Splits when the leaving the 1st room");

    vars.AddSplit("fbhtwo", true, "In Front Of Cabin", "events");
    settings.SetToolTip("fbhtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("fbhthree", true, "Mountain Path", "events");
    settings.SetToolTip("fbhthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("fbhfour", true, "Susp. Bridge", "events");
    settings.SetToolTip("fbhfour", "Splits when the leaving the 4th room");

    vars.AddSplit("fbhfive", true, "Hospital Back Gate", "events");
    settings.SetToolTip("fbhfive", "Splits when the leaving the 5th room");


    vars.AddSplit("fbhhallOne", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbhhallOne", "Splits when the leaving room");

    vars.AddSplit("fbhrecep", true, "Reception Office", "events");
    settings.SetToolTip("fbhrecep", "Splits when the leavin room");

    vars.AddSplit("fbhexam", true, "Examination Room", "events");
    settings.SetToolTip("fbhexam", "Splits when the leaving room");

    vars.AddSplit("fbhoffice", true, "Reception Office", "events");
    settings.SetToolTip("fbhoffice", "Splits when the leaving room");


    vars.AddSplit("fbhsix", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbhsix", "Splits when the leaving the 6th room");

    vars.AddSplit("fbhseven", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbhseven", "Splits when the leaving the 7th room");

    vars.AddSplit("fbheight", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbheight", "Splits when the leaving the 8th room");

    vars.AddSplit("fbhnine", true, "Pharmacy", "events");
    settings.SetToolTip("fbhnine", "Splits when the leaving the 9th room");

    vars.AddSplit("fbhten", true, "Auxiliary Hall B1F", "events");
    settings.SetToolTip("fbhten", "Splits when the leaving the 10th room");

    vars.AddSplit("fbheleven", true, "Auxiliary Hall 1F", "events");
    settings.SetToolTip("fbheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("fbhtwelve", true, "Main Hall 1F", "events");
    settings.SetToolTip("fbhtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("fbhthirteen", true, "Main Hall 2F", "events");
    settings.SetToolTip("fbhthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("fbhfourteen", true, "Room 203", "events");
    settings.SetToolTip("fbhfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("fbhfifteen", true, "Main Hall 2F", "events");
    settings.SetToolTip("fbhfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("fbhsixteen", true, "Room 202", "events");
    settings.SetToolTip("fbhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("fbhseventeen", true, "Main Hall 2F", "events");
    settings.SetToolTip("fbhseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("fbheighteen", true, "Administrator's Office", "events");
    settings.SetToolTip("fbheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("fbhnineteen", true, "Auxiliary Building 3F", "events");
    settings.SetToolTip("fbhnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("fbhtwenty", true, "Main Building Rooftop", "events");
    settings.SetToolTip("fbhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("fbhtwentyOne", true, "Room 202", "events");
    settings.SetToolTip("fbhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("fbhtwentyTwo", true, "Main Hall 2F", "events");
    settings.SetToolTip("fbhtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("fbhtwentyThree", true, "Main Hall 1F", "events");
    settings.SetToolTip("fbhtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("fbhtwentyFour", true, "Auxiliary Hall 1F", "events");
    settings.SetToolTip("fbhtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("fbhtwentyFive", true, "Auxiliary North Hall", "events");
    settings.SetToolTip("fbhtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("fbhtwentySix", true, "Auxiliary Hall 2F", "events");
    settings.SetToolTip("fbhtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("fbhtwentySeven", true, "Maintenance Access Route", "events");
    settings.SetToolTip("fbhtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("fbhtwentyEight", true, "Auxiliary Hall 5F", "events");
    settings.SetToolTip("fbhtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("fbhtwentyNine", true, "Auxiliary Rooftop", "events");
    settings.SetToolTip("fbhtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("fbhthirty", true, "Auxiliary Hall 5F", "events");
    settings.SetToolTip("fbhthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("fbhthirtyOne", true, "Maintenance Access Route", "events");
    settings.SetToolTip("fbhthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("fbhthirtyTwo", true, "Auxiliary Hall 2F", "events");
    settings.SetToolTip("fbhthirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("fbhthirtyThree", true, "Storage Room", "events");
    settings.SetToolTip("fbhthirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("fbhthirtyFour", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbhthirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("fbhthirtyFive", true, "Auxiliary North Hall", "events");
    settings.SetToolTip("fbhthirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("fbhthirtySix", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbhthirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("fbhthirtySeven", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbhthirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("fbhthirtyEight", true, "Intensive Care Unit", "events");
    settings.SetToolTip("fbhthirtyEight", "Splits when the leaving the 38th room");

    vars.AddSplit("fbhthirtyNine", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbhthirtyNine", "Splits when the leaving the 39th room");

    vars.AddSplit("fbhforty", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbhforty", "Splits when the leaving the 40th room");





    vars.AddSplit("fbvhone", true, "Cabin", "events");
    settings.SetToolTip("fbvhone", "Splits when the leaving the 1st room");

    vars.AddSplit("fbvhtwo", true, "In Front Of Cabin", "events");
    settings.SetToolTip("fbvhtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("fbvhthree", true, "Mountain Path", "events");
    settings.SetToolTip("fbvhthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("fbvhfour", true, "Susp. Bridge", "events");
    settings.SetToolTip("fbvhfour", "Splits when the leaving the 4th room");

    vars.AddSplit("fbvhfive", true, "Hospital Back Gate", "events");
    settings.SetToolTip("fbvhfive", "Splits when the leaving the 5th room");


    vars.AddSplit("fbvhhallOne", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbvhhallOne", "Splits when the leaving room");

    vars.AddSplit("fbvhrecep", true, "Reception Office", "events");
    settings.SetToolTip("fbvhrecep", "Splits when the leavin room");

    vars.AddSplit("fbvhexam", true, "Examination Room", "events");
    settings.SetToolTip("fbvhexam", "Splits when the leaving room");

    vars.AddSplit("fbvhoffice", true, "Reception Office", "events");
    settings.SetToolTip("fbvhoffice", "Splits when the leaving room");


    vars.AddSplit("fbvhsix", true, "Main Building 1F Hall", "events");
    settings.SetToolTip("fbvhsix", "Splits when the leaving the 6th room");

    vars.AddSplit("fbvhseven", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbvhseven", "Splits when the leaving the 7th room");

    vars.AddSplit("fbvheight", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbvheight", "Splits when the leaving the 8th room");

    vars.AddSplit("fbvhnine", true, "Pharmacy", "events");
    settings.SetToolTip("fbvhnine", "Splits when the leaving the 9th room");

    vars.AddSplit("fbvhten", true, "Auxiliary Hall B1F", "events");
    settings.SetToolTip("fbvhten", "Splits when the leaving the 10th room");

    vars.AddSplit("fbvheleven", true, "Auxiliary Hall 1F", "events");
    settings.SetToolTip("fbvheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("fbvhtwelve", true, "Main Hall 1F", "events");
    settings.SetToolTip("fbvhtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("fbvhthirteen", true, "Main Hall 2F", "events");
    settings.SetToolTip("fbvhthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("fbvhfourteen", true, "Room 203", "events");
    settings.SetToolTip("fbvhfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("fbvhfifteen", true, "Main Hall 2F", "events");
    settings.SetToolTip("fbvhfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("fbvhsixteen", true, "Room 202", "events");
    settings.SetToolTip("fbvhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("fbvhseventeen", true, "Main Hall 2F", "events");
    settings.SetToolTip("fbvhseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("fbvheighteen", true, "Administrator's Office", "events");
    settings.SetToolTip("fbvheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("fbvhnineteen", true, "Auxiliary Building 3F", "events");
    settings.SetToolTip("fbvhnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("fbvhtwenty", true, "Main Building Rooftop", "events");
    settings.SetToolTip("fbvhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("fbvhtwentyOne", true, "Room 202", "events");
    settings.SetToolTip("fbvhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("fbvhtwentyTwo", true, "Main Hall 2F", "events");
    settings.SetToolTip("fbvhtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("fbvhtwentyThree", true, "Main Hall 1F", "events");
    settings.SetToolTip("fbvhtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("fbvhtwentyFour", true, "Auxiliary Hall 1F", "events");
    settings.SetToolTip("fbvhtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("fbvhtwentyFive", true, "Auxiliary North Hall", "events");
    settings.SetToolTip("fbvhtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("fbvhtwentySix", true, "Auxiliary Hall 2F", "events");
    settings.SetToolTip("fbvhtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("fbvhtwentySeven", true, "Maintenance Access Route", "events");
    settings.SetToolTip("fbvhtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("fbvhtwentyEight", true, "Auxiliary Hall 5F", "events");
    settings.SetToolTip("fbvhtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("fbvhtwentyNine", true, "Auxiliary Rooftop", "events");
    settings.SetToolTip("fbvhtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("fbvhthirty", true, "Auxiliary Hall 5F", "events");
    settings.SetToolTip("fbvhthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("fbvhthirtyOne", true, "Maintenance Access Route", "events");
    settings.SetToolTip("fbvhthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("fbvhthirtyTwo", true, "Auxiliary Hall 2F", "events");
    settings.SetToolTip("fbvhthirtyTwo", "Splits when the leaving the 32nd room");


    vars.AddSplit("fbvhthirtyFive", true, "Auxiliary North Hall", "events");
    settings.SetToolTip("fbvhthirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("fbvhthirtySix", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbvhthirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("fbvhthirtySeven", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbvhthirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("fbvhthirtyEight", true, "Intensive Care Unit", "events");
    settings.SetToolTip("fbvhthirtyEight", "Splits when the leaving the 38th room");

    vars.AddSplit("fbvhthirtyNine", true, "Auxiliary Building B1F Hall", "events");
    settings.SetToolTip("fbvhthirtyNine", "Splits when the leaving the 39th room");

    vars.AddSplit("fbvhforty", true, "Auxiliary Building 1F Hall", "events");
    settings.SetToolTip("fbvhforty", "Splits when the leaving the 40th room");






    vars.AddSplit("dteone", true, "Main Hall", "events");
    settings.SetToolTip("dteone", "Splits when the leaving the 1st room");

    vars.AddSplit("dtetwo", true, "Reception Desk", "events");
    settings.SetToolTip("dtetwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("dtethree", true, "Main Hall", "events");
    settings.SetToolTip("dtethree", "Splits when the leaving the 3rd room");

    vars.AddSplit("dtefour", true, "1F Lobby", "events");
    settings.SetToolTip("dtefour", "Splits when the leaving the 4th room");

    vars.AddSplit("dtefive", true, "East Office", "events");
    settings.SetToolTip("dtefive", "Splits when the leaving the 5th room");

    vars.AddSplit("dtesix", true, "Emergency Stairs", "events");
    settings.SetToolTip("dtesix", "Splits when the leaving the 6th room");

    vars.AddSplit("dteseven", true, "2F East Hall", "events");
    settings.SetToolTip("dteseven", "Splits when the leaving the 7th room");

    vars.AddSplit("dteeight", true, "Waiting Room", "events");
    settings.SetToolTip("dteeight", "Splits when the leaving the 8th room");

    vars.AddSplit("dtenine", true, "2F East Hall", "events");
    settings.SetToolTip("dtenine", "Splits when the leaving the 9th room");

    vars.AddSplit("dteten", true, "Emergency Stairs", "events");
    settings.SetToolTip("dteten", "Splits when the leaving the 10th room");

    vars.AddSplit("dteeleven", true, "East Office", "events");
    settings.SetToolTip("dteeleven", "Splits when the leaving the 11th room");

    vars.AddSplit("dtetwelve", true, "1F East Hall", "events");
    settings.SetToolTip("dtetwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("dtethirteen", true, "B1F East Hall", "events");
    settings.SetToolTip("dtethirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("dtefourteen", true, "Substation Room", "events");
    settings.SetToolTip("dtefourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("dtefifteen", true, "B1F East Hall", "events");
    settings.SetToolTip("dtefifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("dtesixteen", true, "Substation Room", "events");
    settings.SetToolTip("dtesixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("dteseventeen", true, "B1F West Hall", "events");
    settings.SetToolTip("dteseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("dteeighteen", true, "Holding Cells", "events");
    settings.SetToolTip("dteeighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("dtenineteen", true, "B1F West Hall", "events");
    settings.SetToolTip("dtenineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("dtetwenty", true, "Parking Garage", "events");
    settings.SetToolTip("dtetwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("dtetwentyOne", true, "Front Gate", "events");
    settings.SetToolTip("dtetwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("dtetwentyTwo", true, "Main Hall", "events");
    settings.SetToolTip("dtetwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("dtetwentyThree", true, "Waiting Room", "events");
    settings.SetToolTip("dtetwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("dtetwentyFour", true, "Main Hall", "events");
    settings.SetToolTip("dtetwentyFour", "Splits when the leaving the 24th room");






    vars.AddSplit("dtnone", true, "East Office", "events");
    settings.SetToolTip("dtnone", "Splits when the leaving the 1st room");

    vars.AddSplit("dtntwo", true, "Emergency Stairs", "events");
    settings.SetToolTip("dtntwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("dtnthree", true, "2F East Hall", "events");
    settings.SetToolTip("dtnthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("dtnfour", true, "Waiting Room", "events");
    settings.SetToolTip("dtnfour", "Splits when the leaving the 4th room");

    vars.AddSplit("dtnfive", true, "2F East Hall", "events");
    settings.SetToolTip("dtnfive", "Splits when the leaving the 5th room");

    vars.AddSplit("dtnsix", true, "Emergency Stairs", "events");
    settings.SetToolTip("dtnsix", "Splits when the leaving the 6th room");

    vars.AddSplit("dtnseven", true, "East Office", "events");
    settings.SetToolTip("dtnseven", "Splits when the leaving the 7th room");

    vars.AddSplit("dtneight", true, "1F East Hall", "events");
    settings.SetToolTip("dtneight", "Splits when the leaving the 8th room");

    vars.AddSplit("dtnnine", true, "B1F East Hall", "events");
    settings.SetToolTip("dtnnine", "Splits when the leaving the 9th room");

    vars.AddSplit("dtnten", true, "Substation Room", "events");
    settings.SetToolTip("dtnten", "Splits when the leaving the 10th room");

    vars.AddSplit("dtneleven", true, "B1F East Hall", "events");
    settings.SetToolTip("dtneleven", "Splits when the leaving the 11th room");

    vars.AddSplit("dtntwelve", true, "Parking Garage", "events");
    settings.SetToolTip("dtntwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("dtnthirteen", true, "B1F West Hall", "events");
    settings.SetToolTip("dtnthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("dtnfourteen", true, "Holding Cells", "events");
    settings.SetToolTip("dtnfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("dtnfifteen", true, "B1F West Hall", "events");
    settings.SetToolTip("dtnfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("dtnsixteen", true, "Parking Garage", "events");
    settings.SetToolTip("dtnsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("dtnseventeen", true, "Front Gate", "events");
    settings.SetToolTip("dtnseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("dtneighteen", true, "Main Hall", "events");
    settings.SetToolTip("dtneighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("dtnnineteen", true, "Reception Desk", "events");
    settings.SetToolTip("dtnnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("dtntwenty", true, "Main Hall", "events");
    settings.SetToolTip("dtntwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("dtntwentyOne", true, "1F Lobby", "events");
    settings.SetToolTip("dtntwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("dtntwentyTwo", true, "East Office", "events");
    settings.SetToolTip("dtntwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("dtntwentyThree", true, "1F Lobby", "events");
    settings.SetToolTip("dtntwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("dtntwentyFour", true, "Interrogation Hallway", "events");
    settings.SetToolTip("dtntwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("dtntwentyFive", true, "Interrogation Room", "events");
    settings.SetToolTip("dtntwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("dtntwentySix", true, "Interrogation Hallway", "events");
    settings.SetToolTip("dtntwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("dtntwentySeven", true, "1F Lobby", "events");
    settings.SetToolTip("dtntwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("dtntwentyEight", true, "Main Hall", "events");
    settings.SetToolTip("dtntwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("dtntwentyNine", true, "Waiting Room", "events");
    settings.SetToolTip("dtntwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("dtnthirty", true, "Main Hall", "events");
    settings.SetToolTip("dtnthirty", "Splits when the leaving the 30th room");







    vars.AddSplit("dthone", true, "Parking Garage", "events");
    settings.SetToolTip("dthone", "Splits when the leaving the 1st room");

    vars.AddSplit("dthtwo", true, "B1F East Hall", "events");
    settings.SetToolTip("dthtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("dththree", true, "Autopsy Room", "events");
    settings.SetToolTip("dththree", "Splits when the leaving the 3rd room");

    vars.AddSplit("dthfour", true, "B1F East Hall", "events");
    settings.SetToolTip("dthfour", "Splits when the leaving the 4th room");

    vars.AddSplit("dthfive", true, "Parking Garage", "events");
    settings.SetToolTip("dthfive", "Splits when the leaving the 5th room");

    vars.AddSplit("dthsix", true, "Front Gate", "events");
    settings.SetToolTip("dthsix", "Splits when the leaving the 6th room");

    vars.AddSplit("dthseven", true, "Main Hall", "events");
    settings.SetToolTip("dthseven", "Splits when the leaving the 7th room");

    vars.AddSplit("dtheight", true, "Reception Desk", "events");
    settings.SetToolTip("dtheight", "Splits when the leaving the 8th room");

    vars.AddSplit("dthnine", true, "Main Hall", "events");
    settings.SetToolTip("dthnine", "Splits when the leaving the 9th room");

    vars.AddSplit("dthten", true, "1F Lobby", "events");
    settings.SetToolTip("dthten", "Splits when the leaving the 10th room");

    vars.AddSplit("dtheleven", true, "Interrogation Hallway", "events");
    settings.SetToolTip("dtheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("dthtwelve", true, "Interrogation Room", "events");
    settings.SetToolTip("dthtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("dththirteen", true, "Interrogation Hallway", "events");
    settings.SetToolTip("dththirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("dthfourteen", true, "1F Lobby", "events");
    settings.SetToolTip("dthfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("dthfifteen", true, "East Office", "events");
    settings.SetToolTip("dthfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("dthsixteen", true, "Emergency Stairs", "events");
    settings.SetToolTip("dthsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("dthseventeen", true, "2F East Hall", "events");
    settings.SetToolTip("dthseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("dtheighteen", true, "Waiting Room", "events");
    settings.SetToolTip("dtheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("dthnineteen", true, "2F East Hall", "events");
    settings.SetToolTip("dthnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("dthtwenty", true, "Emergency Stairs", "events");
    settings.SetToolTip("dthtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("dthtwentyOne", true, "East Office", "events");
    settings.SetToolTip("dthtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("dthtwentyTwo", true, "1F East Hall", "events");
    settings.SetToolTip("dthtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("dthtwentyThree", true, "Night-Duty Room", "events");
    settings.SetToolTip("dthtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("dthtwentyFour", true, "1F East Hall", "events");
    settings.SetToolTip("dthtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("dthtwentyFive", true, "B1F East Hall", "events");
    settings.SetToolTip("dthtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("dthtwentySix", true, "Parking Garage", "events");
    settings.SetToolTip("dthtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("dthtwentySeven", true, "B1F East Hall", "events");
    settings.SetToolTip("dthtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("dthtwentyEight", true, "Kennel", "events");
    settings.SetToolTip("dthtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("dthtwentyNine", true, "B1F West Hall", "events");
    settings.SetToolTip("dthtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("dththirty", true, "Holding Cells", "events");
    settings.SetToolTip("dththirty", "Splits when the leaving the 30th room");

    vars.AddSplit("dththirtyOne", true, "B1F West Hall", "events");
    settings.SetToolTip("dththirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("dththirtyTwo", true, "Parking Garage", "events");
    settings.SetToolTip("dththirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("dththirtyThree", true, "Front Gate", "events");
    settings.SetToolTip("dththirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("dththirtyFour", true, "Main Hall", "events");
    settings.SetToolTip("dththirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("dththirtyFive", true, "Waiting Room", "events");
    settings.SetToolTip("dththirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("dththirtySix", true, "Main Hall", "events");
    settings.SetToolTip("dththirtySix", "Splits when the leaving the 36th room");







    vars.AddSplit("dtvhone", true, "Waiting Room", "events");
    settings.SetToolTip("dtvhone", "Splits when the leaving the 1st room");

    vars.AddSplit("dtvhtwo", true, "2F East Hall", "events");
    settings.SetToolTip("dtvhtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("dtvhthree", true, "Stairs", "events");
    settings.SetToolTip("dtvhthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("dtvhfour", true, "East Office", "events");
    settings.SetToolTip("dtvhfour", "Splits when the leaving the 4th room");

    vars.AddSplit("dtvhfive", true, "1F East Hall", "events");
    settings.SetToolTip("dtvhfive", "Splits when the leaving the 5th room");

    vars.AddSplit("dtvhsix", true, "Night Duty Room", "events");
    settings.SetToolTip("dtvhsix", "Splits when the leaving the 6th room");

    vars.AddSplit("dtvhseven", true, "1F East Hall", "events");
    settings.SetToolTip("dtvhseven", "Splits when the leaving the 7th room");

    vars.AddSplit("dtvheight", true, "East Office", "events");
    settings.SetToolTip("dtvheight", "Splits when the leaving the 8th room");

    vars.AddSplit("dtvhnine", true, "1F Lobby", "events");
    settings.SetToolTip("dtvhnine", "Splits when the leaving the 9th room");

    vars.AddSplit("dtvhten", true, "Interrogation Hall", "events");
    settings.SetToolTip("dtvhten", "Splits when the leaving the 10th room");

    vars.AddSplit("dtvheleven", true, "Interrogation Room", "events");
    settings.SetToolTip("dtvheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("dtvhtwelve", true, "Interrogation Hall", "events");
    settings.SetToolTip("dtvhtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("dtvhthirteen", true, "1F Lobby", "events");
    settings.SetToolTip("dtvhthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("dtvhfourteen", true, "Main Hall", "events");
    settings.SetToolTip("dtvhfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("dtvhfifteen", true, "Reception", "events");
    settings.SetToolTip("dtvhfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("dtvhsixteen", true, "Main Hall", "events");
    settings.SetToolTip("dtvhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("dtvhseventeen", true, "Waiting Room", "events");
    settings.SetToolTip("dtvhseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("dtvheighteen", true, "Main Hall", "events");
    settings.SetToolTip("dtvheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("dtvhnineteen", true, "1F Lobby", "events");
    settings.SetToolTip("dtvhnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("dtvhtwenty", true, "East Office", "events");
    settings.SetToolTip("dtvhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("dtvhtwentyOne", true, "Stairs", "events");
    settings.SetToolTip("dtvhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("dtvhtwentyTwo", true, "2F East Hall", "events");
    settings.SetToolTip("dtvhtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("dtvhtwentyThree", true, "Waiting Room", "events");
    settings.SetToolTip("dtvhtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("dtvhtwentyFour", true, "2F East Hall", "events");
    settings.SetToolTip("dtvhtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("dtvhtwentyFive", true, "Stairs", "events");
    settings.SetToolTip("dtvhtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("dtvhtwentySix", true, "East Office", "events");
    settings.SetToolTip("dtvhtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("dtvhtwentySeven", true, "1F East Hall", "events");
    settings.SetToolTip("dtvhtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("dtvhtwentyEight", true, "B1F East Hall", "events");
    settings.SetToolTip("dtvhtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("dtvhtwentyNine", true, "Autopsy", "events");
    settings.SetToolTip("dtvhtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("dtvhthirty", true, "B1F East Hall", "events");
    settings.SetToolTip("dtvhthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("dtvhthirtyOne", true, "Parking Garage", "events");
    settings.SetToolTip("dtvhthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("dtvhthirtyTwo", true, "B1F West Hall", "events");
    settings.SetToolTip("dtvhthirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("dtvhthirtyThree", true, "Kennel", "events");
    settings.SetToolTip("dtvhthirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("dtvhthirtyFour", true, "B1F West Hall", "events");
    settings.SetToolTip("dtvhthirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("dtvhthirtyFive", true, "Cells", "events");
    settings.SetToolTip("dtvhthirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("dtvhthirtySix", true, "B1F West Hall", "events");
    settings.SetToolTip("dtvhthirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("dtvhthirtySeven", true, "Parking Garage", "events");
    settings.SetToolTip("dtvhthirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("dtvhthirtyEight", true, "Front Gate", "events");
    settings.SetToolTip("dtvhthirtyEight", "Splits when the leaving the 38th room");

    vars.AddSplit("dtvhthirtyNine", true, "Main Hall", "events");
    settings.SetToolTip("dtvhthirtyNine", "Splits when the leaving the 39th room");








    vars.AddSplit("etrone", true, "Waiting Room", "events");
    settings.SetToolTip("etrone", "Splits when the leaving the 1st room");

    vars.AddSplit("etrtwo", true, "Central Passage 1", "events");
    settings.SetToolTip("etrtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("etrthree", true, "East Passage 1", "events");
    settings.SetToolTip("etrthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("etrfour", true, "Reference Room", "events");
    settings.SetToolTip("etrfour", "Splits when the leaving the 4th room");

    vars.AddSplit("etrfive", true, "East Passage 1", "events");
    settings.SetToolTip("etrfive", "Splits when the leaving the 5th room");

    vars.AddSplit("etrsix", true, "Central Passage 1", "events");
    settings.SetToolTip("etrsix", "Splits when the leaving the 6th room");

    vars.AddSplit("etrseven", true, "Waiting Room", "events");
    settings.SetToolTip("etrseven", "Splits when the leaving the 7th room");

    vars.AddSplit("etreight", true, "Examination Room", "events");
    settings.SetToolTip("etreight", "Splits when the leaving the 8th room");

    vars.AddSplit("etrnine", true, "Central Passage 2", "events");
    settings.SetToolTip("etrnine", "Splits when the leaving the 9th room");

    vars.AddSplit("etrten", true, "West Passage", "events");
    settings.SetToolTip("etrten", "Splits when the leaving the 10th room");

    vars.AddSplit("etreleven", true, "Laser Emission Room", "events");
    settings.SetToolTip("etreleven", "Splits when the leaving the 11th room");

    vars.AddSplit("etrtwelve", true, "West Passage", "events");
    settings.SetToolTip("etrtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("etrthirteen", true, "Central Passage 2", "events");
    settings.SetToolTip("etrthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("etrfourteen", true, "Laser Emission Room", "events");
    settings.SetToolTip("etrfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("etrfifteen", true, "Central Passage 3", "events");
    settings.SetToolTip("etrfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("etrsixteen", true, "Central Passage 2", "events");
    settings.SetToolTip("etrsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("etrseventeen", true, "Central Passage 1", "events");
    settings.SetToolTip("etrseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("etreighteen", true, "Experimentation Chamber", "events");
    settings.SetToolTip("etreighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("etrnineteen", true, "Observation Mezzanine", "events");
    settings.SetToolTip("etrnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("etrtwenty", true, "Stairwell", "events");
    settings.SetToolTip("etrtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("etrtwentyOne", true, "Central Passage 4", "events");
    settings.SetToolTip("etrtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("etrtwentyTwo", true, "Central Passage 1", "events");
    settings.SetToolTip("etrtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("etrtwentyThree", true, "Mainframe", "events");
    settings.SetToolTip("etrtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("etrtwentyFour", true, "Central Passage 1", "events");
    settings.SetToolTip("etrtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("etrtwentyFive", true, "Central Passage 4", "events");
    settings.SetToolTip("etrtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("etrtwentySix", true, "Stairwell", "events");
    settings.SetToolTip("etrtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("etrtwentySeven", true, "Observation Mezzanine", "events");
    settings.SetToolTip("etrtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("etrtwentyEight", true, "Experimentation Chamber", "events");
    settings.SetToolTip("etrtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("etrtwentyNine", true, "Central Passage 1", "events");
    settings.SetToolTip("etrtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("etrthirty", true, "East Passage 1", "events");
    settings.SetToolTip("etrthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("etrthirtyOne", true, "East Passage 2", "events");
    settings.SetToolTip("etrthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("etrthirtyTwo", true, "East Passage 3", "events");
    settings.SetToolTip("etrthirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("etrthirtyThree", true, "East Exit", "events");
    settings.SetToolTip("etrthirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("etrthirtyFour", true, "East Passage 3", "events");
    settings.SetToolTip("etrthirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("etrthirtyFive", true, "East Passage 2", "events");
    settings.SetToolTip("etrthirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("etrthirtySix", true, "Special Research Room", "events");
    settings.SetToolTip("etrthirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("etrthirtySeven", true, "East Passage 1", "events");
    settings.SetToolTip("etrthirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("etrthirtyEight", true, "Elevator Room", "events");
    settings.SetToolTip("etrthirtyEight", "Splits when the leaving the 38th room");

    vars.AddSplit("etrthirtyNine", true, "Underground Waterworks", "events");
    settings.SetToolTip("etrthirtyNine", "Splits when the leaving the 39th room");

    vars.AddSplit("etrforty", true, "Drainage Area", "events");
    settings.SetToolTip("etrforty", "Splits when the leaving the 40th room");

    vars.AddSplit("etrfortyOne", true, "Maintenance Room", "events");
    settings.SetToolTip("etrfortyOne", "Splits when the leaving the 41st room");

    vars.AddSplit("etrfortyTwo", true, "Underground Waterworks", "events");
    settings.SetToolTip("etrfortyTwo", "Splits when the leaving the 42nd room");

    vars.AddSplit("etrfortyThree", true, "Floodgate Control Room", "events");
    settings.SetToolTip("etrfortyThree", "Splits when the leaving the 43rd room");

    vars.AddSplit("etrfortyFour", true, "Emergency Materials Storage", "events");
    settings.SetToolTip("etrfortyFour", "Splits when the leaving the 44th room");

    vars.AddSplit("etrfortyFive", true, "Maintenance Passage 3", "events");
    settings.SetToolTip("etrfortyFive", "Splits when the leaving the 45th room");

    vars.AddSplit("etrfortySix", true, "Old Waterway", "events");
    settings.SetToolTip("etrfortySix", "Splits when the leaving the 46th room");

    vars.AddSplit("etrfortySeven", true, "Linda Cutscene", "events");
    settings.SetToolTip("etrfortySeven", "Splits when the leaving the 47th room");

    vars.AddSplit("etrfortyEight", true, "Tunnel", "events");
    settings.SetToolTip("etrfortyEight", "Splits when the leaving the 48th room");

    vars.AddSplit("etrfortyNine", true, "In Front of Apple Inn", "events");
    settings.SetToolTip("etrfortyNine", "Splits when the leaving the 49th room");

    vars.AddSplit("etrfifty", true, "Construction Site", "events");
    settings.SetToolTip("etrfifty", "Splits when the leaving the 50th room");

    vars.AddSplit("etrfiftyOne", true, "Under The Highway Overpass", "events");
    settings.SetToolTip("etrfiftyOne", "Splits when the leaving the 51st room");

    vars.AddSplit("etroffice", true, "Office Cutscene", "events");
    settings.SetToolTip("etroffice", "Splits when Office Cutscene plays");




    vars.AddSplit("etrhone", true, "Waiting Room", "events");
    settings.SetToolTip("etrhone", "Splits when the leaving the 1st room");

    vars.AddSplit("etrhtwo", true, "Central Passage 1", "events");
    settings.SetToolTip("etrhtwo", "Splits when the leaving the 2nd room");

    vars.AddSplit("etrhthree", true, "East Passage 1", "events");
    settings.SetToolTip("etrhthree", "Splits when the leaving the 3rd room");

    vars.AddSplit("etrhfour", true, "Reference Room", "events");
    settings.SetToolTip("etrhfour", "Splits when the leaving the 4th room");

    vars.AddSplit("etrhfive", true, "East Passage 1", "events");
    settings.SetToolTip("etrhfive", "Splits when the leaving the 5th room");

    vars.AddSplit("etrhsix", true, "Central Passage 1", "events");
    settings.SetToolTip("etrhsix", "Splits when the leaving the 6th room");

    vars.AddSplit("etrhseven", true, "Waiting Room", "events");
    settings.SetToolTip("etrhseven", "Splits when the leaving the 7th room");

    vars.AddSplit("etrheight", true, "Examination Room", "events");
    settings.SetToolTip("etrheight", "Splits when the leaving the 8th room");

    vars.AddSplit("etrhnine", true, "Central Passage 2", "events");
    settings.SetToolTip("etrhnine", "Splits when the leaving the 9th room");

    vars.AddSplit("etrhten", true, "West Passage", "events");
    settings.SetToolTip("etrhten", "Splits when the leaving the 10th room");

    vars.AddSplit("etrheleven", true, "Laser Emission Room", "events");
    settings.SetToolTip("etrheleven", "Splits when the leaving the 11th room");

    vars.AddSplit("etrhtwelve", true, "West Passage", "events");
    settings.SetToolTip("etrhtwelve", "Splits when the leaving the 12th room");

    vars.AddSplit("etrhthirteen", true, "Central Passage 2", "events");
    settings.SetToolTip("etrhthirteen", "Splits when the leaving the 13th room");

    vars.AddSplit("etrhfourteen", true, "Laser Emission Room", "events");
    settings.SetToolTip("etrhfourteen", "Splits when the leaving the 14th room");

    vars.AddSplit("etrhfifteen", true, "Central Passage 3", "events");
    settings.SetToolTip("etrhfifteen", "Splits when the leaving the 15th room");

    vars.AddSplit("etrhsixteen", true, "Central Passage 2", "events");
    settings.SetToolTip("etrhsixteen", "Splits when the leaving the 16th room");

    vars.AddSplit("etrhseventeen", true, "Central Passage 1", "events");
    settings.SetToolTip("etrhseventeen", "Splits when the leaving the 17th room");

    vars.AddSplit("etrheighteen", true, "Experimentation Chamber", "events");
    settings.SetToolTip("etrheighteen", "Splits when the leaving the 18th room");

    vars.AddSplit("etrhnineteen", true, "Observation Mezzanine", "events");
    settings.SetToolTip("etrhnineteen", "Splits when the leaving the 19th room");

    vars.AddSplit("etrhtwenty", true, "Stairwell", "events");
    settings.SetToolTip("etrhtwenty", "Splits when the leaving the 20th room");

    vars.AddSplit("etrhtwentyOne", true, "Central Passage 4", "events");
    settings.SetToolTip("etrhtwentyOne", "Splits when the leaving the 21st room");

    vars.AddSplit("etrhtwentyTwo", true, "Central Passage 1", "events");
    settings.SetToolTip("etrhtwentyTwo", "Splits when the leaving the 22nd room");

    vars.AddSplit("etrhtwentyThree", true, "Mainframe", "events");
    settings.SetToolTip("etrhtwentyThree", "Splits when the leaving the 23rd room");

    vars.AddSplit("etrhtwentyFour", true, "Central Passage 1", "events");
    settings.SetToolTip("etrhtwentyFour", "Splits when the leaving the 24th room");

    vars.AddSplit("etrhtwentyFive", true, "Central Passage 4", "events");
    settings.SetToolTip("etrhtwentyFive", "Splits when the leaving the 25th room");

    vars.AddSplit("etrhtwentySix", true, "Stairwell", "events");
    settings.SetToolTip("etrhtwentySix", "Splits when the leaving the 26th room");

    vars.AddSplit("etrhtwentySeven", true, "Observation Mezzanine", "events");
    settings.SetToolTip("etrhtwentySeven", "Splits when the leaving the 27th room");

    vars.AddSplit("etrhtwentyEight", true, "Experimentation Chamber", "events");
    settings.SetToolTip("etrhtwentyEight", "Splits when the leaving the 28th room");

    vars.AddSplit("etrhtwentyNine", true, "Central Passage 1", "events");
    settings.SetToolTip("etrhtwentyNine", "Splits when the leaving the 29th room");

    vars.AddSplit("etrhthirty", true, "East Passage 1", "events");
    settings.SetToolTip("etrhthirty", "Splits when the leaving the 30th room");

    vars.AddSplit("etrhthirtyOne", true, "East Passage 2", "events");
    settings.SetToolTip("etrhthirtyOne", "Splits when the leaving the 31st room");

    vars.AddSplit("etrhthirtyTwo", true, "East Passage 3", "events");
    settings.SetToolTip("etrhthirtyTwo", "Splits when the leaving the 32nd room");

    vars.AddSplit("etrhthirtyThree", true, "East Exit", "events");
    settings.SetToolTip("etrhthirtyThree", "Splits when the leaving the 33rd room");

    vars.AddSplit("etrhthirtyFour", true, "East Passage 3", "events");
    settings.SetToolTip("etrhthirtyFour", "Splits when the leaving the 34th room");

    vars.AddSplit("etrhthirtyFive", true, "East Passage 2", "events");
    settings.SetToolTip("etrhthirtyFive", "Splits when the leaving the 35th room");

    vars.AddSplit("etrhthirtySix", true, "Special Research Room", "events");
    settings.SetToolTip("etrhthirtySix", "Splits when the leaving the 36th room");

    vars.AddSplit("etrhthirtySeven", true, "East Passage 1", "events");
    settings.SetToolTip("etrhthirtySeven", "Splits when the leaving the 37th room");

    vars.AddSplit("etrhthirtyEight", true, "Elevator Room", "events");
    settings.SetToolTip("etrhthirtyEight", "Splits when the leaving the 38th room");

    vars.AddSplit("etrhthirtyNine", true, "Underground Waterworks", "events");
    settings.SetToolTip("etrhthirtyNine", "Splits when the leaving the 39th room");

    vars.AddSplit("etrhforty", true, "Drainage Area", "events");
    settings.SetToolTip("etrhforty", "Splits when the leaving the 40th room");

    vars.AddSplit("etrhfortyOne", true, "Maintenance Room", "events");
    settings.SetToolTip("etrhfortyOne", "Splits when the leaving the 41st room");

    vars.AddSplit("etrhfortyTwo", true, "Underground Waterworks", "events");
    settings.SetToolTip("etrhfortyTwo", "Splits when the leaving the 42nd room");

    vars.AddSplit("etrhfortyThree", true, "Floodgate Control Room", "events");
    settings.SetToolTip("etrhfortyThree", "Splits when the leaving the 43rd room");

    vars.AddSplit("etrhfortyFour", true, "Emergency Materials Storage", "events");
    settings.SetToolTip("etrhfortyFour", "Splits when the leaving the 44th room");

    vars.AddSplit("etrhfortyFive", true, "Maintenance Passage 3", "events");
    settings.SetToolTip("etrhfortyFive", "Splits when the leaving the 45th room");

    vars.AddSplit("etrhfortySix", true, "Old Waterway", "events");
    settings.SetToolTip("etrhfortySix", "Splits when the leaving the 46th room");

    vars.AddSplit("etrhfortySeven", true, "Linda Cutscene", "events");
    settings.SetToolTip("etrhfortySeven", "Splits when the leaving the 47th room");

    vars.AddSplit("etrhfortyEight", true, "Tunnel", "events");
    settings.SetToolTip("etrhfortyEight", "Splits when the leaving the 48th room");

    vars.AddSplit("etrhfortyNine", true, "In Front of Apple Inn", "events");
    settings.SetToolTip("etrhfortyNine", "Splits when the leaving the 49th room");

    vars.AddSplit("etrhfifty", true, "Construction Site", "events");
    settings.SetToolTip("etrhfifty", "Splits when the leaving the 50th room");

    vars.AddSplit("etrhfiftyOne", true, "Under The Highway Overpass", "events");
    settings.SetToolTip("etrhfiftyOne", "Splits when the leaving the 51st room");

    vars.AddSplit("etrhoffice", true, "Office Cutscene", "events");
    settings.SetToolTip("etrhoffice", "Splits when Office Cutscene plays");



    vars.AddSplit("etrhnursery", true, "Nursery", "events");
    settings.SetToolTip("etrhnursery", "Splits when the leaving the Nursery");

    vars.AddSplit("etrheExit", true, "East Passage 3", "events");
    settings.SetToolTip("etrheExit", "Splits when the Entering East Exit");










    vars.AddSplit("endGame", true, "End Game", "events");
    settings.SetToolTip("endGame", "Splits when the game rank screen displays");



}

init
{
    vars.lastSplit = String.Empty; // Name of the most recent split
    vars.gameProcess = String.Empty; // Used to detect when the process has changed
    vars.productCode = String.Empty; // Used to detect when the game release has changed
    vars.basePointer = IntPtr.Zero; // Emulator virtual memory base pointer
    vars.isBigEndian = false; // Console uses big endian (e.g. PS3 and GCN)

    // Log splits
    vars.LogSplit = (Action<string>)((text) => {
        vars.lastSplit = text;

        string log = timer.CurrentTime[timer.CurrentTimingMethod] + ": " + text;

        if (settings["logSplits"])
            File.AppendAllText(vars.logPath, log + System.Environment.NewLine);

        if (settings["debugSplits"])
            print("recvx split: " + log);
    });

    // Update split status
    vars.UpdateSplit = (Func<string, bool>)((split) => {
        if (!vars.splits[split])
        {
            vars.LogSplit(split);
            vars.splits[split] = true;
            return settings[split];
        }
        else
            return false;
    });

    // Update item split status
    vars.UpdateItemSplit = (Func<byte, bool>)((id) => {
        if (!vars.itemSplits[id])
        {
            vars.LogSplit(vars.itemIndex[id] + " (" + id.ToString() + ")");
            vars.itemSplits[id] = true;
            return settings[vars.itemIndex[id]];
        }
        else
            return false;
    });

    // Sets memory pointers for the detected game release
    vars.UpdatePointers = (Action) (() => {
        switch ((string)vars.productCode)
        {
            default: // SLPM_656.92 [PS2] [JP] Biohazard: outbreak f2
                vars.timePtr = 0x004912B8;
                vars.roomPtr = 0x0047BF12;
                vars.screenPtr = 0x004912A0;
                vars.healthPtr = 0x0047C270;
                vars.statusPtr = 0x0047C8E8;
                vars.pausePtr = 0x004912BE;
                vars.characterPtr = 0x0047C8E0;
                vars.inventoryPtr = 0x0047C9C4;
                vars.bosshpPtr = 0x007612AC;
		vars.scenarioidPtr = 0x003137BA;
		vars.wtbardoorhpPtr = 0x00477726;
		vars.diffPtr = 0x0049135A;
		vars.ekillcountPtr = 0x0049010C;
		vars.eotrventhpPtr = 0x00477B00;
                break;
        }
    });
	
    // Detects if the process has changed
    vars.UpdateProcess = (Action) (() => {
        // Update process name if application has changed
        if (vars.gameProcess != game.ProcessName)
        {
            vars.gameProcess = game.ProcessName;

            // Set emulator edianess
            switch ((string)vars.gameProcess.ToLower())
            {
                default: //pcsx2
                    vars.isBigEndian = false;
                    break;
            }
        }
    });

    // Set emulator base pointer
    vars.UpdatePointer = (Action) (() => {
        switch ((string)vars.gameProcess.ToLower())
        {
            default: // pcsx2
                vars.basePointer = 0x20000000;
                break;
        }
    });

    // Detects if the game release has changed
    vars.UpdateProduct = (Action) (() => {
        string productCode;

        // Read game product code from memory
        switch ((string)vars.gameProcess.ToLower())
        {
            default: //pcsx2
                productCode = memory.ReadString(new IntPtr(vars.basePointer + 0x00015B90), 11);
                break;
        }

        // Update product code if the game release has changed
        if (vars.productCode != productCode)
        {
            vars.productCode = productCode;
            vars.UpdatePointers();
        }
    });

    // Updates game values
    vars.UpdateValues = (Action) (() => {
        uint time = 0; // In Game Timer
        byte room = 0; // Room the character is in
        byte screen = 0; // Current game screen
        uint health = 0; // Character health
        byte status = 0; // Character status info
        byte pause = 0; // pause status info
        byte character = 0; // Character ID
        ushort bosshp = 0; // bosshp
	byte scenarioid = 0; //40 = WT, 10 = UB, 26 = FB, 15 = DT, 6 = EOTR
	ushort wtbardoorhp = 0;
	byte diff = 0;
	byte ekillcount = 0; //number of enemies killed in elimination
	ushort eotrventhp = 0;

        // Read values from memory
        memory.ReadValue<uint>(new IntPtr(vars.basePointer + vars.timePtr), out time);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.roomPtr), out room);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.screenPtr), out screen);
        memory.ReadValue<uint>(new IntPtr(vars.basePointer + vars.healthPtr), out health);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.statusPtr), out status);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.pausePtr), out pause);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.characterPtr), out character);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.bosshpPtr), out bosshp);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.scenarioidPtr), out scenarioid);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.diffPtr), out diff);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.wtbardoorhpPtr), out wtbardoorhp);
        memory.ReadValue<byte>(new IntPtr(vars.basePointer + vars.ekillcountPtr), out ekillcount);
        memory.ReadValue<ushort>(new IntPtr(vars.basePointer + vars.eotrventhpPtr), out eotrventhp);

        current.slot = 0; // Inventory slot number of the equipped item
        current.ammo = 0; // Ammo count for the equipped weapon
        current.time = vars.isBigEndian ? (int)vars.SwapBytesInt(time) : (int)time;
        current.room = room;
        current.screen = screen;
        current.health = vars.isBigEndian ? (int)vars.SwapBytesInt(health) : (int)health;
        current.status = "Normal";
        current.character = character;
        current.inventory = new byte[8]; // Current characters inventory
		current.bosshp = bosshp;
	current.scenarioid = scenarioid;
	current.wtbardoorhp = wtbardoorhp;
	current.diff = diff;
	current.ekillcount = ekillcount;
	current.eotrventhp = eotrventhp;

	if (eotrventhp <= 50)
		current.eotrventhp = "Destroyed";

        // Check status for gassed or poison flags
        if ((status & 0x20) != 0)
            current.status = "Gassed";
        else if ((status & 0x08) != 0)
            current.status = "Poison";

        int index = -1; // Inventory array index

        // Pointer to the current characters inventory table
        IntPtr pointer = new IntPtr(vars.basePointer + vars.inventoryPtr-2);

        // Read inventory of the current character
        for (int i = 0; i < 9; ++i)
        {
            int item = 0; // Inventory entry

            // Read inventory entry from memory
            memory.ReadValue<int>(pointer, out item);

            // Move pointer to the next entry
            pointer = IntPtr.Add(pointer, 0x1);

            // First entry is the slot number of the equipped item
            if (i == 0)
            {
                current.slot = item;
                continue;
            }

            // Remaing entries are inventory items
            byte[] bytes = BitConverter.GetBytes(item);

            // Set inventory index to the item ID
            current.inventory[++index] = bytes[1];

            // Read quantity if this item is equipped
            if (current.slot == (index + 1))
                current.ammo = BitConverter.ToInt16(bytes, 0);
        }
    });

    // Initialise values
    vars.UpdateProcess();
    vars.UpdatePointer();
    vars.UpdateProduct();
    vars.UpdateValues();
}

start
{
    // Start when IGT is 0, in the Prison Cell room and the 1st item slot contains the Lighter
    return (current.time > 0);
}

update
{
    vars.UpdateProcess();
    vars.UpdatePointer();
    vars.UpdateProduct();
    vars.UpdateValues();

    if (timer.CurrentPhase == TimerPhase.NotRunning)
    {
        vars.ResetSplits();
        vars.ResetItemSplits();
    }
}

split
{
    // Split when an inventory entry changes
    for (int i = 0; i < current.inventory.Length; i++)
    {
        byte item = current.inventory[i];

        // Continue if the entry has not changed
        if (item == old.inventory[i]) continue;

        switch (item)
        {
            default: // Split the first time an item is added to the inventory
                if (vars.itemSplits.ContainsKey(item))
                    return vars.UpdateItemSplit(item);
                break;
        }
    }

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 1)
        return vars.UpdateSplit("wteone");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 3 && vars.lastSplit == "wteone" && old.room == 1)
        return vars.UpdateSplit("wtetwo");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 4 && vars.lastSplit == "wtetwo")
        return vars.UpdateSplit("wtethree");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtethree")
        return vars.UpdateSplit("wtefour");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtefour")
        return vars.UpdateSplit("wtefive");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtefive")
        return vars.UpdateSplit("wtesix");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 8 && vars.lastSplit == "wtesix")
        return vars.UpdateSplit("wteseven");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wteseven")
        return vars.UpdateSplit("wteeight");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wteeight")
        return vars.UpdateSplit("wtenine");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtenine")
        return vars.UpdateSplit("wteten");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wteten")
        return vars.UpdateSplit("wteeleven");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wteeleven")
        return vars.UpdateSplit("wtetwelve");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wtetwelve")
        return vars.UpdateSplit("wtethirteen");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wtethirteen")
        return vars.UpdateSplit("wtefourteen");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 16 && vars.lastSplit == "wtefourteen")
        return vars.UpdateSplit("wtefifteen");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 18 && vars.lastSplit == "wtefifteen")
        return vars.UpdateSplit("wtesixteen");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wtesixteen")
        return vars.UpdateSplit("wteseventeen");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 26 && vars.lastSplit == "wteseventeen")
        return vars.UpdateSplit("wteeighteen");

    if (current.diff == 0 && current.scenarioid == 40 && current.room == 27 && vars.lastSplit == "wteeighteen")
        return vars.UpdateSplit("wtenineteen");





    if (current.diff == 1 && current.scenarioid == 40 && current.room == 1)
        return vars.UpdateSplit("wtnone");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 3 && vars.lastSplit == "wtnone")
        return vars.UpdateSplit("wtntwo");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 4 && vars.lastSplit == "wtntwo")
        return vars.UpdateSplit("wtnthree");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtnthree")
        return vars.UpdateSplit("wtnfour");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtnfour")
        return vars.UpdateSplit("wtnfive");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtnfive")
        return vars.UpdateSplit("wtnsix");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 8 && vars.lastSplit == "wtnsix")
        return vars.UpdateSplit("wtnseven");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtnseven")
        return vars.UpdateSplit("wtneight");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtneight")
        return vars.UpdateSplit("wtnnine");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtnnine")
        return vars.UpdateSplit("wtnten");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wtnten")
        return vars.UpdateSplit("wtneleven");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wtneleven")
        return vars.UpdateSplit("wtntwelve");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 16 && vars.lastSplit == "wtntwelve")
        return vars.UpdateSplit("wtnthirteen");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 18 && vars.lastSplit == "wtnthirteen")
        return vars.UpdateSplit("wtnfourteen");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wtnfourteen")
        return vars.UpdateSplit("wtnfifteen");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 21 && vars.lastSplit == "wtnfifteen")
        return vars.UpdateSplit("wtnsixteen");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wtnsixteen")
        return vars.UpdateSplit("wtnseventeen");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtnseventeen")
        return vars.UpdateSplit("wtneighteen");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtneighteen")
        return vars.UpdateSplit("wtnnineteen");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 8 && vars.lastSplit == "wtnnineteen")
        return vars.UpdateSplit("wtntwenty");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtntwenty")
        return vars.UpdateSplit("wtntwentyOne");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtntwentyOne")
        return vars.UpdateSplit("wtntwentyTwo");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtntwentyTwo")
        return vars.UpdateSplit("wtntwentyThree");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wtntwentyThree")
        return vars.UpdateSplit("wtntwentyFour");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wtntwentyFour")
        return vars.UpdateSplit("wtntwentyFive");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 16 && vars.lastSplit == "wtntwentyFive")
        return vars.UpdateSplit("wtntwentySix");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wtntwentySix")
        return vars.UpdateSplit("wtntwentySeven");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wtntwentySeven")
        return vars.UpdateSplit("wtntwentyEight");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtntwentyEight")
        return vars.UpdateSplit("wtntwentyNine");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 4 && vars.lastSplit == "wtntwentyNine")
        return vars.UpdateSplit("wtnthirty");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 23 && vars.lastSplit == "wtnthirty")
        return vars.UpdateSplit("wtnthirtyOne");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 24 && vars.lastSplit == "wtnthirtyOne")
        return vars.UpdateSplit("wtnthirtyTwo");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 25 && vars.lastSplit == "wtnthirtyTwo")
        return vars.UpdateSplit("wtnthirtyThree");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 26 && vars.lastSplit == "wtnthirtyThree")
        return vars.UpdateSplit("wtnthirtyFour");

    if (current.diff == 1 && current.scenarioid == 40 && current.room == 27 && vars.lastSplit == "wtnthirtyFour")
        return vars.UpdateSplit("wtnthirtyFive");






    if (current.diff == 2 && current.scenarioid == 40 && current.room == 2)
        return vars.UpdateSplit("wthone");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 3 && vars.lastSplit == "wthone")
        return vars.UpdateSplit("wthtwo");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 1 && vars.lastSplit == "wthtwo")
        return vars.UpdateSplit("wththree");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 3 && vars.lastSplit == "wththree")
        return vars.UpdateSplit("wthfour");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 4 && vars.lastSplit == "wthfour")
        return vars.UpdateSplit("wthfive");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wthfive")
        return vars.UpdateSplit("wthsix");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wthsix")
        return vars.UpdateSplit("wthseven");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wthseven")
        return vars.UpdateSplit("wtheight");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtheight")
        return vars.UpdateSplit("wthnine");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wthnine")
        return vars.UpdateSplit("wthten");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 8 && vars.lastSplit == "wthten")
        return vars.UpdateSplit("wtheleven");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtheleven")
        return vars.UpdateSplit("wthtwelve");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wthtwelve")
        return vars.UpdateSplit("wththirteen");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 4 && vars.lastSplit == "wththirteen")
        return vars.UpdateSplit("wthfourteen");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 23 && vars.lastSplit == "wthfourteen")
        return vars.UpdateSplit("wthfifteen");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 24 && vars.lastSplit == "wthfifteen")
        return vars.UpdateSplit("wthsixteen");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 25 && vars.lastSplit == "wthsixteen")
        return vars.UpdateSplit("wthseventeen");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 26 && vars.lastSplit == "wthseventeen")
        return vars.UpdateSplit("wtheighteen");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wtheighteen")
        return vars.UpdateSplit("wthnineteen");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 21 && vars.lastSplit == "wthnineteen")
        return vars.UpdateSplit("wthtwenty");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wthtwenty")
        return vars.UpdateSplit("wthtwentyOne");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wthtwentyOne")
        return vars.UpdateSplit("wthtwentyTwo");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wthtwentyTwo")
        return vars.UpdateSplit("wthtwentyThree");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 8 && vars.lastSplit == "wthtwentyThree")
        return vars.UpdateSplit("wthtwentyFour");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wthtwentyFour")
        return vars.UpdateSplit("wthtwentyFive");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wthtwentyFive")
        return vars.UpdateSplit("wthtwentySix");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wthtwentySix")
        return vars.UpdateSplit("wthtwentySeven");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wthtwentySeven")
        return vars.UpdateSplit("wthtwentyEight");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wthtwentyEight")
        return vars.UpdateSplit("wthtwentyNine");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wthtwentyNine")
        return vars.UpdateSplit("wththirty");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wththirty")
        return vars.UpdateSplit("wththirtyOne");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 16 && vars.lastSplit == "wththirtyOne")
        return vars.UpdateSplit("wththirtyTwo");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 18 && vars.lastSplit == "wththirtyTwo")
        return vars.UpdateSplit("wththirtyThree");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wththirtyThree")
        return vars.UpdateSplit("wththirtyFour");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 26 && vars.lastSplit == "wththirtyFour")
        return vars.UpdateSplit("wththirtyFive");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 25 && vars.lastSplit == "wththirtyFive")
        return vars.UpdateSplit("wththirtySix");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 26 && vars.lastSplit == "wththirtySix")
        return vars.UpdateSplit("wththirtySeven");

    if (current.diff == 2 && current.scenarioid == 40 && current.room == 27 && vars.lastSplit == "wththirtySeven")
        return vars.UpdateSplit("wththirtyEight");





    if (current.diff == 3 && current.scenarioid == 40 && current.room == 2)
        return vars.UpdateSplit("wtvhone");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 3 && vars.lastSplit == "wtvhone")
        return vars.UpdateSplit("wtvhtwo");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 4 && vars.lastSplit == "wtvhtwo")
        return vars.UpdateSplit("wtvhthree");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 23 && vars.lastSplit == "wtvhthree")
        return vars.UpdateSplit("wtvhfour");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 24 && vars.lastSplit == "wtvhfour")
        return vars.UpdateSplit("wtvhfive");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 25 && vars.lastSplit == "wtvhfive")
        return vars.UpdateSplit("wtvhsix");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 26 && vars.lastSplit == "wtvhsix")
        return vars.UpdateSplit("wtvhseven");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wtvhseven")
        return vars.UpdateSplit("wtvheight");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 21 && vars.lastSplit == "wtvheight")
        return vars.UpdateSplit("wtvhnine");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wtvhnine")
        return vars.UpdateSplit("wtvhten");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 18 && vars.lastSplit == "wtvhten")
        return vars.UpdateSplit("wtvheleven");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 16 && vars.lastSplit == "wtvheleven")
        return vars.UpdateSplit("wtvhtwelve");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wtvhtwelve")
        return vars.UpdateSplit("wtvhthirteen");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wtvhthirteen")
        return vars.UpdateSplit("wtvhfourteen");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtvhfourteen")
        return vars.UpdateSplit("wtvhfifteen");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtvhfifteen")
        return vars.UpdateSplit("wtvhsixteen");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtvhsixteen")
        return vars.UpdateSplit("wtvhseventeen");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 8 && vars.lastSplit == "wtvhseventeen")
        return vars.UpdateSplit("wtvheighteen");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtvheighteen")
        return vars.UpdateSplit("wtvhnineteen");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtvhnineteen")
        return vars.UpdateSplit("wtvhtwenty");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtvhtwenty")
        return vars.UpdateSplit("wtvhtwentyOne");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wtvhtwentyOne")
        return vars.UpdateSplit("wtvhtwentyTwo");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wtvhtwentyTwo")
        return vars.UpdateSplit("wtvhtwentyThree");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 16 && vars.lastSplit == "wtvhtwentyThree")
        return vars.UpdateSplit("wtvhtwentyFour");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 14 && vars.lastSplit == "wtvhtwentyFour")
        return vars.UpdateSplit("wtvhtwentyFive");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 12 && vars.lastSplit == "wtvhtwentyFive")
        return vars.UpdateSplit("wtvhtwentySix");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 5 && vars.lastSplit == "wtvhtwentySix")
        return vars.UpdateSplit("wtvhtwentySeven");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtvhtwentySeven")
        return vars.UpdateSplit("wtvhtwentyEight");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtvhtwentyEight")
        return vars.UpdateSplit("wtvhtwentyNine");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 8 && vars.lastSplit == "wtvhtwentyNine")
        return vars.UpdateSplit("wtvhthirty");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 7 && vars.lastSplit == "wtvhthirty")
        return vars.UpdateSplit("wtvhthirtyOne");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 6 && vars.lastSplit == "wtvhthirtyOne")
        return vars.UpdateSplit("wtvhthirtyTwo");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 19 && vars.lastSplit == "wtvhthirtyTwo")
        return vars.UpdateSplit("wtvhthirtyThree");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 26 && vars.lastSplit == "wtvhthirtyThree")
        return vars.UpdateSplit("wtvhthirtyFour");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 25 && vars.lastSplit == "wtvhthirtyFour")
        return vars.UpdateSplit("wtvhthirtyFive");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 24 && vars.lastSplit == "wtvhthirtyFive")
        return vars.UpdateSplit("wtvhthirtySix");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 25 && vars.lastSplit == "wtvhthirtySix")
        return vars.UpdateSplit("wtvhthirtySeven");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 26 && vars.lastSplit == "wtvhthirtySeven")
        return vars.UpdateSplit("wtvhthirtyEight");

    if (current.diff == 3 && current.scenarioid == 40 && current.room == 27 && vars.lastSplit == "wtvhthirtyEight")
        return vars.UpdateSplit("wtvhthirtyNine");






    if (current.diff == 0 && current.scenarioid == 10 && current.room == 2 )
        return vars.UpdateSplit("ubeone");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubeone")
        return vars.UpdateSplit("ubetwo");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubetwo")
        return vars.UpdateSplit("ubethree");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 13 && vars.lastSplit == "ubethree")
        return vars.UpdateSplit("ubefour");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubefour")
        return vars.UpdateSplit("ubefive");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 11 && vars.lastSplit == "ubefive")
        return vars.UpdateSplit("ubesix");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubesix")
        return vars.UpdateSplit("ubeseven");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 15 && vars.lastSplit == "ubeseven")
        return vars.UpdateSplit("ubeeight");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubeeight")
        return vars.UpdateSplit("ubenine");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 25 && vars.lastSplit == "ubenine")
        return vars.UpdateSplit("ubeten");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubeten")
        return vars.UpdateSplit("ubeeleven");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 24 && vars.lastSplit == "ubeeleven")
        return vars.UpdateSplit("ubetwelve");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubetwelve")
        return vars.UpdateSplit("ubethirteen");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 15 && vars.lastSplit == "ubethirteen")
        return vars.UpdateSplit("ubefourteen");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubefourteen")
        return vars.UpdateSplit("ubefifteen");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 10 && vars.lastSplit == "ubefifteen")
        return vars.UpdateSplit("ubesixteen");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubesixteen")
        return vars.UpdateSplit("ubeseventeen");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubeseventeen")
        return vars.UpdateSplit("ubeeighteen");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubeeighteen")
        return vars.UpdateSplit("ubenineteen");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubenineteen")
        return vars.UpdateSplit("ubetwenty");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubetwenty")
        return vars.UpdateSplit("ubetwentyOne");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 9 && vars.lastSplit == "ubetwentyOne")
        return vars.UpdateSplit("ubetwentyTwo");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubetwentyTwo")
        return vars.UpdateSplit("ubetwentyThree");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubetwentyThree")
        return vars.UpdateSplit("ubetwentyFour");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubetwentyFour")
        return vars.UpdateSplit("ubetwentyFive");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 32 && vars.lastSplit == "ubetwentyFive")
        return vars.UpdateSplit("ubetwentySix");

    if (current.diff == 0 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubetwentySix")
        return vars.UpdateSplit("ubetwentySeven");






    if (current.diff == 1 && current.scenarioid == 10 && current.room == 17 )
        return vars.UpdateSplit("ubnone");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 18 && vars.lastSplit == "ubnone")
        return vars.UpdateSplit("ubntwo");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubntwo")
        return vars.UpdateSplit("ubnthree");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 13 && vars.lastSplit == "ubnthree")
        return vars.UpdateSplit("ubnfour");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubnfour")
        return vars.UpdateSplit("ubnfive");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 11 && vars.lastSplit == "ubnfive")
        return vars.UpdateSplit("ubnsix");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubnsix")
        return vars.UpdateSplit("ubnseven");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 15 && vars.lastSplit == "ubnseven")
        return vars.UpdateSplit("ubneight");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubneight")
        return vars.UpdateSplit("ubnnine");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 25 && vars.lastSplit == "ubnnine")
        return vars.UpdateSplit("ubnten");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubnten")
        return vars.UpdateSplit("ubneleven");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 24 && vars.lastSplit == "ubneleven")
        return vars.UpdateSplit("ubntwelve");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubntwelve")
        return vars.UpdateSplit("ubnthirteen");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 15 && vars.lastSplit == "ubnthirteen")
        return vars.UpdateSplit("ubnfourteen");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubnfourteen")
        return vars.UpdateSplit("ubnfifteen");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 10 && vars.lastSplit == "ubnfifteen")
        return vars.UpdateSplit("ubnsixteen");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubnsixteen")
        return vars.UpdateSplit("ubnseventeen");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubnseventeen")
        return vars.UpdateSplit("ubneighteen");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubneighteen")
        return vars.UpdateSplit("ubnnineteen");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubnnineteen")
        return vars.UpdateSplit("ubntwenty");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubntwenty")
        return vars.UpdateSplit("ubntwentyOne");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 9 && vars.lastSplit == "ubntwentyOne")
        return vars.UpdateSplit("ubntwentyTwo");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubntwentyTwo")
        return vars.UpdateSplit("ubntwentyThree");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubntwentyThree")
        return vars.UpdateSplit("ubntwentyFour");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubntwentyFour")
        return vars.UpdateSplit("ubntwentyFive");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 32 && vars.lastSplit == "ubntwentyFive")
        return vars.UpdateSplit("ubntwentySix");

    if (current.diff == 1 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubntwentySix")
        return vars.UpdateSplit("ubntwentySeven");







    if (current.diff == 2 && current.scenarioid == 10 && current.room == 2)
        return vars.UpdateSplit("ubhone");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubhone")
        return vars.UpdateSplit("ubhtwo");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubhtwo")
        return vars.UpdateSplit("ubhWest");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 32 && vars.lastSplit == "ubhWest")
        return vars.UpdateSplit("ubhPlat");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubhPlat")
        return vars.UpdateSplit("ubheTunn");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 18 && vars.lastSplit == "ubheTunn")
        return vars.UpdateSplit("ubhPBoom");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubhPBoom")
        return vars.UpdateSplit("ubhthree");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 13 && vars.lastSplit == "ubhthree")
        return vars.UpdateSplit("ubhfour");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubhfour")
        return vars.UpdateSplit("ubhfive");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 11 && vars.lastSplit == "ubhfive")
        return vars.UpdateSplit("ubhsix");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubhsix")
        return vars.UpdateSplit("ubhseven");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 15 && vars.lastSplit == "ubhseven")
        return vars.UpdateSplit("ubheight");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubheight")
        return vars.UpdateSplit("ubhnine");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 25 && vars.lastSplit == "ubhnine")
        return vars.UpdateSplit("ubhten");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubhten")
        return vars.UpdateSplit("ubheleven");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 24 && vars.lastSplit == "ubheleven")
        return vars.UpdateSplit("ubhtwelve");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubhtwelve")
        return vars.UpdateSplit("ubhthirteen");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 15 && vars.lastSplit == "ubhthirteen")
        return vars.UpdateSplit("ubhfourteen");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubhfourteen")
        return vars.UpdateSplit("ubhfifteen");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 10 && vars.lastSplit == "ubhfifteen")
        return vars.UpdateSplit("ubhsixteen");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubhsixteen")
        return vars.UpdateSplit("ubhseventeen");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubhseventeen")
        return vars.UpdateSplit("ubheighteen");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubheighteen")
        return vars.UpdateSplit("ubhnineteen");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubhnineteen")
        return vars.UpdateSplit("ubhtwenty");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubhtwenty")
        return vars.UpdateSplit("ubhtwentyOne");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 9 && vars.lastSplit == "ubhtwentyOne")
        return vars.UpdateSplit("ubhtwentyTwo");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubhtwentyTwo")
        return vars.UpdateSplit("ubhtwentyThree");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubhtwentyThree")
        return vars.UpdateSplit("ubhtwentyFour");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubhtwentyFour")
        return vars.UpdateSplit("ubhtwentyFive");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 32 && vars.lastSplit == "ubhtwentyFive")
        return vars.UpdateSplit("ubhtwentySix");

    if (current.diff == 2 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubhtwentySix")
        return vars.UpdateSplit("ubhtwentySeven");





    if (current.diff == 3 && current.scenarioid == 10 && current.room == 17)
        return vars.UpdateSplit("ubvhone");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 18 && vars.lastSplit == "ubvhone")
        return vars.UpdateSplit("ubvhtwo");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubvhtwo")
        return vars.UpdateSplit("ubvhWest");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 32 && vars.lastSplit == "ubvhWest")
        return vars.UpdateSplit("ubvhPlat");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubvhPlat")
        return vars.UpdateSplit("ubvheTunn");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 18 && vars.lastSplit == "ubvheTunn")
        return vars.UpdateSplit("ubvhPBoom");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubvhPBoom")
        return vars.UpdateSplit("ubvhthree");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 13 && vars.lastSplit == "ubvhthree")
        return vars.UpdateSplit("ubvhfour");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubvhfour")
        return vars.UpdateSplit("ubvhfive");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 11 && vars.lastSplit == "ubvhfive")
        return vars.UpdateSplit("ubvhsix");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubvhsix")
        return vars.UpdateSplit("ubvhseven");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 15 && vars.lastSplit == "ubvhseven")
        return vars.UpdateSplit("ubvheight");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubvheight")
        return vars.UpdateSplit("ubvhnine");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 25 && vars.lastSplit == "ubvhnine")
        return vars.UpdateSplit("ubvhten");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubvhten")
        return vars.UpdateSplit("ubvheleven");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 24 && vars.lastSplit == "ubvheleven")
        return vars.UpdateSplit("ubvhtwelve");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 22 && vars.lastSplit == "ubvhtwelve")
        return vars.UpdateSplit("ubvhthirteen");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 15 && vars.lastSplit == "ubvhthirteen")
        return vars.UpdateSplit("ubvhfourteen");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubvhfourteen")
        return vars.UpdateSplit("ubvhfifteen");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 10 && vars.lastSplit == "ubvhfifteen")
        return vars.UpdateSplit("ubvhsixteen");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubvhsixteen")
        return vars.UpdateSplit("ubvhseventeen");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubvhseventeen")
        return vars.UpdateSplit("ubvheighteen");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubvheighteen")
        return vars.UpdateSplit("ubvhnineteen");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubvhnineteen")
        return vars.UpdateSplit("ubvhtwenty");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubvhtwenty")
        return vars.UpdateSplit("ubvhtwentyOne");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 9 && vars.lastSplit == "ubvhtwentyOne")
        return vars.UpdateSplit("ubvhtwentyTwo");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 7 && vars.lastSplit == "ubvhtwentyTwo")
        return vars.UpdateSplit("ubvhtwentyThree");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 3 && vars.lastSplit == "ubvhtwentyThree")
        return vars.UpdateSplit("ubvhtwentyFour");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubvhtwentyFour")
        return vars.UpdateSplit("ubvhtwentyFive");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 32 && vars.lastSplit == "ubvhtwentyFive")
        return vars.UpdateSplit("ubvhtwentySix");

    if (current.diff == 3 && current.scenarioid == 10 && current.room == 31 && vars.lastSplit == "ubvhtwentySix")
        return vars.UpdateSplit("ubvhtwentySeven");





    if (current.diff == 0 && current.scenarioid == 26 && current.room == 1 )
        return vars.UpdateSplit("fbeone");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 3 && vars.lastSplit == "fbeone")
        return vars.UpdateSplit("fbetwo");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 4 && vars.lastSplit == "fbetwo")
        return vars.UpdateSplit("fbethree");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 5 && vars.lastSplit == "fbethree")
        return vars.UpdateSplit("fbefour");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbefour")
        return vars.UpdateSplit("fbefive");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbefive")
        return vars.UpdateSplit("fbesix");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbesix")
        return vars.UpdateSplit("fbeseven");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 14 && vars.lastSplit == "fbeseven")
        return vars.UpdateSplit("fbeeight");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbeeight")
        return vars.UpdateSplit("fbenine");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbenine")
        return vars.UpdateSplit("fbeten");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 11 && vars.lastSplit == "fbeten")
        return vars.UpdateSplit("fbeeleven");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 22 && vars.lastSplit == "fbeeleven")
        return vars.UpdateSplit("fbetwelve");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 24 && vars.lastSplit == "fbetwelve")
        return vars.UpdateSplit("fbethirteen");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 26 && vars.lastSplit == "fbethirteen")
        return vars.UpdateSplit("fbefourteen");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 27 && vars.lastSplit == "fbefourteen")
        return vars.UpdateSplit("fbefifteen");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 26 && vars.lastSplit == "fbefifteen")
        return vars.UpdateSplit("fbesixteen");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 24 && vars.lastSplit == "fbesixteen")
        return vars.UpdateSplit("fbeseventeen");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 22 && vars.lastSplit == "fbeseventeen")
        return vars.UpdateSplit("fbeeighteen");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 12 && vars.lastSplit == "fbeeighteen")
        return vars.UpdateSplit("fbenineteen");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbenineteen")
        return vars.UpdateSplit("fbetwenty");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 11 && vars.lastSplit == "fbetwenty")
        return vars.UpdateSplit("fbetwentyOne");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbetwentyOne")
        return vars.UpdateSplit("fbetwentyTwo");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbetwentyTwo")
        return vars.UpdateSplit("fbetwentyThree");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbetwentyThree")
        return vars.UpdateSplit("fbetwentyFour");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 21 && vars.lastSplit == "fbetwentyFour")
        return vars.UpdateSplit("fbetwentyFive");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 23 && vars.lastSplit == "fbetwentyFive")
        return vars.UpdateSplit("fbetwentySix");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 25 && vars.lastSplit == "fbetwentySix")
        return vars.UpdateSplit("fbetwentySeven");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 19 && vars.lastSplit == "fbetwentySeven")
        return vars.UpdateSplit("fbetwentyEight");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbetwentyEight")
        return vars.UpdateSplit("fbetwentyNine");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 20 && vars.lastSplit == "fbetwentyNine")
        return vars.UpdateSplit("fbethirty");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbethirty")
        return vars.UpdateSplit("fbethirtyOne");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbethirtyOne")
        return vars.UpdateSplit("fbethirtyTwo");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbethirtyTwo")
        return vars.UpdateSplit("fbethirtyThree");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbethirtyThree")
        return vars.UpdateSplit("fbethirtyFour");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 16 && vars.lastSplit == "fbethirtyFour")
        return vars.UpdateSplit("fbethirtyFive");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbethirtyFive")
        return vars.UpdateSplit("fbethirtySix");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbethirtySix")
        return vars.UpdateSplit("fbethirtySeven");

    if (current.diff == 0 && current.scenarioid == 26 && current.room == 12 && vars.lastSplit == "fbethirtySeven")
        return vars.UpdateSplit("fbethirtyEight");






    if (current.diff == 1 && current.scenarioid == 26 && current.room == 1 )
        return vars.UpdateSplit("fbnone");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 3 && vars.lastSplit == "fbnone")
        return vars.UpdateSplit("fbntwo");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 4 && vars.lastSplit == "fbntwo")
        return vars.UpdateSplit("fbnthree");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 5 && vars.lastSplit == "fbnthree")
        return vars.UpdateSplit("fbnfour");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbnfour")
        return vars.UpdateSplit("fbnfive");


    if (current.diff == 1 && current.scenarioid == 26 && current.room == 7 && vars.lastSplit == "fbnfive")
        return vars.UpdateSplit("fbnhallOne");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 8 && vars.lastSplit == "fbnhallOne")
        return vars.UpdateSplit("fbnrecep");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 7 && vars.lastSplit == "fbnrecep")
        return vars.UpdateSplit("fbnexam");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbnexam")
        return vars.UpdateSplit("fbnoffice");


    if (current.diff == 1 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbnoffice")
        return vars.UpdateSplit("fbnsix");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbnsix")
        return vars.UpdateSplit("fbnseven");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 14 && vars.lastSplit == "fbnseven")
        return vars.UpdateSplit("fbneight");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbneight")
        return vars.UpdateSplit("fbnnine");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbnnine")
        return vars.UpdateSplit("fbnten");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 11 && vars.lastSplit == "fbnten")
        return vars.UpdateSplit("fbneleven");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 22 && vars.lastSplit == "fbneleven")
        return vars.UpdateSplit("fbntwelve");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 24 && vars.lastSplit == "fbntwelve")
        return vars.UpdateSplit("fbnthirteen");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 26 && vars.lastSplit == "fbnthirteen")
        return vars.UpdateSplit("fbnfourteen");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 27 && vars.lastSplit == "fbnfourteen")
        return vars.UpdateSplit("fbnfifteen");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 26 && vars.lastSplit == "fbnfifteen")
        return vars.UpdateSplit("fbnsixteen");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 24 && vars.lastSplit == "fbnsixteen")
        return vars.UpdateSplit("fbnseventeen");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 22 && vars.lastSplit == "fbnseventeen")
        return vars.UpdateSplit("fbneighteen");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 12 && vars.lastSplit == "fbneighteen")
        return vars.UpdateSplit("fbnnineteen");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbnnineteen")
        return vars.UpdateSplit("fbntwenty");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 11 && vars.lastSplit == "fbntwenty")
        return vars.UpdateSplit("fbntwentyOne");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbntwentyOne")
        return vars.UpdateSplit("fbntwentyTwo");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbntwentyTwo")
        return vars.UpdateSplit("fbntwentyThree");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbntwentyThree")
        return vars.UpdateSplit("fbntwentyFour");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 21 && vars.lastSplit == "fbntwentyFour")
        return vars.UpdateSplit("fbntwentyFive");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 23 && vars.lastSplit == "fbntwentyFive")
        return vars.UpdateSplit("fbntwentySix");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 25 && vars.lastSplit == "fbntwentySix")
        return vars.UpdateSplit("fbntwentySeven");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 19 && vars.lastSplit == "fbntwentySeven")
        return vars.UpdateSplit("fbntwentyEight");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbntwentyEight")
        return vars.UpdateSplit("fbntwentyNine");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 20 && vars.lastSplit == "fbntwentyNine")
        return vars.UpdateSplit("fbnthirty");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbnthirty")
        return vars.UpdateSplit("fbnthirtyOne");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbnthirtyOne")
        return vars.UpdateSplit("fbnthirtyTwo");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbnthirtyTwo")
        return vars.UpdateSplit("fbnthirtyThree");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbnthirtyThree")
        return vars.UpdateSplit("fbnthirtyFour");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 16 && vars.lastSplit == "fbnthirtyFour")
        return vars.UpdateSplit("fbnthirtyFive");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbnthirtyFive")
        return vars.UpdateSplit("fbnthirtySix");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbnthirtySix")
        return vars.UpdateSplit("fbnthirtySeven");

    if (current.diff == 1 && current.scenarioid == 26 && current.room == 12 && vars.lastSplit == "fbnthirtySeven")
        return vars.UpdateSplit("fbnthirtyEight");






    if (current.diff == 2 && current.scenarioid == 26 && current.room == 1 )
        return vars.UpdateSplit("fbhone");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 3 && vars.lastSplit == "fbhone")
        return vars.UpdateSplit("fbhtwo");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 4 && vars.lastSplit == "fbhtwo")
        return vars.UpdateSplit("fbhthree");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 5 && vars.lastSplit == "fbhthree")
        return vars.UpdateSplit("fbhfour");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbhfour")
        return vars.UpdateSplit("fbhfive");


    if (current.diff == 2 && current.scenarioid == 26 && current.room == 7 && vars.lastSplit == "fbhfive")
        return vars.UpdateSplit("fbhhallOne");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 8 && vars.lastSplit == "fbhhallOne")
        return vars.UpdateSplit("fbhrecep");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 7 && vars.lastSplit == "fbhrecep")
        return vars.UpdateSplit("fbhexam");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbhexam")
        return vars.UpdateSplit("fbhoffice");


    if (current.diff == 2 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbhoffice")
        return vars.UpdateSplit("fbhsix");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbhsix")
        return vars.UpdateSplit("fbhseven");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 14 && vars.lastSplit == "fbhseven")
        return vars.UpdateSplit("fbheight");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbheight")
        return vars.UpdateSplit("fbhnine");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbhnine")
        return vars.UpdateSplit("fbhten");



    if (current.diff == 2 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbhten")
        return vars.UpdateSplit("fbheleven");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbheleven")
        return vars.UpdateSplit("fbhtwelve");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 20 && vars.lastSplit == "fbhtwelve")
        return vars.UpdateSplit("fbhthirteen");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbhthirteen")
        return vars.UpdateSplit("fbhfourteen");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 19 && vars.lastSplit == "fbhfourteen")
        return vars.UpdateSplit("fbhfifteen");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbhfifteen")
        return vars.UpdateSplit("fbhsixteen");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 21 && vars.lastSplit == "fbhsixteen")
        return vars.UpdateSplit("fbhseventeen");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 23 && vars.lastSplit == "fbhseventeen")
        return vars.UpdateSplit("fbheighteen");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 25 && vars.lastSplit == "fbheighteen")
        return vars.UpdateSplit("fbhnineteen");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 19 && vars.lastSplit == "fbhnineteen")
        return vars.UpdateSplit("fbhtwenty");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbhtwenty")
        return vars.UpdateSplit("fbhtwentyOne");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbhtwentyOne")
        return vars.UpdateSplit("fbhtwentyTwo");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbhtwentyTwo")
        return vars.UpdateSplit("fbhtwentyThree");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 11 && vars.lastSplit == "fbhtwentyThree")
        return vars.UpdateSplit("fbhtwentyFour");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 22 && vars.lastSplit == "fbhtwentyFour")
        return vars.UpdateSplit("fbhtwentyFive");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 24 && vars.lastSplit == "fbhtwentyFive")
        return vars.UpdateSplit("fbhtwentySix");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 26 && vars.lastSplit == "fbhtwentySix")
        return vars.UpdateSplit("fbhtwentySeven");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 27 && vars.lastSplit == "fbhtwentySeven")
        return vars.UpdateSplit("fbhtwentyEight");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 26 && vars.lastSplit == "fbhtwentyEight")
        return vars.UpdateSplit("fbhtwentyNine");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 24 && vars.lastSplit == "fbhtwentyNine")
        return vars.UpdateSplit("fbhthirty");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 22 && vars.lastSplit == "fbhthirty")
        return vars.UpdateSplit("fbhthirtyOne");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 12 && vars.lastSplit == "fbhthirtyOne")
        return vars.UpdateSplit("fbhthirtyTwo");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbhthirtyTwo")
        return vars.UpdateSplit("fbhthirtyThree");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 11 && vars.lastSplit == "fbhthirtyThree")
        return vars.UpdateSplit("fbhthirtyFour");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbhthirtyFour")
        return vars.UpdateSplit("fbhthirtyFive");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbhthirtyFive")
        return vars.UpdateSplit("fbhthirtySix");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 16 && vars.lastSplit == "fbhthirtySix")
        return vars.UpdateSplit("fbhthirtySeven");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbhthirtySeven")
        return vars.UpdateSplit("fbhthirtyEight");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbhthirtyEight")
        return vars.UpdateSplit("fbhthirtyNine");

    if (current.diff == 2 && current.scenarioid == 26 && current.room == 12 && vars.lastSplit == "fbhthirtyNine")
        return vars.UpdateSplit("fbhforty");






    if (current.diff == 3 && current.scenarioid == 26 && current.room == 1 )
        return vars.UpdateSplit("fbvhone");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 3 && vars.lastSplit == "fbvhone")
        return vars.UpdateSplit("fbvhtwo");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 4 && vars.lastSplit == "fbvhtwo")
        return vars.UpdateSplit("fbvhthree");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 5 && vars.lastSplit == "fbvhthree")
        return vars.UpdateSplit("fbvhfour");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbvhfour")
        return vars.UpdateSplit("fbvhfive");


    if (current.diff == 3 && current.scenarioid == 26 && current.room == 7 && vars.lastSplit == "fbvhfive")
        return vars.UpdateSplit("fbvhhallOne");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 8 && vars.lastSplit == "fbvhhallOne")
        return vars.UpdateSplit("fbvhrecep");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 7 && vars.lastSplit == "fbvhrecep")
        return vars.UpdateSplit("fbvhexam");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbvhexam")
        return vars.UpdateSplit("fbvhoffice");


    if (current.diff == 3 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbvhoffice")
        return vars.UpdateSplit("fbvhsix");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbvhsix")
        return vars.UpdateSplit("fbvhseven");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 14 && vars.lastSplit == "fbvhseven")
        return vars.UpdateSplit("fbvheight");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbvheight")
        return vars.UpdateSplit("fbvhnine");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbvhnine")
        return vars.UpdateSplit("fbvhten");



    if (current.diff == 3 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbvhten")
        return vars.UpdateSplit("fbvheleven");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbvheleven")
        return vars.UpdateSplit("fbvhtwelve");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 20 && vars.lastSplit == "fbvhtwelve")
        return vars.UpdateSplit("fbvhthirteen");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbvhthirteen")
        return vars.UpdateSplit("fbvhfourteen");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 19 && vars.lastSplit == "fbvhfourteen")
        return vars.UpdateSplit("fbvhfifteen");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbvhfifteen")
        return vars.UpdateSplit("fbvhsixteen");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 21 && vars.lastSplit == "fbvhsixteen")
        return vars.UpdateSplit("fbvhseventeen");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 23 && vars.lastSplit == "fbvhseventeen")
        return vars.UpdateSplit("fbvheighteen");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 25 && vars.lastSplit == "fbvheighteen")
        return vars.UpdateSplit("fbvhnineteen");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 19 && vars.lastSplit == "fbvhnineteen")
        return vars.UpdateSplit("fbvhtwenty");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 17 && vars.lastSplit == "fbvhtwenty")
        return vars.UpdateSplit("fbvhtwentyOne");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 6 && vars.lastSplit == "fbvhtwentyOne")
        return vars.UpdateSplit("fbvhtwentyTwo");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbvhtwentyTwo")
        return vars.UpdateSplit("fbvhtwentyThree");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 11 && vars.lastSplit == "fbvhtwentyThree")
        return vars.UpdateSplit("fbvhtwentyFour");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 22 && vars.lastSplit == "fbvhtwentyFour")
        return vars.UpdateSplit("fbvhtwentyFive");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 24 && vars.lastSplit == "fbvhtwentyFive")
        return vars.UpdateSplit("fbvhtwentySix");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 26 && vars.lastSplit == "fbvhtwentySix")
        return vars.UpdateSplit("fbvhtwentySeven");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 27 && vars.lastSplit == "fbvhtwentySeven")
        return vars.UpdateSplit("fbvhtwentyEight");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 26 && vars.lastSplit == "fbvhtwentyEight")
        return vars.UpdateSplit("fbvhtwentyNine");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 24 && vars.lastSplit == "fbvhtwentyNine")
        return vars.UpdateSplit("fbvhthirty");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 22 && vars.lastSplit == "fbvhthirty")
        return vars.UpdateSplit("fbvhthirtyOne");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 11 && vars.lastSplit == "fbvhthirtyOne")
        return vars.UpdateSplit("fbvhthirtyTwo");


    if (current.diff == 3 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbvhthirtyTwo")
        return vars.UpdateSplit("fbvhthirtyFive");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbvhthirtyFive")
        return vars.UpdateSplit("fbvhthirtySix");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 16 && vars.lastSplit == "fbvhthirtySix")
        return vars.UpdateSplit("fbvhthirtySeven");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 15 && vars.lastSplit == "fbvhthirtySeven")
        return vars.UpdateSplit("fbvhthirtyEight");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 9 && vars.lastSplit == "fbvhthirtyEight")
        return vars.UpdateSplit("fbvhthirtyNine");

    if (current.diff == 3 && current.scenarioid == 26 && current.room == 12 && vars.lastSplit == "fbvhthirtyNine")
        return vars.UpdateSplit("fbvhforty");





    if (current.diff == 0 && current.scenarioid == 15 && current.room == 2)
        return vars.UpdateSplit("dteone");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 1 && old.room == 2 && vars.lastSplit == "dteone")
        return vars.UpdateSplit("dtetwo");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dtetwo")
        return vars.UpdateSplit("dtethree");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dtethree")
        return vars.UpdateSplit("dtefour");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 6 && vars.lastSplit == "dtefour")
        return vars.UpdateSplit("dtefive");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 7 && vars.lastSplit == "dtefive")
        return vars.UpdateSplit("dtesix");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 27 && vars.lastSplit == "dtesix")
        return vars.UpdateSplit("dteseven");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 7 && vars.lastSplit == "dteseven")
        return vars.UpdateSplit("dteeight");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 6 && vars.lastSplit == "dteeight")
        return vars.UpdateSplit("dtenine");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dtenine")
        return vars.UpdateSplit("dteten");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 9 && vars.lastSplit == "dteten")
        return vars.UpdateSplit("dteeleven");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 11 && vars.lastSplit == "dteeleven")
        return vars.UpdateSplit("dtetwelve");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 16 && vars.lastSplit == "dtetwelve")
        return vars.UpdateSplit("dtethirteen");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 11 && vars.lastSplit == "dtethirteen")
        return vars.UpdateSplit("dtefourteen");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 13 && vars.lastSplit == "dtefourteen")
        return vars.UpdateSplit("dtefifteen");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dtefifteen")
        return vars.UpdateSplit("dtesixteen");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 18 && vars.lastSplit == "dtesixteen")
        return vars.UpdateSplit("dteseventeen");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dteseventeen")
        return vars.UpdateSplit("dteeighteen");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 13 && vars.lastSplit == "dteeighteen")
        return vars.UpdateSplit("dtenineteen");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dtenineteen")
        return vars.UpdateSplit("dtetwenty");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 1 && old.room == 3 && vars.lastSplit == "dtetwenty")
        return vars.UpdateSplit("dtetwentyOne");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 27 && vars.lastSplit == "dtetwentyOne")
        return vars.UpdateSplit("dtetwentyTwo");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 1 && old.room == 27 && vars.lastSplit == "dtetwentyTwo")
        return vars.UpdateSplit("dtetwentyThree");

    if (current.diff == 0 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dtetwentyThree")
        return vars.UpdateSplit("dtetwentyFour");







    if (current.diff == 1 && current.scenarioid == 15 && current.room == 6)
        return vars.UpdateSplit("dtnone");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 7 && vars.lastSplit == "dtnone")
        return vars.UpdateSplit("dtntwo");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 27 && vars.lastSplit == "dtntwo")
        return vars.UpdateSplit("dtnthree");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 7 && vars.lastSplit == "dtnthree")
        return vars.UpdateSplit("dtnfour");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 6 && vars.lastSplit == "dtnfour")
        return vars.UpdateSplit("dtnfive");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dtnfive")
        return vars.UpdateSplit("dtnsix");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 9 && vars.lastSplit == "dtnsix")
        return vars.UpdateSplit("dtnseven");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 11 && vars.lastSplit == "dtnseven")
        return vars.UpdateSplit("dtneight");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 16 && vars.lastSplit == "dtneight")
        return vars.UpdateSplit("dtnnine");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 11 && vars.lastSplit == "dtnnine")
        return vars.UpdateSplit("dtnten");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 13 && vars.lastSplit == "dtnten")
        return vars.UpdateSplit("dtneleven");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dtneleven")
        return vars.UpdateSplit("dtntwelve");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 18 && vars.lastSplit == "dtntwelve")
        return vars.UpdateSplit("dtnthirteen");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dtnthirteen")
        return vars.UpdateSplit("dtnfourteen");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 13 && vars.lastSplit == "dtnfourteen")
        return vars.UpdateSplit("dtnfifteen");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dtnfifteen")
        return vars.UpdateSplit("dtnsixteen");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dtnsixteen")
        return vars.UpdateSplit("dtnseventeen");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 2 && vars.lastSplit == "dtnseventeen")
        return vars.UpdateSplit("dtneighteen");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dtneighteen")
        return vars.UpdateSplit("dtnnineteen");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dtnnineteen")
        return vars.UpdateSplit("dtntwenty");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dtntwenty")
        return vars.UpdateSplit("dtntwentyOne");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dtntwentyOne")
        return vars.UpdateSplit("dtntwentyTwo");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 20 && vars.lastSplit == "dtntwentyTwo")
        return vars.UpdateSplit("dtntwentyThree");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 21 && vars.lastSplit == "dtntwentyThree")
        return vars.UpdateSplit("dtntwentyFour");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 20 && vars.lastSplit == "dtntwentyFour")
        return vars.UpdateSplit("dtntwentyFive");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dtntwentyFive")
        return vars.UpdateSplit("dtntwentySix");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dtntwentySix")
        return vars.UpdateSplit("dtntwentySeven");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 27 && vars.lastSplit == "dtntwentySeven")
        return vars.UpdateSplit("dtntwentyEight");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dtntwentyEight")
        return vars.UpdateSplit("dtntwentyNine");

    if (current.diff == 1 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dtntwentyNine")
        return vars.UpdateSplit("dtnthirty");






    if (current.diff == 2 && current.scenarioid == 15 && current.room == 11)
        return vars.UpdateSplit("dthone");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 12 && vars.lastSplit == "dthone")
        return vars.UpdateSplit("dthtwo");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 11 && old.room == 12 && vars.lastSplit == "dthtwo")
        return vars.UpdateSplit("dththree");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 13 && old.room == 11 && vars.lastSplit == "dththree")
        return vars.UpdateSplit("dthfour");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dthfour")
        return vars.UpdateSplit("dthfive");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dthfive")
        return vars.UpdateSplit("dthsix");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 2 && vars.lastSplit == "dthsix")
        return vars.UpdateSplit("dthseven");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dthseven")
        return vars.UpdateSplit("dtheight");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dtheight")
        return vars.UpdateSplit("dthnine");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 20 && vars.lastSplit == "dthnine")
        return vars.UpdateSplit("dthten");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 21 && vars.lastSplit == "dthten")
        return vars.UpdateSplit("dtheleven");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 20 && vars.lastSplit == "dtheleven")
        return vars.UpdateSplit("dthtwelve");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dthtwelve")
        return vars.UpdateSplit("dththirteen");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dththirteen")
        return vars.UpdateSplit("dthfourteen");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 6 && vars.lastSplit == "dthfourteen")
        return vars.UpdateSplit("dthfifteen");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 7 && vars.lastSplit == "dthfifteen")
        return vars.UpdateSplit("dthsixteen");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 27 && vars.lastSplit == "dthsixteen")
        return vars.UpdateSplit("dthseventeen");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 7 && vars.lastSplit == "dthseventeen")
        return vars.UpdateSplit("dtheighteen");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 6 && vars.lastSplit == "dtheighteen")
        return vars.UpdateSplit("dthnineteen");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dthnineteen")
        return vars.UpdateSplit("dthtwenty");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 9 && vars.lastSplit == "dthtwenty")
        return vars.UpdateSplit("dthtwentyOne");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 10 && vars.lastSplit == "dthtwentyOne")
        return vars.UpdateSplit("dthtwentyTwo");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 9 && vars.lastSplit == "dthtwentyTwo")
        return vars.UpdateSplit("dthtwentyThree");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 11 && old.room == 9 && vars.lastSplit == "dthtwentyThree")
        return vars.UpdateSplit("dthtwentyFour");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 13 && old.room == 11 && vars.lastSplit == "dthtwentyFour")
        return vars.UpdateSplit("dthtwentyFive");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dthtwentyFive")
        return vars.UpdateSplit("dthtwentySix");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 15 && vars.lastSplit == "dthtwentySix")
        return vars.UpdateSplit("dthtwentySeven");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dthtwentySeven")
        return vars.UpdateSplit("dthtwentyEight");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 18 && vars.lastSplit == "dthtwentyEight")
        return vars.UpdateSplit("dthtwentyNine");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dthtwentyNine")
        return vars.UpdateSplit("dththirty");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 13 && old.room == 14 && vars.lastSplit == "dththirty")
        return vars.UpdateSplit("dththirtyOne");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dththirtyOne")
        return vars.UpdateSplit("dththirtyTwo");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dththirtyTwo")
        return vars.UpdateSplit("dththirtyThree");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 27 && vars.lastSplit == "dththirtyThree")
        return vars.UpdateSplit("dththirtyFour");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dththirtyFour")
        return vars.UpdateSplit("dththirtyFive");

    if (current.diff == 2 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dththirtyFive")
        return vars.UpdateSplit("dththirtySix");





    if (current.diff == 3 && current.scenarioid == 15 && current.room == 7)
        return vars.UpdateSplit("dtvhone");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 6 && vars.lastSplit == "dtvhone")
        return vars.UpdateSplit("dtvhtwo");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dtvhtwo")
        return vars.UpdateSplit("dtvhthree");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 9 && vars.lastSplit == "dtvhthree")
        return vars.UpdateSplit("dtvhfour");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 10 && vars.lastSplit == "dtvhfour")
        return vars.UpdateSplit("dtvhfive");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 9 && vars.lastSplit == "dtvhfive")
        return vars.UpdateSplit("dtvhsix");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dtvhsix")
        return vars.UpdateSplit("dtvhseven");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dtvhseven")
        return vars.UpdateSplit("dtvheight");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 20 && vars.lastSplit == "dtvheight")
        return vars.UpdateSplit("dtvhnine");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 21 && vars.lastSplit == "dtvhnine")
        return vars.UpdateSplit("dtvhten");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 20 && vars.lastSplit == "dtvhten")
        return vars.UpdateSplit("dtvheleven");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dtvheleven")
        return vars.UpdateSplit("dtvhtwelve");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dtvhtwelve")
        return vars.UpdateSplit("dtvhthirteen");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 2 && vars.lastSplit == "dtvhthirteen")
        return vars.UpdateSplit("dtvhfourteen");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dtvhfourteen")
        return vars.UpdateSplit("dtvhfifteen");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 27 && old.room == 1 && vars.lastSplit == "dtvhfifteen")
        return vars.UpdateSplit("dtvhsixteen");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dtvhsixteen")
        return vars.UpdateSplit("dtvhseventeen");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 4 && vars.lastSplit == "dtvhseventeen")
        return vars.UpdateSplit("dtvheighteen");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dtvheighteen")
        return vars.UpdateSplit("dtvhnineteen");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 6 && vars.lastSplit == "dtvhnineteen")
        return vars.UpdateSplit("dtvhtwenty");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 7 && vars.lastSplit == "dtvhtwenty")
        return vars.UpdateSplit("dtvhtwentyOne");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 27 && old.room == 7 && vars.lastSplit == "dtvhtwentyOne")
        return vars.UpdateSplit("dtvhtwentyTwo");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 7 && vars.lastSplit == "dtvhtwentyTwo")
        return vars.UpdateSplit("dtvhtwentyThree");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 6 && vars.lastSplit == "dtvhtwentyThree")
        return vars.UpdateSplit("dtvhtwentyFour");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 5 && vars.lastSplit == "dtvhtwentyFour")
        return vars.UpdateSplit("dtvhtwentyFive");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 9 && vars.lastSplit == "dtvhtwentyFive")
        return vars.UpdateSplit("dtvhtwentySix");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 11 && vars.lastSplit == "dtvhtwentySix")
        return vars.UpdateSplit("dtvhtwentySeven");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 12 && vars.lastSplit == "dtvhtwentySeven")
        return vars.UpdateSplit("dtvhtwentyEight");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 11 && vars.lastSplit == "dtvhtwentyEight")
        return vars.UpdateSplit("dtvhtwentyNine");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 13 && vars.lastSplit == "dtvhtwentyNine")
        return vars.UpdateSplit("dtvhthirty");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dtvhthirty")
        return vars.UpdateSplit("dtvhthirtyOne");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 15 && vars.lastSplit == "dtvhthirtyOne")
        return vars.UpdateSplit("dtvhthirtyTwo");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dtvhthirtyTwo")
        return vars.UpdateSplit("dtvhthirtyThree");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 18 && vars.lastSplit == "dtvhthirtyThree")
        return vars.UpdateSplit("dtvhthirtyFour");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 14 && vars.lastSplit == "dtvhthirtyFour")
        return vars.UpdateSplit("dtvhthirtyFive");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 13 && vars.lastSplit == "dtvhthirtyFive")
        return vars.UpdateSplit("dtvhthirtySix");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dtvhthirtySix")
        return vars.UpdateSplit("dtvhthirtySeven");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 1 && vars.lastSplit == "dtvhthirtySeven")
        return vars.UpdateSplit("dtvhthirtyEight");

    if (current.diff == 3 && current.scenarioid == 15 && current.room == 3 && vars.lastSplit == "dtvhthirtyEight")
        return vars.UpdateSplit("dtvhthirtyNine");






    if (current.scenarioid == 6 && current.room == 2 && old.room == 1)
        return vars.UpdateSplit("etrone");

    if (current.scenarioid == 6 && current.room == 12 && vars.lastSplit == "etrone")
        return vars.UpdateSplit("etrtwo");

    if (current.scenarioid == 6 && current.room == 11 && vars.lastSplit == "etrtwo")
        return vars.UpdateSplit("etrthree");

    if (current.scenarioid == 6 && current.room == 12 && vars.lastSplit == "etrthree")
        return vars.UpdateSplit("etrfour");

    if (current.scenarioid == 6 && current.room == 2 && old.room == 12 && vars.lastSplit == "etrfour")
        return vars.UpdateSplit("etrfive");

    if (current.scenarioid == 6 && current.room == 1 && old.room == 2 && vars.lastSplit == "etrfive")
        return vars.UpdateSplit("etrsix");

    if (current.scenarioid == 6 && current.room == 7 && vars.lastSplit == "etrsix")
        return vars.UpdateSplit("etrseven");

    if (current.scenarioid == 6 && current.room == 3 && vars.lastSplit == "etrseven")
        return vars.UpdateSplit("etreight");

    if (current.scenarioid == 6 && current.room == 4 && vars.lastSplit == "etreight")
        return vars.UpdateSplit("etrnine");

    if (current.scenarioid == 6 && current.room == 6 && vars.lastSplit == "etrnine")
        return vars.UpdateSplit("etrten");

    if (current.scenarioid == 6 && current.room == 4 && vars.lastSplit == "etrten")
        return vars.UpdateSplit("etreleven");

    if (current.scenarioid == 6 && current.room == 3 && vars.lastSplit == "etreleven")
        return vars.UpdateSplit("etrtwelve");

    if (current.scenarioid == 6 && current.room == 6 && vars.lastSplit == "etrtwelve")
        return vars.UpdateSplit("etrthirteen");

    if (current.scenarioid == 6 && current.room == 5 && vars.lastSplit == "etrthirteen")
        return vars.UpdateSplit("etrfourteen");

    if (current.scenarioid == 6 && current.room == 3 && vars.lastSplit == "etrfourteen")
        return vars.UpdateSplit("etrfifteen");

    if (current.scenarioid == 6 && current.room == 2 && vars.lastSplit == "etrfifteen")
        return vars.UpdateSplit("etrsixteen");

    if (current.scenarioid == 6 && current.room == 8 && vars.lastSplit == "etrsixteen")
        return vars.UpdateSplit("etrseventeen");

    if (current.scenarioid == 6 && current.room == 9 && vars.lastSplit == "etrseventeen")
        return vars.UpdateSplit("etreighteen");

    if (current.scenarioid == 6 && current.room == 10 && vars.lastSplit == "etreighteen")
        return vars.UpdateSplit("etrnineteen");

    if (current.scenarioid == 6 && current.room == 14 && vars.lastSplit == "etrnineteen")
        return vars.UpdateSplit("etrtwenty");

    if (current.scenarioid == 6 && current.room == 2 && vars.lastSplit == "etrtwenty")
        return vars.UpdateSplit("etrtwentyOne");

    if (current.scenarioid == 6 && current.room == 13 && vars.lastSplit == "etrtwentyOne")
        return vars.UpdateSplit("etrtwentyTwo");

    if (current.scenarioid == 6 && current.room == 2 && vars.lastSplit == "etrtwentyTwo")
        return vars.UpdateSplit("etrtwentyThree");

    if (current.scenarioid == 6 && current.room == 14 && vars.lastSplit == "etrtwentyThree")
        return vars.UpdateSplit("etrtwentyFour");

    if (current.scenarioid == 6 && current.room == 10 && vars.lastSplit == "etrtwentyFour")
        return vars.UpdateSplit("etrtwentyFive");

    if (current.scenarioid == 6 && current.room == 9 && vars.lastSplit == "etrtwentyFive")
        return vars.UpdateSplit("etrtwentySix");

    if (current.scenarioid == 6 && current.room == 8 && vars.lastSplit == "etrtwentySix")
        return vars.UpdateSplit("etrtwentySeven");

    if (current.scenarioid == 6 && current.room == 2 && vars.lastSplit == "etrtwentySeven")
        return vars.UpdateSplit("etrtwentyEight");

    if (current.scenarioid == 6 && current.room == 12 && vars.lastSplit == "etrtwentyEight")
        return vars.UpdateSplit("etrtwentyNine");

    if (current.scenarioid == 6 && current.room == 16 && vars.lastSplit == "etrtwentyNine")
        return vars.UpdateSplit("etrthirty");

    if (current.scenarioid == 6 && current.room == 17 && vars.lastSplit == "etrthirty")
        return vars.UpdateSplit("etrthirtyOne");

    if (current.scenarioid == 6 && current.room == 19 && vars.lastSplit == "etrthirtyOne" | vars.lastSplit == "etrheExit")
        return vars.UpdateSplit("etrthirtyTwo");

    if (current.scenarioid == 6 && current.room == 17 && vars.lastSplit == "etrthirtyTwo")
        return vars.UpdateSplit("etrthirtyThree");

    if (current.scenarioid == 6 && current.room == 16 && vars.lastSplit == "etrthirtyThree")
        return vars.UpdateSplit("etrthirtyFour");

    if (current.scenarioid == 6 && current.room == 15 && vars.lastSplit == "etrthirtyFour")
        return vars.UpdateSplit("etrthirtyFive");

    if (current.scenarioid == 6 && current.room == 12 && vars.lastSplit == "etrthirtyFive")
        return vars.UpdateSplit("etrthirtySix");

    if (current.scenarioid == 6 && current.room == 20 && vars.lastSplit == "etrthirtySix")
        return vars.UpdateSplit("etrthirtySeven");

    if (current.scenarioid == 6 && current.room == 30 && vars.lastSplit == "etrthirtySeven") //Underground Waterworks 1
        return vars.UpdateSplit("etrthirtyEight");

    if (current.scenarioid == 6 && current.room == 32 && vars.lastSplit == "etrthirtyEight")
        return vars.UpdateSplit("etrthirtyNine");

    if (current.scenarioid == 6 && current.room == 31 && vars.lastSplit == "etrthirtyNine")
        return vars.UpdateSplit("etrforty");

    if (current.scenarioid == 6 && current.room == 30 && vars.lastSplit == "etrforty")
        return vars.UpdateSplit("etrfortyOne");

    if (current.scenarioid == 6 && current.room == 29 && vars.lastSplit == "etrfortyOne")
        return vars.UpdateSplit("etrfortyTwo");

    if (current.scenarioid == 6 && current.room == 45 && vars.lastSplit == "etrfortyTwo")
        return vars.UpdateSplit("etrfortyThree");

    if (current.scenarioid == 6 && current.room == 46 && vars.lastSplit == "etrfortyThree")
        return vars.UpdateSplit("etrfortyFour");

    if (current.scenarioid == 6 && current.room == 48 && vars.lastSplit == "etrfortyFour")
        return vars.UpdateSplit("etrfortyFive");

    if (current.scenarioid == 6 && current.room == 32 && vars.lastSplit == "etrfortyFive")
        return vars.UpdateSplit("etrfortySix");

    if (current.scenarioid == 6 && current.room == 52 && vars.lastSplit == "etrfortySix")
        return vars.UpdateSplit("etrfortySeven");

    if (current.scenarioid == 6 && current.room == 53 && vars.lastSplit == "etrfortySeven")
        return vars.UpdateSplit("etrfortyEight");

    if (current.scenarioid == 6 && current.room == 58 && vars.lastSplit == "etrfortyEight")
        return vars.UpdateSplit("etrfortyNine");

    if (current.scenarioid == 6 && current.room == 59 && vars.lastSplit == "etrfortyNine")
        return vars.UpdateSplit("etrfifty");

    if (current.scenarioid == 6 && current.room == 61 && vars.lastSplit == "etrfifty")
        return vars.UpdateSplit("etrfiftyOne");

    if (current.scenarioid == 6 && current.room == 61 && current.screen == 0x04) // Office Cutscene
        return vars.UpdateSplit("etroffice");




    if (current.scenarioid == 6 && current.diff == 2 && current.room == 18 && vars.lastSplit == "etrthirtyOne")
        return vars.UpdateSplit("etrhnursery");

    if (current.scenarioid == 6 && current.diff == 2 && current.room == 17 && vars.lastSplit == "etrhnursery")
        return vars.UpdateSplit("etrheExit");

























    if (current.screen >= 0x0C) // End Game Rank Screen
        return vars.UpdateSplit("endGame");
}

reset
{
    if (current.room == 0 && current.time == 0)
    {
        return true;
    }
}

gameTime
{
    // Seconds = IGT / 60
    return TimeSpan.FromSeconds(current.time / 0.03 / 1000);
}

isLoading
{
    return true;
}